#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "kernel.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "gtemac.h"
#include "inline_c.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "screen.h"
#include "sound.h"
#include "cd.h"
#include "main.h"
#include "pads.h"
#include "skeleton.h"
#include "movie.h"
#include "frontend.h"

#define O_CREAT 512
#define O_RDONLY 1

long fepadread,fepadread2;
long fepaddeb;
long feexit;
TIM_IMAGE	fetimheader;
TIM_IMAGE	pistetimheader;
uint16	pistetpage;
uint16  pisteclut;
uint16	fetpage1;
uint16  feclut1;
uint16	flagtpage;
uint16  flagclut;
uint16	chartpage;
POLY_FT4 mapsprite[2];
POLY_FT4 textsprite[2];
POLY_FT4 lboardsprite[2];
POLY_FT4 rboardsprite[2];
POLY_FT4 pistepoly[2];
POLY_FT4 uparrow[2];
POLY_FT4 downarrow[2];
POLY_FT4 xbutton[2];
POLY_FT4 tbutton[2];
POLY_FT4 seltext[2];
POLY_FT4 backtext[2];
POLY_FT4 lasttpolys[2];
POLY_FT4 lastspolys[2];
POLY_FT4 loadpolys[2];
POLY_F4	pisteclear[2];
uint8	loadinggame;
char *timestring;
char timechars[13];
long restimeout;

uint16	mapposx=251;
uint16	mapposy=104;
//RECT	imarea[2]={ {0,240,320,240 },{0,0,320,240 } };

/* new frontend stuff */

RECT	imarea[2]={ {0,0,320,240 },{0,240,320,240 } };
RECT 	imbox[2]={ {168,26,136,104 },{168,266,136,104 } };
uint16	reftpage;
uint16	refclut;
uint16	prelangtpage;
uint16	prelangclut;
uint16	langtpage;
uint16	langclut;
uint16	lang2tpage;
uint16	lang2clut;
uint16	lang3tpage;
uint16	lang3clut;
uint16	cardtpage;
uint16	cardclut;
POLY_FT4 refsprite[2];
uint8	logoson;
TIM_IMAGE	boxtims;
TIM_IMAGE	reftims;
TIM_IMAGE	gentimheader;
POLY_FT4 menuboxes[2][5];
POLY_FT4 menutext[2][5];
POLY_FT4 blackbox[2];
POLY_FT4 blackboxtext[2];
POLY_GT4 barpolys[2][30];
POLY_FT4 fenamepolys[2][3];
POLY_FT4 outnopoly[2];
POLY_FT4 name1polys[2][3];
POLY_FT4 name2polys[2][3];
POLY_FT4 tracknopolys[2];
POLY_FT4 besttpolys[2];
POLY_FT4 bestspolys[2];
POLY_FT4 padtext1[2];
POLY_FT4 padtext2[2];
POLY_FT4 cardpolys[2][5][3];
POLY_G4	fadepoly[2][8];
char	boardnames[21][13] = { {'S','U','P','E','R','5','1','.','T','I','M', 0 , 0 },
							   {'S','U','P','E','R','5','6','.','T','I','M', 0 , 0 },
							   {'S','U','P','E','R','6','2','.','T','I','M', 0 , 0 },
							   {'S','U','P','E','R','6','8','.','T','I','M', 0 , 0 },
							   {'S','U','P','E','R','7','4','.','T','I','M', 0 , 0 },
							   {'S','U','P','E','R','8','1','.','T','I','M', 0 , 0 },
							   {'C','U','S','T','O','M','4','4','.','T','I','M', 0 },
							   {'C','U','S','T','O','M','4','8','.','T','I','M', 0 },
							   {'C','U','S','T','O','M','5','2','.','T','I','M', 0 },
							   {'C','U','S','T','O','M','5','5','.','T','I','M', 0 },
							   {'C','U','S','T','O','M','5','9','.','T','I','M', 0 },
							   {'C','U','S','T','O','M','6','4','.','T','I','M', 0 },
							   {'T','W','I','N','S','4','2','.','T','I','M', 0 , 0 },
							   {'T','W','I','N','S','4','7','.','T','I','M', 0 , 0 },
							   {'T','W','I','N','S','5','3','.','T','I','M', 0 , 0 },
							   {'T','W','I','N','S','5','7','.','T','I','M', 0 , 0 },
							   {'A','L','P','4','5','.','T','I','M', 0 , 0 , 0 , 0 },
							   {'A','L','P','5','1','.','T','I','M', 0 , 0 , 0 , 0 },
							   {'A','L','P','5','7','.','T','I','M', 0 , 0 , 0 , 0 },
							   {'A','L','P','6','4','.','T','I','M', 0 , 0 , 0 , 0 },
							   {'A','L','P','7','1','.','T','I','M', 0 , 0 , 0 , 0 } };
char 	fullboardfilename[50];
uint8	boardtextuvs[21][2]= { {5,18},{26,39},{50,63},{74,87},{96,109},{119,132},{142,155},
							   {164,177},{189,202},{211,224},{235,248},{5,18},{27,40},{49,62},
							   {73,86},{96,109},{119,132},{143,156},{164,177},{189,202},{212,225} };
SVECTOR sbverts[8] = { {-22,100,0,0},{22,100,0,0},{-22,-100,0,0},{22,-100,0,0},
					   {22,200,0,0},{-22,200,0,0},{22,0,0,0},{-22,0,0,0} };
long	feouter;

POLY_FT4 leftbpoly[2];
POLY_FT4 rightbpoly[2];
POLY_FT4 boardnamepoly[2];
uint8	loadboard;
uint16 	boardtpage;
uint16	boardclut;
uint16	boardnametpage;
uint16	boardnameclut;
MATRIX	btransmatrix;
MATRIX	brotmatrix;
MATRIX  bvertrotmatrix;
VECTOR	bvertrotvec;
VECTOR  brotvec;
char memcardtext[33];
char savebuf[1024];
char *storekanji;
uint8	tempwrite;
uint8	cardstatus;
uint8	fadevalue=10;
DR_LOAD *imagetrans;
uint8	fadestatus;
uint8	stgamestate;
uint8	cstartfile;
uint8	cendfile;
uint8	whichcardfile;
uint8	cardwaitcnt;
uint8	cardyesno;

static unsigned short ascii_table[3][2] = {
	{0x824f, 0x30},	/* 0-9  */
	{0x8260, 0x41},	/* A-Z  */
	{0x8281, 0x61},	/* a-z  */
};

/*
 * ASCII code to Shift-JIS code transfer table (kigou)
 */
static unsigned short ascii_k_table[] = {
	0x8140,		/*   */
	0x8149,		/* ! */
	0x8168,		/* " */
	0x8194,		/* # */
	0x8190,		/* $ */
	0x8193,		/* % */
	0x8195,		/* & */
	0x8166,		/* ' */
	0x8169,		/* ( */
	0x816a,		/* ) */
	0x8196,		/* * */
	0x817b,		/* + */
	0x8143,		/* , */
	0x817c,		/* - */
	0x8144,		/* . */
	0x815e,		/* / */
	0x8146,		/* : */
	0x8147,		/* ; */
	0x8171,		/* < */
	0x8181,		/* = */
	0x8172,		/* > */
	0x8148,		/* ? */
	0x8197,		/* @ */
	0x816d,		/* [ */
	0x818f,		/* \ */
	0x816e,		/* ] */
	0x814f,		/* ^ */
	0x8151,		/* _ */
	0x8165,		/* ` */
	0x816f,		/* { */
	0x8162,		/* | */
	0x8170,		/* } */
	0x8150,		/* ~ */
};

/*
 * ASCII code to Shift-JIS code transfer function
  */
char delname[22];

uint8	 tracksavailable;
uint8 	 thistrack;
uint8	 chartemp;
uint8	 whichcharacter;
uint8	 flashvalue;
int8     flashcount;
uint8	 thisvol;
uint8	 textboxeson;
uint8	 blackboxon;
savegame currentsave;
uint8	 chosenchar[2];
uint8	 boardno[2];
uint8	 outfitno[2];
uint8	 twoplayer;
uint8	 whichplayer;

long	exitcount=0;
long	fefilesize;
long	fefin;
uint8	*fetexture;
long	starttrack;
long	firsttime=0;
uint8	fegamestate=1;
uint8	backgroundloaded;
uint8	menuoption;
uint8	nomenuopts;
long	FeOT[2][16];
long	*feottr;

int16	pistewinx;
int16	pistewiny;

uint8	thisfeload[10];
uint8	nofeobjs;
uint8	feobjsloaded;
long	fenumverts;
long	fenumpolys;
SVECTOR	*fevertexptr;
objpolygon	*fepolyptr;
uint32	feprimaddr;
CVECTOR	fecol1,fecol2,fecol3,fecol4,febasecolour;
POLY_G3	*g3ptr;
POLY_G4	*g4ptr;
POLY_FT4 *ft4ptr;
POLY_FT3 *ft3ptr;
MATRIX	fewheelrot1,fewheelrot2,fewheelrot3,fewheeltrans;
trackobject	wheelobjs[10];
uint16	fecnt1,fecnt2;
uint8	feobjecttype;
SVECTOR	fevector;
int32	shit=800;
uint8	febounce;
int32	fez,fed;
uint8	wheelmove;
uint8	maptransport;
uint8	language=0;
uint8	whichboard=0;
uint8	whichchar=0;
uint8	udarrowson=0;
uint8	arrowcycle=0;
uint8	arrowadjust;
//					     st et   startpos        roty  es cp sp mt   textures
area	Mountain[15]={  { 0, 9, { 1619,0,896 }, -800, 0, 0, 0, 0, { 10, 11, 12, 13, 14, 15, 6 } },
					   	{ 44, 51, {1140,0,1692 },0, 0, 0, 0, 0, { 16, 17, 18, 19, 20, 21, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 52,72,{ 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 10,17, { 210,0,470 },   	0, 0, 0, 0, 0, { 10, 11, 12, 13, 14, 15, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } },
						{ 0, 9, { 210,0,470 },   	0, 0, 0, 0, 0, { 0, 1, 2, 3, 4, 9, 6 } } };

uint8	thismount=1;
uint8	thischallenge=2;
uint32	ev0,ev1,ev2,ev3,ev10,ev11,ev12,ev13;
struct DIRENTRY memfiles[15],newname;
long	ret,fd;
char 	buf[128];
uint16	selectrot=0;
uint8	whichcard=0;
uint8	musicvolume=3;
uint8	selbackon;
uint32	besttime=2693376;
uint32  bestscore=5000;
DR_TPAGE transcontrol[2][8];	/* primitives to turn transparency on/off on sub ot */
uint16	transtpage1;
uint16	transtpage2;
uint8	nocardfiles;
uint8	cardscrstatus;

int32	fuckwank=-100;
POLY_FT4 charsprites[4][3];


char tempnames[8][4] =  { { 'J','E','B',0 },
				 { 'J','E','Z',0 },
				 { 'P','J','G',0 },
				 { 'C','O','O',0 },
				 { 'L','B','O',0 },
				 { 'A','R','D',0 },
				 { 'E','R','S',0 },
				 { 'T','W','O',0 }  };

#ifdef CD
CdlFILE	Texturenames[30];
#else
char Texturenames[30][50];
#endif

#ifdef CD
CdlFILE	objectnames[15][2];
#else
char objectnames[15][2][50];
#endif



int
ascii2sjis(unsigned char ascii_code)
{
	int sjis_code = 0;
	unsigned char stmp;
	unsigned char stmp2 = 0;

	if ((ascii_code >= 0x20) && (ascii_code <= 0x2f))
		stmp2 = 1;
	else
	if ((ascii_code >= 0x30) && (ascii_code <= 0x39))
		stmp = 0;
	else
	if ((ascii_code >= 0x3a) && (ascii_code <= 0x40))
		stmp2 = 11;
	else
	if ((ascii_code >= 0x41) && (ascii_code <= 0x5a))
		stmp = 1;
	else
	if ((ascii_code >= 0x5b) && (ascii_code <= 0x60))
		stmp2 = 37;
	else
	if ((ascii_code >= 0x61) && (ascii_code <= 0x7a))
		stmp = 2;
	else
	if ((ascii_code >= 0x7b) && (ascii_code <= 0x7e))
		stmp2 = 63;
	else {
		printf("bad ASCII code 0x%x\n", ascii_code);
		return(0);
	}

	if (stmp2)
		sjis_code = ascii_k_table[ascii_code - 0x20 - (stmp2 - 1)];
	else
		sjis_code = ascii_table[stmp][0] + ascii_code - ascii_table[stmp][1];

	return(sjis_code);
}


void initialisesavegame(void)
{
	uint8	i,j;

	currentsave.options[SFX_VOLUME]=15;
	currentsave.options[MUSIC_VOLUME]=15;
	currentsave.options[STEREO_SET]=1;
	currentsave.options[DOLBY_SET]=1;
	currentsave.options[CONTROLLER_OPT1]=0;
	currentsave.options[CONTROLLER_OPT2]=0;
	currentsave.options[PAD_TYPE1]=Pad_Type(0)-1;
	currentsave.options[PAD_TYPE2]=Pad_Type(1)-1;
	currentsave.options[SPLIT_SET]=0;
	currentsave.options[GHOST_SET]=0;
	currentsave.options[YETI_FOUND]=0;
	currentsave.options[TRACK6_FOUND]=0;
	currentsave.options[TRACK7_FOUND]=0;
	for (i=0;i<7;i++)
	{
		for (j=0;j<MAX_RECORDS;j++)
		{
			currentsave.records[i][j].score=20000-(i*2500);
			sprintf(&currentsave.records[i][j].sname,"%s",&tempnames[i][0]);
			currentsave.records[i][j].time=2693376+(i*10000);
			sprintf(&currentsave.records[i][j].tname,"%s",&tempnames[i+1][0]);
		}
	}
}


_card_event()
{
        while(1) {
		if(TestEvent(ev0)==1) {         /* IOE */
                        return 0;
                }
                if(TestEvent(ev1)==1) {         /* ERROR */
                        return 1;
                }
                if(TestEvent(ev2)==1) {         /* TIMEOUT */
                        return 2;
                }
                if(TestEvent(ev3)==1) {         /* NEW CARD */
                        return 3;
                }
        }
}


_clear_event()
{
	TestEvent(ev0);
	TestEvent(ev1);
	TestEvent(ev2);
	TestEvent(ev3);
}


_card_event_x()
{
        while(1) {
		if(TestEvent(ev10)==1) {         /* IOE */
                        return 0;
                }
                if(TestEvent(ev11)==1) {         /* ERROR */
                        return 1;
                }
                if(TestEvent(ev12)==1) {         /* TIMEOUT */
                        return 2;
                }
                if(TestEvent(ev13)==1) {         /* NEW CARD */
                        return 3;
                }
        }
}

_clear_event_x()
{
	TestEvent(ev10);
	TestEvent(ev11);
	TestEvent(ev12);
	TestEvent(ev13);
}

uint8	dir_file(drv,memfiles)
char *drv;
struct DIRENTRY *memfiles;
{
        long i;
        char key[128];

	extern struct DIRENTRY *firstfile(), *nextfile();

	strcpy(key,drv);
	strcat(key,"*");

        i = 0;
	if(firstfile(key, memfiles)==memfiles) {
                do {
                        i++;
			memfiles++;
                } while(nextfile(memfiles)==memfiles);
        }
	return i;
}


et_format(chan)
long chan;
{
	bzero(&buf[0],128);
	_clear_event_x();
	_new_card();
	_card_read(chan,0,&buf[0]);
	if(_card_event_x()!=0)
		return -1;
	if(buf[0]=='M' && buf[1]=='C')
		return 1;
	return 0;
}

void testcard(uint8	cardno)
{
	printf("testing card %d\n",cardno);
	cardno%=2;
	_card_info(cardno*0x10);
    ret = _card_event();
	switch(ret)
	{
		case 0:
			printf("CARD EXIST\n");
			cardstatus=0;
			break;
		case 2:
			printf("NO CARD\n");
			cardstatus=1;
			goto done;
		case 3:
			printf("NEW CARD\n");
			_clear_event_x();
			_card_clear(cardno*0x10);
        	ret = _card_event_x();
		break;
		case 1:
		default:
			printf("ERROR\n");
			cardstatus=5;
			break;
	}
	_clear_event();
    _card_load(cardno*0x10);		/* load file system */
    ret = _card_event();
	switch(ret)
	{
		case 0:
			printf("FORMATTED\n");
			cardstatus=0;
			break;
		case 2:
			printf("NO CARD\n");
			cardstatus=1;
			break;
		case 3:
			printf("UNFORMATTED\n");
			cardstatus=2;
			break;
		case 1:
		default:
			printf("ERROR\n");
			cardstatus=5;
			break;
	}
done:
	return;
}

void formatcard(uint8 cardno)
{
	char cardstr[6];
	char *cardptr;

	cardno%=2;
	cardptr=&cardstr[0];
	if (cardno==0)
	{
		sprintf(cardptr,"bu00:\0");
	}
	else
	{
		sprintf(cardptr,"bu10:\0");
	}
	printf("formatting card %d\n",cardno);
	ret = format(cardptr);
	if(ret==1)
		printf("\nDONE\n");
	else
		printf("\nERROR\n");
}

uint8 carddirectory(uint8 cardno)
{
	char cardstr[18];
	char *cardptr;
	uint8	i;

	cardstatus=0;
	cardno%=2;
	cardptr=&cardstr[0];
	testcard(cardno);
	if (cardstatus!=0)
	{
		return;
	}
/*	if (cardno==0)
	{
		sprintf(cardptr,"bu00:BESLES-00711RECS");
	}
	else
	{
		sprintf(cardptr,"bu10:BESLES-00711RECS");
	}
	if (dir_file(cardptr,&memfiles[0])==1)
	{
		printf("records save exists\n");
	}   */

	if (cardno==0)
	{
		sprintf(cardptr,"bu00:BESLES-00711S");
	}
	else
	{
		sprintf(cardptr,"bu10:BESLES-00711S");
	}
	printf("directory card %d\n",cardno);
	ret = dir_file(cardptr,&memfiles[0]);
	if(ret==0)
		printf(" no chill files\n");
	else {
		printf("  %d chill file(s)\n",ret);
		for(i=0;i<ret;i++) {
			printf("  %2d:%s\n",i+1,memfiles[i].name);
		}
	}
	return ret;
}

uint8 cardfileexist(uint8 cardno)
{
	char cardstr[18];
	char *cardptr;
	uint8	i;

	cardstatus=0;
	cardno%=2;
	cardptr=&cardstr[0];
	testcard(cardno);
	if (cardstatus!=0)
	{
		return;
	}
/*	if (cardno==0)
	{
		sprintf(cardptr,"bu00:BESLES-00711RECS");
	}
	else
	{
		sprintf(cardptr,"bu10:BESLES-00711RECS");
	}
	if (dir_file(cardptr,&memfiles[0])==1)
	{
		printf("records save exists\n");
	}   */

	if (cardno==0)
	{
		sprintf(cardptr,"bu00:BESLES-00711S%s",&Player[0].Name);
	}
	else
	{
		sprintf(cardptr,"bu10:BESLES-00711S%s",&Player[0].Name);
	}
	printf("directory card %d\n",cardno);
	ret = dir_file(cardptr,&memfiles[0]);
	if(ret==0)
		printf(" file does not exist\n");
	else {
		printf(" file exists");
	}
	return ret;
}


uint8 carddirnumfile(uint8 cardno)
{
	char cardstr[18];
	char *cardptr;
	uint8	i;

	cardstatus=0;
	cardno%=2;
	cardptr=&cardstr[0];
	testcard(cardno);
	if (cardstatus!=0)
	{
		return 0;
	}
	if (cardno==0)
	{
		sprintf(cardptr,"bu00:");
	}
	else
	{
		sprintf(cardptr,"bu10:");
	}
	printf("directory card %d\n",cardno);
	ret = dir_file(cardptr,&memfiles[0]);
	if(ret==0)
		printf(" no files\n");
	else {
		printf("  %d file(s)\n",ret);
		for(i=0;i<ret;i++) {
			printf("  %2d:%s\n",i+1,memfiles[i].name);
		}
	}
	return i+1;
}


void cardread(uint8 cardno,uint8 dirno,char *buffer)
{
	char cardstr[21];
	char *cardptr;

	cardstatus=0;
	cardno%=2;
	cardptr=&cardstr[0];
	testcard(cardno);
	if (cardstatus!=0)
	{
		cardstatus=3;
		return;
	}
	if (cardno==0)
	{
		sprintf(cardptr,"bu00:%s",&memfiles[dirno].name);
	}
	else
	{
		sprintf(cardptr,"bu10:%s",&memfiles[dirno].name);
	}

	if ((fd=open(cardptr,O_RDONLY))==-1)
	{
		printf("read didn't work\n");
		cardstatus=3;
	}
	else
	{
		printf("read successful\n");
	}
	read(fd,buffer,2048); /* buffer size */
	close(fd);
}

void cardwrite(uint8 cardno,char *buffer)
{
	char cardstr[22];
	char *cardptr;

	cardstatus=0;
	cardno%=2;
	cardptr=&cardstr[0];
	testcard(cardno);
	if (cardstatus!=0)
	{
		cardstatus=4;
		return;
	}
	if (cardno==0)
	{
		sprintf(cardptr,"bu00:%s",&newname.name);
	}
	else
	{
		sprintf(cardptr,"bu10:%s",&newname.name);
	}
	_card_info(cardno*0x10);
    ret = _card_event();
	if(!(ret==1 || ret==2))
	{
		if(ret==3)
		{
			_clear_event_x();
			_card_clear(0x00);
        	ret = _card_event_x();
		}
		_clear_event();
       	_card_load(cardno*0x10);
	    ret = _card_event();
		if(ret==3)
		{
			formatcard(cardno);
		}
		fd=open(cardptr,O_CREAT|0x10000);
		if((write(fd,buffer,2048))==-1)
		{
			printf("bollocks, %s didn't save \n",cardptr);
			cardstatus=4;
		}
		close(fd);
	}
}



void initmemcards(void)
{
	ev0 = OpenEvent(SwCARD, EvSpIOE, EvMdNOINTR, NULL);
	ev1 = OpenEvent(SwCARD, EvSpERROR, EvMdNOINTR, NULL);
	ev2 = OpenEvent(SwCARD, EvSpTIMOUT, EvMdNOINTR, NULL);
	ev3 = OpenEvent(SwCARD, EvSpNEW, EvMdNOINTR, NULL);
	ev10 = OpenEvent(HwCARD, EvSpIOE, EvMdNOINTR, NULL);
	ev11 = OpenEvent(HwCARD, EvSpERROR, EvMdNOINTR, NULL);
	ev12 = OpenEvent(HwCARD, EvSpTIMOUT, EvMdNOINTR, NULL);
	ev13 = OpenEvent(HwCARD, EvSpNEW, EvMdNOINTR, NULL);

	EnableEvent(ev0);
    EnableEvent(ev1);
    EnableEvent(ev2);
    EnableEvent(ev3);
    EnableEvent(ev10);
    EnableEvent(ev11);
    EnableEvent(ev12);
    EnableEvent(ev13);
}

void killmemcards(void)
{
	DisableEvent(ev0);
    DisableEvent(ev1);
    DisableEvent(ev2);
    DisableEvent(ev3);
    DisableEvent(ev10);
    DisableEvent(ev11);
    DisableEvent(ev12);
    DisableEvent(ev13);

	CloseEvent(ev0);
    CloseEvent(ev1);
    CloseEvent(ev2);
    CloseEvent(ev3);
    CloseEvent(ev10);
    CloseEvent(ev11);
    CloseEvent(ev12);
    CloseEvent(ev13);

}

void setuvs(POLY_FT4 *poly,uint8 u02,uint8 u13,uint8 v01,uint8 v23)
{
	poly->v0=poly->v1=v01;
	poly->v2=poly->v3=v23;
	poly->u0=poly->u2=u02;
	poly->u1=poly->u3=u13;
}

void setuvgs(POLY_GT4 *poly,uint8 u02,uint8 u13,uint8 v01,uint8 v23)
{
	poly->v0=poly->v1=v01;
	poly->v2=poly->v3=v23;
	poly->u0=poly->u2=u02;
	poly->u1=poly->u3=u13;
}

void uvchar(char *a,POLY_FT4 *b)
{
	if ((*a>='0')&&(*a<='9'))
	{
		setuvs(b,0,15,(((*a)-48)*14),(((*a)-48)*14)+13);
	}
	else
	{
		if (*a>='N')
		{
			setuvs(b,48,63,(((*a)-78)*14),(((*a)-78)*14)+13);
		}
		else
		{
			setuvs(b,32,47,(((*a)-65)*14),(((*a)-65)*14)+13);
		}
	}
}

uint8 fadeout(void)
{
	uint8	temp,i;
	uint16	thistpage;

	temp=fadevalue;
//	fadevalue/=2;
	if ((fegamestate==4)||(fegamestate==5))
	{
		thistpage=transtpage2;
	}
	else
	{
		thistpage=transtpage1;
	}
	for (i=0;i<4;i++)
	{
		SetDrawTPage(&(transcontrol[otid][i]),1,1,(int)(thistpage));

		setRGB0(&fadepoly[otid][i],fadevalue*6,fadevalue*6,fadevalue*16);
		setRGB1(&fadepoly[otid][i],fadevalue*6,fadevalue*16,fadevalue*6);
		setRGB2(&fadepoly[otid][i],fadevalue*16,fadevalue*6,fadevalue*6);
		setRGB3(&fadepoly[otid][i],fadevalue*16,fadevalue*16,fadevalue*16);
		setPolyG4(&fadepoly[otid][i]);

		AddPrim(&FeOT[otid][13],&transcontrol[otid][i]);
		SetSemiTrans(&fadepoly[otid][i],1);

		AddPrim(&FeOT[otid][14],&fadepoly[otid][i]);
	}
//	fadevalue=temp;
	if (fadevalue==15)
	{
		fadevalue=0;
		return 1;
	}
	else
	{
		fadevalue++;
		return 0;
	}
}

uint8 fadein(void)
{
	uint8	temp,i;
	uint16  thistpage;

//	temp=fadevalue;
//	fadevalue/=10;
	if ((fegamestate==4)||(fegamestate==5))
	{
		thistpage=transtpage2;
	}
	else
	{
		thistpage=transtpage1;
	}
	for (i=0;i<4;i++)
	{
		SetDrawTPage(&(transcontrol[otid][i]),1,1,(int)(thistpage));
		setRGB0(&fadepoly[otid][i],fadevalue*6,fadevalue*6,fadevalue*16);
		setRGB1(&fadepoly[otid][i],fadevalue*6,fadevalue*16,fadevalue*6);
		setRGB2(&fadepoly[otid][i],fadevalue*16,fadevalue*6,fadevalue*6);
		setRGB3(&fadepoly[otid][i],fadevalue*16,fadevalue*16,fadevalue*16);
		setPolyG4(&fadepoly[otid][i]);
		AddPrim(&FeOT[otid][13],&transcontrol[otid][i]);
		SetSemiTrans(&fadepoly[otid][i],1);
		AddPrim(&FeOT[otid][14],&fadepoly[otid][i]);
	}
//	fadevalue=temp;
	if (fadevalue==0)
	{
		fadevalue=15;
		return 1;
	}
	else
	{
		fadevalue--;
		return 0;
	}
}

void loadcurrentscreens(void)
{
	cdbuffer=(char *)&Ib2[0];
#ifndef CD
	fefin			=	PCopen( "textures/frontend/front320.tim", 0, 0 );
	fefilesize	=	PClseek( fefin, 0, 2 );
	PClseek( fefin, 0, 0 );
	fetexture	=	cdbuffer+48;
	PCread( fefin, (char *)fetexture, fefilesize );
	PCclose( fefin );
#else
	load_cd("\\TEXTURES\\FRONTEND\\FRONT320.TIM;1",cdbuffer+48);
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
#endif
	OpenTIM(cdbuffer+48);
	ReadTIM(&fetimheader);
#ifndef CD
	fefin			=	PCopen( "textures/frontend/prelang.tim", 0, 0 );
	fefilesize	=	PClseek( fefin, 0, 2 );
	PClseek( fefin, 0, 0 );
	fetexture	=	cdbuffer+180000;
	PCread( fefin, (char *)fetexture, fefilesize );
	PCclose( fefin );
#else
	load_cd("\\TEXTURES\\FRONTEND\\PRELANG.TIM;1",cdbuffer+180000);
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
#endif
	OpenTIM(cdbuffer+180000);
	ReadTIM(&gentimheader);
	prelangtpage=LoadTPage(gentimheader.paddr,1,0,448,0,256,256);  /* 96 */
	prelangclut=LoadClut(gentimheader.caddr,448,255);

	switch (language)
	{
#ifndef CD
		default:
		case (0):
		{
			fefin	=	PCopen( "textures/frontend/english.tim", 0, 0 );
			break;
		}
		case (1):
		{
			fefin	=	PCopen( "textures/frontend/english.tim", 0, 0 );
			break;
		}
		case (2):
		{
			fefin	=	PCopen( "textures/frontend/english.tim", 0, 0 );
			break;
		}
		case (3):
		{
			fefin	=	PCopen( "textures/frontend/english.tim", 0, 0 );
			break;
		}
		case (4):
		{
			fefin	=	PCopen( "textures/frontend/english.tim", 0, 0 );
			break;
		}
#else
		default:
		case (0):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH.TIM;1",cdbuffer+180000);
			break;
		}
		case (1):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH.TIM;1",cdbuffer+180000);
			break;
		}
		case (2):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH.TIM;1",cdbuffer+180000);
			break;
		}
		case (3):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH.TIM;1",cdbuffer+180000);
			break;
		}
		case (4):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH.TIM;1",cdbuffer+180000);
			break;
		}
#endif
	}
	/* load language texture page */

#ifndef CD
	fefilesize	=	PClseek( fefin, 0, 2 );
	PClseek( fefin, 0, 0 );
	fetexture	=	cdbuffer+180000;
	PCread( fefin, (char *)fetexture, fefilesize );
	PCclose( fefin );
#else
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
#endif
	OpenTIM(cdbuffer+180000);
	ReadTIM(&gentimheader);
	langtpage=LoadTPage(gentimheader.paddr,1,0,576,0,256,256);  /* 96 */
	langclut=LoadClut(gentimheader.caddr,576,255);
	switch (language)
	{
#ifndef CD
		default:
		case (0):
		{
			fefin	=	PCopen( "textures/frontend/english2.tim", 0, 0 );
			break;
		}
		case (1):
		{
			fefin	=	PCopen( "textures/frontend/english2.tim", 0, 0 );
			break;
		}
		case (2):
		{
			fefin	=	PCopen( "textures/frontend/english2.tim", 0, 0 );
			break;
		}
		case (3):
		{
			fefin	=	PCopen( "textures/frontend/english2.tim", 0, 0 );
			break;
		}
		case (4):
		{
			fefin	=	PCopen( "textures/frontend/english2.tim", 0, 0 );
			break;
		}
#else
		default:
		case (0):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH2.TIM;1",cdbuffer+180000);
			break;
		}
		case (1):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH2.TIM;1",cdbuffer+180000);
			break;
		}
		case (2):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH2.TIM;1",cdbuffer+180000);
			break;
		}
		case (3):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH2.TIM;1",cdbuffer+180000);
			break;
		}
		case (4):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH2.TIM;1",cdbuffer+180000);
			break;
		}
#endif
	}
	/* load language texture page */

#ifndef CD
	fefilesize	=	PClseek( fefin, 0, 2 );
	PClseek( fefin, 0, 0 );
	fetexture	=	cdbuffer+180000;
	PCread( fefin, (char *)fetexture, fefilesize );
	PCclose( fefin );
#else
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
#endif
	OpenTIM(cdbuffer+180000);
	ReadTIM(&gentimheader);
	lang2tpage=LoadTPage(gentimheader.paddr,1,0,704,0,256,256);  /* 96 */
	lang2clut=LoadClut(gentimheader.caddr,704,255);
	switch (language)
	{
#ifndef CD
		default:
		case (0):
		{
			fefin	=	PCopen( "textures/frontend/english3.tim", 0, 0 );
			break;
		}
		case (1):
		{
			fefin	=	PCopen( "textures/frontend/english3.tim", 0, 0 );
			break;
		}
		case (2):
		{
			fefin	=	PCopen( "textures/frontend/english3.tim", 0, 0 );
			break;
		}
		case (3):
		{
			fefin	=	PCopen( "textures/frontend/english3.tim", 0, 0 );
			break;
		}
		case (4):
		{
			fefin	=	PCopen( "textures/frontend/english3.tim", 0, 0 );
			break;
		}
#else
		default:
		case (0):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH3.TIM;1",cdbuffer+180000);
			break;
		}
		case (1):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH3.TIM;1",cdbuffer+180000);
			break;
		}
		case (2):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH3.TIM;1",cdbuffer+180000);
			break;
		}
		case (3):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH3.TIM;1",cdbuffer+180000);
			break;
		}
		case (4):
		{
			load_cd("\\TEXTURES\\FRONTEND\\ENGLISH3.TIM;1",cdbuffer+180000);
			break;
		}
#endif
	}
	/* load language texture page */

#ifndef CD
	fefilesize	=	PClseek( fefin, 0, 2 );
	PClseek( fefin, 0, 0 );
	fetexture	=	cdbuffer+180000;
	PCread( fefin, (char *)fetexture, fefilesize );
	PCclose( fefin );
#else
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
#endif
	OpenTIM(cdbuffer+180000);
	ReadTIM(&gentimheader);
	lang3tpage=LoadTPage(gentimheader.paddr,1,0,832,0,256,256);  /* 96 */
	lang3clut=LoadClut(gentimheader.caddr,832,255);
}


void Frontend(void)
{
	/* initialise systems if first time */

	if (firsttime==0)
	{
#ifdef CD
		CdInit();
#endif
		InitialisePSX();
// 		initfilesystem();
		InitialisePads();
		firsttime=1;
//		initobjects();
		InitCARD(1);
		StartCARD();
		_bu_init();
//		initmemcards();
		textboxeson=0;
		blackboxon=0;
		initialisesavegame();
		noframes=0;
//		musiccat=1;
	}
	Initialise_Skeleton();
	InitialisePlayers();
	sprintf(&Player[0].Name[0],"PL1");
	sprintf(&Player[1].Name[0],"PL2");
	chosenchar[0]=0;
	chosenchar[1]=1;
//	OpenTIM(&cdbuffer);
//	ReadTIM(&fetimheader);

	for (exitcount=0;exitcount<2;exitcount++)
	{
		if (exitcount==0)
		{
#ifndef CD
			fefin			=	PCopen( "textures/page9.tim", 0, 0 );
			fefilesize	=	PClseek( fefin, 0, 2 );
			PClseek( fefin, 0, 0 );
			fetexture	=	cdbuffer+180000;
			PCread( fefin, (char *)fetexture, fefilesize );
			PCclose( fefin );
#else
			load_cd("\\TEXTURES\\PAGE9.TIM;1",cdbuffer+180000);
			do
 			{

 			}
 			while (CdReadSync(1,0) > 0 );
#endif
			OpenTIM(cdbuffer+180000);
			ReadTIM(&gentimheader);
			tids[8].textpage=LoadTPage(gentimheader.paddr,1,0,704,256,128,256);  /* 96 */
			tids[8].clutline[0]=LoadClut(gentimheader.caddr,768,296);
		}


/*	 	setXY4(&pistepoly[exitcount],204,47,298,47,204,207,298,207);
		setRGB0(&pistepoly[exitcount],127,127,127);
		setXY4(&pisteclear[exitcount],0,0,320,0,0,240,320,240);
		setRGB0(&pisteclear[exitcount],127,127,127);
		setRGB0(&mapsprite[exitcount],127,127,127);
		mapsprite[exitcount].u0=mapsprite[exitcount].u2=16;
		mapsprite[exitcount].u1=mapsprite[exitcount].u3=31;
		mapsprite[exitcount].v0=mapsprite[exitcount].v1=32;
		mapsprite[exitcount].v2=mapsprite[exitcount].v3=47;
		setXY4(&textsprite[exitcount],50,131,177,131,50,139,177,139);
		setXY4(&lboardsprite[exitcount],219,65,283,65,219,132,283,132);
		setXY4(&rboardsprite[exitcount],219,132,283,132,219,191,283,191);
		setRGB0(&textsprite[exitcount],127,127,127);
		setRGB0(&lboardsprite[exitcount],127,127,127);
		setRGB0(&rboardsprite[exitcount],127,127,127);
		setRGB0(&uparrow[exitcount],127,127,127);
		setRGB0(&downarrow[exitcount],127,127,127);
		uparrow[exitcount].u0=uparrow[exitcount].u2=167;
		uparrow[exitcount].u1=uparrow[exitcount].u3=191;
		uparrow[exitcount].v0=uparrow[exitcount].v1=180;
		uparrow[exitcount].v2=uparrow[exitcount].v3=196;
		downarrow[exitcount].u0=downarrow[exitcount].u2=167;
		downarrow[exitcount].u1=downarrow[exitcount].u3=191;
		downarrow[exitcount].v0=downarrow[exitcount].v1=197;
		downarrow[exitcount].v2=downarrow[exitcount].v3=213;
		setXY4(&charsprites[exitcount][0],42,82,73,82,42,109,73,109);
		setXY4(&charsprites[exitcount+2][0],42,82,73,82,42,109,73,109);
		setRGB0(&charsprites[exitcount][0],127,127,127);
		setRGB0(&charsprites[exitcount+2][0],127,127,127);
		setXY4(&charsprites[exitcount][1],96,82,127,82,96,109,127,109);
		setXY4(&charsprites[exitcount+2][1],96,82,127,82,96,109,127,109);
		setRGB0(&charsprites[exitcount][1],127,127,127);
		setRGB0(&charsprites[exitcount+2][1],127,127,127);
		setXY4(&charsprites[exitcount][2],150,82,181,82,150,109,181,109);
		setXY4(&charsprites[exitcount+2][2],150,82,181,82,150,109,181,109);
		setRGB0(&charsprites[exitcount][2],127,127,127);
		setRGB0(&charsprites[exitcount+2][2],127,127,127);
		sprintf(&Player[exitcount].Name[0],"PL%d\0",exitcount+1);
		for (fecnt1=0;fecnt1<8;fecnt1++)
		{
			setuvs(&barpolys[exitcount][fecnt1],192,255,166,173);
		}
		setXY4(&xbutton[exitcount],31,207,51,207,31,226,51,226);
		setXY4(&tbutton[exitcount],154,207,174,207,154,226,174,226);
		setuvs(&xbutton[exitcount],184,204,214,233);
		setuvs(&tbutton[exitcount],161,181,214,233);
		setRGB0(&xbutton[exitcount],127,127,127);
		setRGB0(&tbutton[exitcount],127,127,127);
		setXY4(&seltext[exitcount],51,212,153,212,51,221,153,221);
		setXY4(&backtext[exitcount],181,212,283,212,181,221,283,221);
		setuvs(&seltext[exitcount],0,102,80,89);
		setuvs(&backtext[exitcount],0,102,90,99);
		setRGB0(&seltext[exitcount],127,127,127);
		setRGB0(&backtext[exitcount],127,127,127); */
		for (fecnt1=0;fecnt1<5;fecnt1++)
		{
			setXY4(&menuboxes[exitcount][fecnt1],52,132+(fecnt1*18),266,132+(fecnt1*18),52,149+(fecnt1*18),266,149+(fecnt1*18));
			setRGB0(&menuboxes[exitcount][fecnt1],127,127,127);
			setPolyFT4(&menuboxes[exitcount][fecnt1]);
			setXY4(&menutext[exitcount][fecnt1],60,134+(fecnt1*18),260,134+(fecnt1*18),60,147+(fecnt1*18),260,147+(fecnt1*18));
			setRGB0(&menutext[exitcount][fecnt1],127,127,127);
			setPolyFT4(&menutext[exitcount][fecnt1]);
		}
		setXY4(&blackbox[exitcount],52,210,266,210,52,227,266,227);
		setRGB0(&blackbox[exitcount],127,127,127);
		setuvs(&blackbox[exitcount],3,217,114,129);
		setPolyFT4(&blackbox[exitcount]);
		for (fecnt1=0;fecnt1<30;fecnt1++)
		{
			setXY4(&barpolys[exitcount][fecnt1],55+(fecnt1*7),213,61+(fecnt1*7),213,55+(fecnt1*7),225,61+(fecnt1*7),225);
			setuvgs(&barpolys[exitcount][fecnt1],0,19,132,145);
			setRGB0(&barpolys[exitcount][fecnt1],(fecnt1*4),120-(fecnt1*4),(fecnt1*8));
			setRGB2(&barpolys[exitcount][fecnt1],(fecnt1*4),120-(fecnt1*4),(fecnt1*8));
			setRGB1(&barpolys[exitcount][fecnt1],(fecnt1*4),128-(fecnt1*4),15+(fecnt1*8));
			setRGB3(&barpolys[exitcount][fecnt1],(fecnt1*4),128-(fecnt1*4),15+(fecnt1*8));
			setPolyGT4(&barpolys[exitcount][fecnt1]);
		}
		for (fecnt1=0;fecnt1<3;fecnt1++)
		{
			setXY4(&fenamepolys[exitcount][fecnt1],132+(fecnt1*21),211,146+(fecnt1*21),211,132+(fecnt1*21),226,146+(fecnt1*21),226);
			setPolyFT4(&fenamepolys[exitcount][fecnt1]);
		}
		setXY4(&outnopoly[exitcount],236,186,249,186,236,203,249,203);
		setRGB0(&outnopoly[exitcount],127,127,127);
		setPolyFT4(&outnopoly[exitcount]);


		setXY4(&padtext1[exitcount],180,134,260,134,180,147,260,147);
		setXY4(&padtext2[exitcount],180,170,260,170,180,183,260,183);
		setRGB0(&padtext1[exitcount],127,127,127);
		setRGB0(&padtext2[exitcount],127,127,127);
		setPolyFT4(&padtext1[exitcount]);
		setPolyFT4(&padtext2[exitcount]);
//		setXY4(&leftbpoly[exitcount],220,20,260,20,220,130,260,130);
		setRGB0(&leftbpoly[exitcount],127,127,127);
		setPolyFT4(&leftbpoly[exitcount]);
//		setXY4(&rightbpoly[exitcount],270,20,310,20,270,130,310,130);
		setRGB0(&rightbpoly[exitcount],127,127,127);
		setPolyFT4(&rightbpoly[exitcount]);
		setXY4(&boardnamepoly[exitcount],140,171,255,171,140,182,255,182);
		setRGB0(&boardnamepoly[exitcount],127,127,127);
		setPolyFT4(&boardnamepoly[exitcount]);
		for (fecnt1=0;fecnt1<4;fecnt1++)
		{
			setXY4(&fadepoly[exitcount][fecnt1],0,0,320,0,0,240,320,240);
		}
		transtpage1 = GetTPage(1,1,0,0);
		transtpage2 = GetTPage(1,2,0,0);
//		SetDrawTPage(&(transcontrol[exitcount][1]),1,1,(int)(transtpage));
//		transtpage = GetTPage(1,1,0,0);
//		SetDrawTPage(&(transcontrol[exitcount][2]),1,1,(int)(transtpage));
//		SetDrawTPage(&(transcontrol[exitcount][]),1,1,(int)(transtpage));
		for (fecnt1=0;fecnt1<5;fecnt1++)
		{
			for (fecnt2=0;fecnt2<3;fecnt2++)
			{
				setRGB0(&cardpolys[exitcount][fecnt1][fecnt2],127,127,127);
				setXY4(&cardpolys[exitcount][fecnt1][fecnt2],135+(fecnt2*16),134+(fecnt1*18),149+(fecnt2*16),134+(fecnt1*18),
														135+(fecnt2*16),148+(fecnt1*18),149+(fecnt2*16),148+(fecnt1*18));
				setPolyFT4(&cardpolys[exitcount][fecnt1][fecnt2]);
			}
		}
	}
	exitcount=0;
	FntLoad(960,256);
	fntid1 = FntOpen(45,215,250,8,0,50);
	SetDumpFnt(fntid1);


//	MyLocalLight.m[0][0]=10000;
//	MyLocalLight.m[0][1]=10000;
//	MyLocalLight.m[0][2]=-10000;
//	MyColourMatrix.m[0][0]=2000;
//	MyColourMatrix.m[1][0]=2000;
//	MyColourMatrix.m[2][0]=2000;

	/* temp font shit */

	otid=0;
	display_id=0;
	feexit=0;
	backgroundloaded=0;
	fegamestate=0;
	stgamestate=0;
	pistewinx=0;
	pistewiny=0;
	feobjsloaded=0;
	fevector.vy=0;
	fez=50;
	fed=20;
	maptransport=0;
	logoson=0;
	fadestatus=0;

	while (feexit==0)
	{
		if ((fegamestate!=stgamestate)&&(fadestatus==0))
		{
			if ((fegamestate==1)||(fegamestate==5)||(fegamestate==4)||(fegamestate==8))
			{
				stgamestate=fegamestate;
			}
			else
			{
				stgamestate=fegamestate;
				fegamestate=50;
				fadestatus=2;
			}
		}
		/* do pad read stuff */
		if (fadestatus==0)
		{
			fepadread = Pad_Debounced( 0 );
			fepadread2 = Pad_Debounced( 1 );
#ifdef MUSIC
			if (((fepadread!=0)||(fepadread2!=0))&&(fegamestate>4)&&(fegamestate<15))
			{
				playfesoundeffect(rand()%5,1);
			}
#endif
		}
		else
		{
			fepadread=fepadread2=0;
		}

		OTPtr=&FeOT[otid][0];
		ClearOTag(OTPtr,16);
		DrawSync(0);
//		LoadImage(&imarea[otid],fetimheader.paddr);
//		DrawSync(0);

		/* do state based specifics */
		switch (fegamestate)
		{
			case (0):
			{
				/* sony piracy warning screen */
				if (backgroundloaded==0)
				{
#ifndef CD
					fefin			=	PCopen( "textures/frontend/warning.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\WARNING.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
					exitcount=0;
					udarrowson=0;
				}
				else
				{
					exitcount++;
				}
				if (exitcount==2)
				{
 					initfilesystem();
				}
				if (exitcount>2)  /* 150 for final version = 5 secs, ntsc. pal = 125 */
				{
					if ((fepadread==PAD_START)||(fepadread==PAD_B2))
					{
						fegamestate=1;
						backgroundloaded=0;
//							fegamestate=16;
//							nomenuopts=numloadedtracks;
//							menuoption=52
//							backgroundloaded=0;
//							udarrowson=0;

					}
					if ((fepadread2==PAD_START)||(fepadread2==PAD_B2))
					{
						fegamestate=1;
						backgroundloaded=0;
//							fegamestate=16;
//							nomenuopts=numloadedtracks;
//							menuoption=52
//							backgroundloaded=0;
//							udarrowson=0;

					}
				}
				if (exitcount>=30000)  /* 250 for pal */
				{
					fegamestate=1;
					feobjsloaded=0;
					backgroundloaded=0;
//							fegamestate=16;
//							nomenuopts=numloadedtracks;
//							menuoption=52
//							backgroundloaded=0;
//							udarrowson=0;
				}
				break;
			}
			case (1):
			{
				/* eidos copywrite screen */
				if (backgroundloaded==0)
				{
#ifndef CD
					fefin			=	PCopen( "textures/frontend/eidos.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\EIDOS.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
					exitcount=0;
					fadestatus=1;
				}
				/* temp font shit */
				exitcount++;
				if (exitcount>600)	/* 500 for pal, 20 secs */
				{
					fegamestate=2;
					backgroundloaded=0;
				}
				if ((fepadread==PAD_START)||(fepadread==PAD_B2))
				{
					fegamestate=2;
					backgroundloaded=0;

				}
				if ((fepadread2==PAD_START)||(fepadread2==PAD_B2))
				{
					fegamestate=2;
					backgroundloaded=0;
				}

				break;
			}
			case (2):
			{
				/* play fmv one */
				if (backgroundloaded==0)
				{
#ifndef CD
					fefin			=	PCopen( "textures/frontend/sdreams.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\SDREAMS.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
					exitcount=0;
					fadestatus=1;
				}
				udarrowson=0;
				if ((fepadread==PAD_START)||(fepadread==PAD_B2))
				{
					fegamestate=3;
					backgroundloaded=0;

				}
				if ((fepadread2==PAD_START)||(fepadread2==PAD_B2))
				{
					fegamestate=3;
					backgroundloaded=0;
				}
				break;
			}
			case (3):
			{
				if (backgroundloaded==0)
				{
					/* load initial language screen */
#ifndef CD
					fefin			=	PCopen( "textures/frontend/front320.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\FRONT320.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
#ifndef CD
					fefin			=	PCopen( "textures/frontend/prelang.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\PRELANG.TIM;1",cdbuffer+180000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					prelangtpage=LoadTPage(gentimheader.paddr,1,0,448,0,256,256);  /* 96 */
					prelangclut=LoadClut(gentimheader.caddr,448,255);
					nomenuopts=5;
					menuoption=0;
					textboxeson=1;
					setuvs(&menutext[0][0],0,255,44,57);
					setuvs(&menutext[0][1],0,255,58,71);
					setuvs(&menutext[0][2],0,255,72,85);
					setuvs(&menutext[0][3],0,255,86,99);
					setuvs(&menutext[0][4],0,255,100,113);
					setuvs(&menutext[1][0],0,255,44,57);
					setuvs(&menutext[1][1],0,255,58,71);
					setuvs(&menutext[1][2],0,255,72,85);
					setuvs(&menutext[1][3],0,255,86,99);
					setuvs(&menutext[1][4],0,255,100,113);
					for (fecnt1=0;fecnt1<5;fecnt1++)
					{
						menutext[0][fecnt1].tpage=prelangtpage;
						menutext[0][fecnt1].clut=prelangclut;
						menutext[1][fecnt1].tpage=prelangtpage;
						menutext[1][fecnt1].clut=prelangclut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					backgroundloaded=1;
					exitcount=0;
					fadestatus=1;
				}
				if ((fepadread==PAD_DOWN)||(fepadread2==PAD_DOWN))
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if ((fepadread==PAD_UP)||(fepadread2==PAD_UP))
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if ((fepadread==PAD_START)||(fepadread==PAD_B2)||(fepadread2==PAD_START)||(fepadread2==PAD_B2))
				{

					fegamestate=4;
					backgroundloaded=0;
					textboxeson=0;
					language=menuoption;
				}
				break;
			}

			case (4):
			{
				/* FMV */
				cdbuffer=&Ib2[0];
				cdbuffer+=80000;
#ifdef CD
				InitMoviePlayer();
				PlayMovie(&MOVIE_NAME1,0,298);
				FreeMoviePlayer();
#endif
				fegamestate=5;
				backgroundloaded=0;
				break;
			}
			case (5):
			{
				/* chill start screen */
				if (backgroundloaded==0)
				{
#ifdef MUSIC
					musiccat=4;
					tuneno=0;
					InitialiseSound(0);
					VSyncCallback(&SoundCallBack);
#endif
					loadcurrentscreens();
#ifndef CD
					fefin			=	PCopen( "textures/frontend/strtscrn.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\STRTSCRN.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
					if (firsttime==1)
					{
						exitcount=300;   /* temp for chris */
						firsttime=2;
					}
					else
					{
						exitcount=300;
					}
					fadestatus=1;
				}
#ifdef NTSC
				if (exitcount>300)
#else
				if (exitcount>250)
#endif
				{
					if ((fepadread==PAD_B2)||(fepadread2==PAD_B2)||(fepadread==PAD_START)||(fepadread2==PAD_START))
					{
						fegamestate=6;
						backgroundloaded=0;
						nomenuopts=5;
						menuoption=0;
					}
				}
#ifdef NTSC
				if (exitcount>=1800)
#else
				if (exitocunt>=1500)
#endif
				{
					/* back to FMV */
					fegamestate=4;
					logoson=0;
					textboxeson=0;
#ifdef MUSIC
					KillSoundFE();
					VSyncCallback(0);
#endif

				}
				exitcount++;
				break;
			}
			case (6):
			{
				if (backgroundloaded==0)
				{
#ifndef CD
					fefin			=	PCopen( "textures/frontend/front320.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\FRONT320.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
					exitcount=0;
					menuoption=0;
#ifndef CD
					fefin			=	PCopen( "textures/frontend/burton.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+200000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\BURTON.TIM;1",cdbuffer+200000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+200000);
					ReadTIM(&boxtims);
#ifndef CD
					fefin			=	PCopen( "textures/frontend/burtref.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+230000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\FRONTEND\\BURTREF.TIM;1",cdbuffer+230000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+230000);
					ReadTIM(&reftims);
					reftpage=LoadTPage(reftims.paddr,1,0,320,0,64,128);  /* 96 */
					refclut=LoadClut(reftims.caddr,320,129);
					setuvs(&refsprite[0],0,43,0,71);
					setuvs(&refsprite[1],0,43,0,71);
					setXY4(&refsprite[0],103,27,147,27,103,99,147,99);
					setXY4(&refsprite[1],103,27,147,27,103,99,147,99);
					setRGB0(&refsprite[0],127,127,127);
					setRGB0(&refsprite[1],127,127,127);
					refsprite[0].tpage=reftpage;
					refsprite[0].clut=refclut;
					refsprite[1].tpage=reftpage;
					refsprite[1].clut=refclut;
					logoson=1;
					nomenuopts=5;
					menuoption=0;
					textboxeson=1;
					blackboxon=0;
					setuvs(&menutext[0][0],0,255,0,13);
					setuvs(&menutext[0][1],0,255,14,27);
					setuvs(&menutext[0][2],0,255,28,41);
					setuvs(&menutext[0][3],0,255,42,55);
					setuvs(&menutext[0][4],0,255,56,69);
					setuvs(&menutext[1][0],0,255,0,13);
					setuvs(&menutext[1][1],0,255,14,27);
					setuvs(&menutext[1][2],0,255,28,41);
					setuvs(&menutext[1][3],0,255,42,55);
					setuvs(&menutext[1][4],0,255,56,69);
					for (fecnt1=0;fecnt1<5;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang2tpage;
						menutext[0][fecnt1].clut=lang2clut;
						menutext[1][fecnt1].tpage=lang2tpage;
						menutext[1][fecnt1].clut=lang2clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					backgroundloaded=1;
					twoplayer=0;
					exitcount=0;
					fadestatus=1;
				}
				SetPolyFT4(&refsprite[otid]);
				feottr=&(FeOT[otid][1]);
				AddPrim(feottr,&refsprite[otid]);
				if ((fepadread!=0)||(fepadread2!=0))
				{
					exitcount=0;
				}
				else
				{
					exitcount++;
				}
#ifdef NTSC
				if (exitcount>=1800)
#else
				if (exitocunt>=1500)
#endif
				{
					/* back to FMV */
					fegamestate=4;
					logoson=0;
					textboxeson=0;
#ifdef MUSIC
					KillSoundFE();
					VSyncCallback(0);
#endif

				}
				if ((fepadread==PAD_DOWN)||(fepadread2==PAD_DOWN))
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if ((fepadread==PAD_UP)||(fepadread2==PAD_UP))
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if (fepadread==PAD_TOPLEFT)
				{

//					temp for chirs

					fegamestate=16;
					nomenuopts=numloadedtracks;
					menuoption=52;
					backgroundloaded=0;
					logoson=0;
					textboxeson=0;
				}
				if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
				{
					switch (menuoption)
					{
						case (0):
						{
							if (currentsave.options[PAD_TYPE1]!=2)
							{
								fegamestate=7;
								nomenuopts=2;
								menuoption=0;
								backgroundloaded=0;
								logoson=0;
								textboxeson=0;
							}
							break;
						}
						case (1):
						{
							if ((currentsave.options[PAD_TYPE2]!=2)&&(currentsave.options[PAD_TYPE1]!=2))
							{
								fegamestate=8;
								nomenuopts=0;
								menuoption=0;
								backgroundloaded=0;
								logoson=0;
								textboxeson=0;
							}
							break;
						}
						case (2):
						{
							fegamestate=9;
							nomenuopts=0;
							menuoption=0;
							backgroundloaded=0;
							logoson=0;
							textboxeson=0;
							break;
						}
						case (3):
						{
							fegamestate=10;
							nomenuopts=0;
							menuoption=0;
							backgroundloaded=0;
							logoson=0;
							textboxeson=0;
							break;
						}
						case (4):
						{
							fegamestate=11;
							nomenuopts=0;
							menuoption=0;
							backgroundloaded=0;
							logoson=0;
							textboxeson=0;
							break;
						}
					}
				}
				break;
			}
			case (7):
			{
				/* 1 player  */
				if (backgroundloaded==0)
				{
					nomenuopts=2;
					menuoption=0;
					textboxeson=1;
					blackboxon=1;
					setuvs(&menutext[0][0],0,255,70,83);
					setuvs(&menutext[1][0],0,255,70,83);
					setuvs(&menutext[0][1],0,255,56,69);
					setuvs(&menutext[1][1],0,255,56,69);
					if (twoplayer==2)
					{
						menutext[0][0].tpage=lang3tpage;
						menutext[0][0].clut=lang3clut;
						menutext[1][0].tpage=lang3tpage;
						menutext[1][0].clut=lang3clut;
					}
					else
					{
						menutext[0][0].tpage=lang2tpage;
						menutext[0][0].clut=lang2clut;
						menutext[1][0].tpage=lang2tpage;
						menutext[1][0].clut=lang2clut;
					}
					menutext[0][1].tpage=lang3tpage;
					menutext[0][1].clut=lang3clut;
					menutext[1][1].tpage=lang3tpage;
					menutext[1][1].clut=lang3clut;
					blackbox[0].tpage=prelangtpage;
					blackbox[0].clut=prelangclut;
					blackbox[1].tpage=prelangtpage;
					blackbox[1].clut=prelangclut;
					flashvalue=0;
					flashcount=1;
					whichcharacter=0;
					backgroundloaded=1;
					fadestatus=1;
				}
				if (twoplayer==2)
				{
					whichplayer=1;
					fepadread=fepadread2;
					ConsolePlayers=2;
					NumberOfPlayers=2;
					Player[0].ConsoleRemoteGhosted = CONSOLE_PLAYER;
					Player[1].ConsoleRemoteGhosted = CONSOLE_PLAYER;
				}
				else
				{
					whichplayer=0;
					ConsolePlayers=1;
					if (currentsave.options[GHOST_SET]==1)
					{
						NumberOfPlayers=2;
						Player[1].ConsoleRemoteGhosted = GHOSTED_PLAYER;
					}
					else
					{
						NumberOfPlayers=1;
						Player[1].ConsoleRemoteGhosted = 0;

					}
					Player[0].ConsoleRemoteGhosted = CONSOLE_PLAYER;
				}
				for (fecnt1=0;fecnt1<3;fecnt1++)
				{
					uvchar(&Player[whichplayer].Name[fecnt1],&fenamepolys[otid][fecnt1]);
					fenamepolys[otid][fecnt1].tpage=tids[8].textpage;
					fenamepolys[otid][fecnt1].clut=tids[8].clutline[0];
					if (fecnt1!=whichcharacter)
					{
						setRGB0(&fenamepolys[otid][fecnt1],127,127,127);
					}
					else
					{
						setRGB0(&fenamepolys[otid][fecnt1],64+(flashvalue*4),flashvalue*8,(flashvalue*8));
						flashvalue+=flashcount;
						if (flashvalue==32)
						{
							flashvalue=30;
							flashcount=-1;
						}
						if (flashvalue==0)
						{
							flashcount=1;
						}
					}
				}
				if (fepadread==PAD_UP)
				{
					if (Player[whichplayer].Name[whichcharacter]==90)
					{
						Player[whichplayer].Name[whichcharacter]=48;
					}
					else
					{
						if (Player[whichplayer].Name[whichcharacter]==57)
						{
							Player[whichplayer].Name[whichcharacter]=65;
						}
						else
						{
							Player[whichplayer].Name[whichcharacter]++;
						}
					}
				}
				if (fepadread==PAD_DOWN)
				{
					if (Player[whichplayer].Name[whichcharacter]==65)
					{
						Player[whichplayer].Name[whichcharacter]=57;
					}
					else
					{
						if (Player[whichplayer].Name[whichcharacter]==48)
						{
							Player[whichplayer].Name[whichcharacter]=90;
						}
						else
						{
							Player[whichplayer].Name[whichcharacter]--;
						}
					}
				}

				if (fepadread==PAD_LEFT)
				{
					if (whichcharacter==0)
					{
						whichcharacter=2;
					}
					else
					{
						whichcharacter--;
					}
				}
				if (fepadread==PAD_RIGHT)
				{
					if (whichcharacter==2)
					{
						whichcharacter=0;
					}
					else
					{
						whichcharacter++;
					}
				}

				if (fepadread==PAD_B2)
				{
					fegamestate=12;
					backgroundloaded=0;
					textboxeson=0;
					blackboxon=0;
				}
				if (fepadread==PAD_B4)
				{
					if (twoplayer==2)
					{
						fegamestate=12;
						blackboxon=0;
						textboxeson=0;
						backgroundloaded=0;
						twoplayer=1;
					}
					else
					{
						fegamestate=6;
						blackboxon=0;
						textboxeson=0;
						backgroundloaded=0;
						nomenuopts=5;
						menuoption=0;
					}
				}
				break;
			}
			case (8):
			{
				fegamestate=7;
				backgroundloaded=0;
				twoplayer=1;
				break;
			}
			case (9):
			{
				/* Records */
				if (backgroundloaded==0)
				{
					nomenuopts=3;
					menuoption=0;
					thistrack=0;
					textboxeson=1;

					setuvs(&menutext[0][0],0,255,98,111);
					setuvs(&menutext[1][0],0,255,98,111);
					setuvs(&menutext[0][1],0,255,126,139);
					setuvs(&menutext[1][1],0,255,126,139);
					setuvs(&menutext[0][2],0,255,112,125);
					setuvs(&menutext[1][2],0,255,112,125);
					for (fecnt1=0;fecnt1<3;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang3tpage;
						menutext[0][fecnt1].clut=lang3clut;
						menutext[1][fecnt1].tpage=lang3tpage;
						menutext[1][fecnt1].clut=lang3clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					setXY4(&tracknopolys[0],240,134,256,134,240,149,256,149);
					setRGB0(&tracknopolys[0],127,127,127);
					setPolyFT4(&tracknopolys[0]);
					setXY4(&tracknopolys[1],240,134,256,134,240,149,256,149);
					setRGB0(&tracknopolys[1],127,127,127);
					setPolyFT4(&tracknopolys[1]);
					for (fecnt1=0;fecnt1<3;fecnt1++)
					{
						setRGB0(&name1polys[0][fecnt1],127,127,127);
						setXY4(&name1polys[0][fecnt1],216+(fecnt1*14),151,229+(fecnt1*14),151,216+(fecnt1*14),166,229+(fecnt1*14),166);
						setPolyFT4(&name1polys[0][fecnt1]);
			 			setRGB0(&name2polys[0][fecnt1],127,127,127);
						setXY4(&name2polys[0][fecnt1],216+(fecnt1*14),169,229+(fecnt1*14),169,216+(fecnt1*14),184,229+(fecnt1*14),184);
						setPolyFT4(&name2polys[0][fecnt1]);
						setRGB0(&name1polys[1][fecnt1],127,127,127);
						setXY4(&name1polys[1][fecnt1],216+(fecnt1*14),151,229+(fecnt1*14),151,216+(fecnt1*14),166,229+(fecnt1*14),166);
						setPolyFT4(&name1polys[1][fecnt1]);
			 			setRGB0(&name2polys[1][fecnt1],127,127,127);
						setXY4(&name2polys[1][fecnt1],216+(fecnt1*14),169,229+(fecnt1*14),169,216+(fecnt1*14),184,229+(fecnt1*14),184);
						setPolyFT4(&name2polys[1][fecnt1]);

					}
					if (currentsave.options[TRACK7_FOUND]==1)
					{
						tracksavailable=7;
					}
					else
					{
						if (currentsave.options[TRACK6_FOUND]==1)
						{
							tracksavailable=6;
						}
						else
						{
							tracksavailable=5;
						}
					}
					backgroundloaded=1;
					fadestatus=1;
				}

				chartemp=thistrack+49;
				uvchar(&chartemp,&tracknopolys[otid]);
				tracknopolys[otid].tpage=tids[8].textpage;
				tracknopolys[otid].clut=tids[8].clutline[0];
				AddPrim(&FeOT[otid],&tracknopolys[otid]);

				for (fecnt1=0;fecnt1<3;fecnt1++)
				{
					uvchar(&currentsave.records[thistrack][0].tname[fecnt1],&name1polys[otid][fecnt1]);
					name1polys[otid][fecnt1].tpage=tids[8].textpage;
					name1polys[otid][fecnt1].clut=tids[8].clutline[0];
					AddPrim(&FeOT[otid][1],&name1polys[otid][fecnt1]);
				}

				timestring=&timechars[0];
				hours=currentsave.records[thistrack][0].time/36000000;
				minutes=(currentsave.records[thistrack][0].time-(hours*36000000))/600000;
				seconds=(currentsave.records[thistrack][0].time-(hours*36000000)-(minutes*600000))/10000;
				decsecs=(currentsave.records[thistrack][0].time-(hours*36000000)-(minutes*600000)-(seconds*10000))/100;
				sprintf(timestring,"%02d:%02d:%02d\0",minutes,seconds,decsecs);
				for (Cnt=0;Cnt<10;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=14;
					if (timestring[Cnt]==':')
					{
						timecopyrect.x=712;	/* 704 + 16/2 */
						timecopyrect.y=304;  /* 256 + 48 */
					}
					else
					{
						timecopyrect.x=704;
						timecopyrect.y=256+((timestring[Cnt]-48)*14);
					}
					MoveImage(&timecopyrect,320+(Cnt*8),260);
				}
				setRGB0(&besttpolys[otid],127,127,127);
				besttpolys[otid].u0=0;
				besttpolys[otid].v0=4;
				besttpolys[otid].u1=128;
				besttpolys[otid].v1=4;
				besttpolys[otid].u2=0;
				besttpolys[otid].v2=17;
				besttpolys[otid].u3=128;
				besttpolys[otid].v3=17;
				besttpolys[otid].tpage=GetTPage(1,0,320,256);
				besttpolys[otid].clut=tids[8].clutline[0];
				setXY4(&besttpolys[otid],130,151,210,151,130,168,210,168);

				SetPolyFT4(&besttpolys[otid]);
				OTPtr=&(FeOT[otid][1]);
				AddPrim(OTPtr,&besttpolys[otid]);

				for (fecnt1=0;fecnt1<3;fecnt1++)
				{
					uvchar(&currentsave.records[thistrack][0].sname[fecnt1],&name2polys[otid][fecnt1]);
					name2polys[otid][fecnt1].tpage=tids[8].textpage;
					name2polys[otid][fecnt1].clut=tids[8].clutline[0];
					AddPrim(&FeOT[otid][1],&name2polys[otid][fecnt1]);
				}

				sprintf(timestring,"%07d\0",currentsave.records[thistrack][0].score);
				SetPolyFT4(&bestspolys[otid]);
				for (Cnt=0;Cnt<7;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=14;
					timecopyrect.x=704;
					timecopyrect.y=256+((timestring[Cnt]-48)*14);
					MoveImage(&timecopyrect,320+(Cnt*8),280);
				}
				bestspolys[otid].u0=0;
				bestspolys[otid].v0=24;
				bestspolys[otid].u1=111;
				bestspolys[otid].v1=24;
				bestspolys[otid].u2=0;
				bestspolys[otid].v2=38;
				bestspolys[otid].u3=111;
				bestspolys[otid].v3=38;
				bestspolys[otid].tpage=GetTPage(1,0,320,256);
				bestspolys[otid].clut=tids[8].clutline[0];
				setRGB0(&bestspolys[otid],127,127,127);
				setXY4(&bestspolys[otid],130,169,210,169,130,187,210,187);
				AddPrim(OTPtr,&bestspolys[otid]);
				if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT))
				{
					if (thistrack==0)
					{
						thistrack=tracksavailable-1;
					}
					else
					{
						thistrack--;
					}
				}
				if ((fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
				{
					if (thistrack==(tracksavailable-1))
					{
						thistrack=0;
					}
					else
					{
						thistrack++;
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=6;
					backgroundloaded=0;
					blackboxon=0;
					textboxeson=0;
					nomenuopts=5;
					menuoption=0;
				}

				break;
			}
			case (10):
			{
				/* Save/Load */
				if (backgroundloaded==0)
				{
					initmemcards();
#ifndef CD
					switch (language)
					{
						case (0):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (1):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (2):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (3):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (4):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
					}
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					switch(language)
					{
						case (0):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (1):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (2):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (3):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (4):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
					}
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					cardtpage=LoadTPage(gentimheader.paddr,1,0,448,256,256,256);  /* 96 */
					cardclut=LoadClut(gentimheader.caddr,448,511);
					for (fecnt1=0;fecnt1<5;fecnt1++)
					{
						menutext[0][fecnt1].tpage=cardtpage;
						menutext[0][fecnt1].clut=cardclut;
						menutext[1][fecnt1].tpage=cardtpage;
						menutext[1][fecnt1].clut=cardclut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}

					menuoption=0;
					tempwrite=0;
					backgroundloaded=1;
					fadestatus=1;
					textboxeson=1;
					cardscrstatus=0;
					nocardfiles=0;
					cardstatus=1; /* assume no card */
					setuvs(&menutext[0][0],0,200,0,13);
					setuvs(&menutext[1][0],0,200,0,13);
				}
				if ((fadestatus==0)&&(cardstatus!=0))
				{
					testcard(0);
					cardscrstatus=0;
				}
				if (cardstatus==1)
				{
					nomenuopts=1;
					if (fadestatus==0)
					{
						setuvs(&menutext[otid][0],0,200,56,69);
					}
					else
					{
						setuvs(&menutext[otid][fecnt1],0,200,154,167);
					}
				}
				else
				{
					nomenuopts=1;
					switch (cardscrstatus)
					{
						case (0):
						{
							setuvs(&menutext[otid][0],0,200,0,13);
							nocardfiles=carddirectory(0);
							if (nocardfiles==0)
							{
								cardscrstatus=1;
							}
							else
							{
								cardscrstatus=2;
								cstartfile=0;
								cendfile=nocardfiles-1;
								if (cendfile>4)
								{
									cendfile=4;
								}
							}
							break;
						}
						case (1):
						{
							/* no chill files */
							setuvs(&menutext[otid][0],0,200,140,153);
							break;
						}
						case (2):
						{
							/* display files */
							nomenuopts=nocardfiles;
							if (nomenuopts>5)
							{
								nomenuopts=5;
							}
							for (fecnt1=0;fecnt1<nomenuopts;fecnt1++)
							{
								setuvs(&menutext[otid][fecnt1],0,200,154,167);
								for (fecnt2=0;fecnt2<3;fecnt2++)
								{
									uvchar(&memfiles[cstartfile+fecnt1].name[13+fecnt2],&cardpolys[otid][fecnt1][fecnt2]);
									cardpolys[otid][fecnt1][fecnt2].tpage=tids[8].textpage;
									cardpolys[otid][fecnt1][fecnt2].clut=tids[8].clutline[0];
									AddPrim(&FeOT[otid][0],&cardpolys[otid][fecnt1][fecnt2]);
								}
							}
							if ((fepadread==PAD_UP)||(fepadread2==PAD_UP))
							{
								if (menuoption!=0)
								{
									if (cstartfile==0)
									{
									   menuoption--;
									}
									else
									{
										cstartfile--;
										cendfile--;
									}
								}
							}
							if ((fepadread==PAD_DOWN)||(fepadread2==PAD_DOWN))
							{
								if (menuoption==(nomenuopts-1))
								{
									if (cendfile==(nocardfiles-1))
									{
									}
									else
									{
										cstartfile++;
										cendfile++;
									}
								}
								else
								{
									menuoption++;
								}
							}
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								whichcardfile=menuoption+cstartfile;
								cardscrstatus=3;
							}
							break;
						}
						case (3):
						{
							nomenuopts=1;
							menuoption=0;
							setuvs(&menutext[otid][0],0,200,0,13);
							cardscrstatus=4;
							break;
						}
						case (4):
						{
							cardread(0,whichcardfile,&cdbuffer[270000]);
							fetexture=&currentsave;
							for (fecnt1=0;fecnt1<sizeof(currentsave);fecnt1++)
							{
								*(fetexture+fecnt1)=cdbuffer[270512+fecnt1];
							}
							for (fecnt1=0;fecnt1<3;fecnt1++)
							{
							   Player[0].Name[fecnt1]=currentsave.p1name[fecnt1];
							   Player[1].Name[fecnt1]=currentsave.p2name[fecnt1];
							}
							currentsave.options[PAD_TYPE1]=Pad_Type(0)-1;
							currentsave.options[PAD_TYPE2]=Pad_Type(1)-1;

							setuvs(&menutext[otid][0],0,200,0,13);
							if (cardstatus==3)
							{
								cardscrstatus=5;
								cardwaitcnt=0;
								cardstatus=0;
							}
							else
							{
								cardscrstatus=6;
							}
							break;
						}
						case (5):
						{
							setuvs(&menutext[otid][0],0,200,42,55);
							if (cardwaitcnt>100)
							{
								cardscrstatus=0;
								cardstatus=3;
							}
							else
							{
								cardstatus=0;
								cardwaitcnt++;
							}
							break;
						}
						case (6):
						{
							setuvs(&menutext[otid][0],0,200,28,41);
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								fepadread=PAD_B4;
							}

							break;
						}
					}
				}
				if (fepadread==PAD_BL)
				{
					fegamestate=22;
					backgroundloaded=0;
					nomenuopts=5;
					menuoption=0;
					blackboxon=0;
					textboxeson=0;
				}

				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					killmemcards();
					fegamestate=6;
					backgroundloaded=0;
					nomenuopts=5;
					menuoption=0;
					blackboxon=0;
					textboxeson=0;

				}
				break;
			}
			case (11):
			{
				if (backgroundloaded==0)
				{
					textboxeson=1;
					nomenuopts=4;
					menuoption=0;
					blackbox[0].tpage=prelangtpage;
					blackbox[0].clut=prelangclut;
					blackbox[1].tpage=prelangtpage;
					blackbox[1].clut=prelangclut;
					setuvs(&menutext[0][0],0,255,42,55);
					setuvs(&menutext[1][0],0,255,42,55);
					menutext[0][0].tpage=langtpage;
					menutext[0][0].clut=langclut;
					menutext[1][0].tpage=langtpage;
					menutext[1][0].clut=langclut;
					setuvs(&menutext[0][1],0,255,84,97);
					setuvs(&menutext[0][2],0,255,126,139);
					setuvs(&menutext[0][3],0,255,140,153);
					setuvs(&menutext[1][1],0,255,84,97);
					setuvs(&menutext[1][2],0,255,126,139);
					setuvs(&menutext[1][3],0,255,140,153);
					for (fecnt1=1;fecnt1<4;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang2tpage;
						menutext[0][fecnt1].clut=lang2clut;
						menutext[1][fecnt1].tpage=lang2tpage;
						menutext[1][fecnt1].clut=lang2clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					backgroundloaded=1;
					fadestatus=1;
				}
				switch (menuoption)
				{
					case (0):
					{
						blackboxon=0;
						break;
					}
					case (1):
					{
						blackboxon=1;
						if (currentsave.options[SPLIT_SET]==0)
						{
							setuvs(&blackboxtext[otid],0,255,98,111);
						}
						else
						{
							setuvs(&blackboxtext[otid],0,255,112,125);
						}
						setRGB0(&blackboxtext[otid],127,127,127);
						setXY4(&blackboxtext[otid],60,212,266,212,60,225,266,225);
						blackboxtext[otid].tpage=lang2tpage;
						blackboxtext[otid].clut=lang2clut;
						setPolyFT4(&blackboxtext[otid]);
						if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT)||(fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
						{
							currentsave.options[SPLIT_SET]=(currentsave.options[SPLIT_SET]+1)%2;
						}
						break;
					}
					case (2):
					{
						blackboxon=1;
						if (currentsave.options[GHOST_SET]==1)
						{
							setuvs(&blackboxtext[otid],128,255,224,237);
						}
						else
						{
							setuvs(&blackboxtext[otid],128,255,238,251);
						}
						setRGB0(&blackboxtext[otid],127,127,127);
						setXY4(&blackboxtext[otid],134,212,266,212,134,225,266,225);
						blackboxtext[otid].tpage=lang2tpage;
						blackboxtext[otid].clut=lang2clut;
						setPolyFT4(&blackboxtext[otid]);
						if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT)||(fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
						{
							currentsave.options[GHOST_SET]=(currentsave.options[GHOST_SET]+1)%2;
						}

						break;
					}
					case (3):
					{
						blackboxon=0;
						break;
					}
				}
				if ((fepadread==PAD_DOWN)||(fepadread2==PAD_DOWN))
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if ((fepadread==PAD_UP)||(fepadread2==PAD_UP))
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=6;
					backgroundloaded=0;
					nomenuopts=5;
					menuoption=0;
					blackboxon=0;
					textboxeson=0;
				}
				if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
				{
					switch (menuoption)
					{
						case (0):
						{
							fegamestate=20;
							backgroundloaded=0;
							nomenuopts=4;
							menuoption=0;
							break;
						}
						case (1):
						{
							break;
						}
						case (2):
						{
							break;
						}
						case (3):
						{
							fegamestate=21;
							backgroundloaded=0;
							break;
						}
					}
				}
				/* options */
				break;
			}
			case (12):
			{
				/* 1 player character board select */
				if (backgroundloaded==0)
				{
//					InitialiseGame();
/*
#ifndef CD
					fefin			=	PCopen( "textures/page8.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	&cdbuffer[180000];
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\PAGE8.TIM;1",&cdbuffer[180000]);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(&cdbuffer[180000]);
					ReadTIM(&gentimheader);
					tids[7].textpage=LoadTPage(gentimheader.paddr,1,0,576,256,256,256);
					tids[7].clutline[0]=LoadClut(gentimheader.caddr,768,291);  */
					InitialisePlayers();
					Player[whichplayer].Character=chosenchar[whichplayer]+1;
					Initialise_Skeleton();
					InitBoardModel();
					Player[0].Cam.Mode=CAMERA_TEST_TARGET;
					InitCameraModel(0);
					textboxeson=1;
					nomenuopts=4;
					menuoption=1;
					setuvs(&menutext[0][0],0,255,70,83);
					setuvs(&menutext[1][0],0,255,70,83);
					if (twoplayer==2)
					{
						menutext[0][0].tpage=lang3tpage;
						menutext[0][0].clut=lang3clut;
						menutext[1][0].tpage=lang3tpage;
						menutext[1][0].clut=lang3clut;
						whichplayer=1;
					}
					else
					{
						menutext[0][0].tpage=lang2tpage;
						menutext[0][0].clut=lang2clut;
						menutext[1][0].tpage=lang2tpage;
						menutext[1][0].clut=lang2clut;
						whichplayer=0;
					}
					setuvs(&menutext[0][2],0,255,196,209);
					setuvs(&menutext[0][3],0,255,210,223);
					setuvs(&menutext[1][2],0,255,196,209);
					setuvs(&menutext[1][3],0,255,210,223);
					for (fecnt1=1;fecnt1<4;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang3tpage;
						menutext[0][fecnt1].clut=lang3clut;
						menutext[1][fecnt1].tpage=lang3tpage;
						menutext[1][fecnt1].clut=lang3clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					boardno[whichplayer]=0;
					outfitno[whichplayer]=0;
#ifndef CD
					fefin			=	PCopen("textures/boards/bordtext.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\BOARDS\\BORDTEXT.TIM;1",cdbuffer+180000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					boardnametpage=LoadTPage(gentimheader.paddr,1,0,448,256,256,256);  /* 96 */
					boardnameclut=LoadClut(gentimheader.caddr,448,511);
					boardnamepoly[0].tpage=boardnametpage;
					boardnamepoly[0].clut=boardnameclut;
					boardnamepoly[1].tpage=boardnametpage;
					boardnamepoly[1].clut=boardnameclut;
					loadboard=1;
					backgroundloaded=1;
					btransmatrix.t[0]=-160;
					btransmatrix.t[1]=300;
					btransmatrix.t[2]=500;
					brotvec.vx=0;
					brotvec.vy=324;
					brotvec.vz=0;
					bvertrotvec.vx=0;
					bvertrotvec.vy=1024;
					bvertrotvec.vz=0;
					fadestatus=1;
				}
				if (loadboard==1)
				{
#ifndef CD
					sprintf(&fullboardfilename[0],"textures/boards/%s\0",&boardnames[boardno[whichplayer]]);
					fefin			=	PCopen(&fullboardfilename, 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					sprintf(&fullboardfilename[0],"\\TEXTURES\\BOARDS\\%s;1",&boardnames[boardno[whichplayer]]);
					load_cd(&fullboardfilename[0],cdbuffer+180000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					boardtpage=LoadTPage(gentimheader.paddr,1,0,960,0,128,128);  /* 96 */
					boardclut=LoadClut(gentimheader.caddr,448,510);
					loadboard=0;
				}

				if (boardno[whichplayer]<11)
				{
					setuvs(&boardnamepoly[otid],12,118,boardtextuvs[boardno[whichplayer]][0],boardtextuvs[boardno[whichplayer]][1]);
				}
				else
				{
					setuvs(&boardnamepoly[otid],140,246,boardtextuvs[boardno[whichplayer]][0],boardtextuvs[boardno[whichplayer]][1]);
				}
				/* rotate vertices */
				gte_SetTransMatrix(&btransmatrix);
				RotMatrix(&brotvec,&brotmatrix);
				RotMatrix(&bvertrotvec,&bvertrotmatrix);
				for (fecnt1=0;fecnt1<4;fecnt1++)
				{
					ApplyMatrixSV(&bvertrotmatrix,&sbverts[fecnt1],&sbverts[fecnt1+4]);
				}
				gte_SetRotMatrix(&brotmatrix);
				gte_ldv3(&sbverts[4],&sbverts[5],&sbverts[6]);
				gte_rtpt();
				gte_stsxy3(vertstoreaddr,vertstoreaddr+1,vertstoreaddr+2);
				gte_ldv0(&sbverts[7]);
				gte_rtps();
				gte_stsxy(vertstoreaddr+3);
				gte_NormalClip(*vertstoreaddr,*(vertstoreaddr+2),*(vertstoreaddr+1),&feouter);
				if (feouter>=0)
				{
					setuvs(&leftbpoly[otid],0,63,0,127);
				}
				else
				{
					setuvs(&leftbpoly[otid],64,127,0,127);
				}
				*(uint32 *)&(leftbpoly[otid].x0)=((*vertstoreaddr)&0xffff)<<16|(((*vertstoreaddr)&0xffff0000)>>16);
				*(uint32 *)&(leftbpoly[otid].x1)=((*(vertstoreaddr+1))&0xffff)<<16|((*(vertstoreaddr+1))&0xffff0000)>>16;
				*(uint32 *)&(leftbpoly[otid].x2)=((*(vertstoreaddr+2))&0xffff)<<16|((*(vertstoreaddr+2))&0xffff0000)>>16;
				*(uint32 *)&(leftbpoly[otid].x3)=((*(vertstoreaddr+3))&0xffff)<<16|((*(vertstoreaddr+3))&0xffff0000)>>16;
				leftbpoly[otid].tpage=boardtpage;
				leftbpoly[otid].clut=boardclut;
				AddPrim(FeOT[otid][1],&leftbpoly[otid]);

				AddPrim(FeOT[otid][1],&boardnamepoly[otid]);
				bvertrotvec.vx+=0x20;
				bvertrotvec.vx&=0xfff;
//				brotvec.vy++;
//				brotvec.vy&=0xfff;

				setuvs(&menutext[otid][1],0,255,140+(chosenchar[whichplayer]*14),153+(chosenchar[whichplayer]*14));
				chartemp=outfitno[whichplayer]+48;
				uvchar(&chartemp,&outnopoly[otid]);
				outnopoly[otid].tpage=tids[8].textpage;
				outnopoly[otid].clut=tids[8].clutline[0];
				AddPrim(&FeOT[otid][1],&outnopoly[otid]);
				if (whichplayer==1)
				{
					fepadread=fepadread2;
				}
				if (fepadread==PAD_LEFT)
				{
					if (menuoption==1)
					{
						if (chosenchar[whichplayer]==0)
						{
							chosenchar[whichplayer]=3;
						}
						else
						{
							chosenchar[whichplayer]--;
						}
						Player[whichplayer].Character=chosenchar[whichplayer]+1;
						Initialise_Skeleton();
						/* load new player textures / switch player models */
					}
					if (menuoption==2)
					{
						if (boardno[whichplayer]==0)
						{
							boardno[whichplayer]=20;
						}
						else
						{
							boardno[whichplayer]--;
						}
						loadboard=1;
						/* load new board graphic */
					}
					if (menuoption==3)
					{
						if (outfitno[whichplayer]==0)
						{
							outfitno[whichplayer]=3;
						}
						else
						{
							outfitno[whichplayer]--;
						}
						Player[whichplayer].Suit=outfitno[whichplayer]%2;
						Initialise_Skeleton();
						/* urr, fuck knows what to do here. */
					}
				}
				if (fepadread==PAD_RIGHT)
				{
					if (menuoption==1)
					{
						if (chosenchar[whichplayer]==3)
						{
							chosenchar[whichplayer]=0;
						}
						else
						{
							chosenchar[whichplayer]++;
						}
						Player[whichplayer].Character=chosenchar[whichplayer]+1;
						Initialise_Skeleton();
						/* load new player textures / switch player models */
					}
					if (menuoption==2)
					{
						if (boardno[whichplayer]==20)
						{
							boardno[whichplayer]=0;
						}
						else
						{
							boardno[whichplayer]++;
						}
						loadboard=1;
						/* load new board graphic */
					}
					if (menuoption==3)
					{
						if (outfitno[whichplayer]==3)
						{
							outfitno[whichplayer]=0;
						}
						else
						{
							outfitno[whichplayer]++;
						}
						/* urr, fuck knows what to do here. */
						Player[whichplayer].Suit=outfitno[whichplayer]%2;
						Initialise_Skeleton();
					}
				}
				if (fepadread==PAD_UP)
				{
					if (menuoption==1)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if (fepadread==PAD_DOWN)
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=1;
					}
					else
					{
						menuoption++;
					}
				}
				SetGeomOffset(120,160);
				SetGeomScreen(256);
//				Player[0].Pos.X=0;
//				Player[0].Pos.Y=0;
//				Player[0].Pos.Z=0;
//				Player[0].Rot.Y=0;
				Refresh_Skeleton();
				ClearOTagR(OrderingTable[otid],OTLENGTH);
				Ingame=0;
				Draw_Character(whichplayer,0);
				AddPrims(&FeOT[otid][1],&OrderingTable[otid][OTLENGTH-1],&OrderingTable[otid][0]);
				CameraLogic(0);

				if (fepadread==PAD_B4)
				{
					fegamestate=7;
					backgroundloaded=0;
				}
				if (fepadread==PAD_B2)
				{
					if (twoplayer==1)
					{
						fegamestate=7;
						backgroundloaded=0;
						logoson=0;
						textboxeson=0;
						twoplayer=2;
					}
					else
					{
						fegamestate=13;
//						nomenuopts=numloadedtracks;
//						menuoption=52
						backgroundloaded=0;
						logoson=0;
						textboxeson=0;
					}
				}
				break;
			}
			case (13):
			{
				/* 1 & 2 player track select */
				if (backgroundloaded==0)
				{
					nomenuopts=3;
					menuoption=0;
					textboxeson=1;
					if (twoplayer==2)
					{
						setuvs(&menutext[0][0],0,255,14,27);
						setuvs(&menutext[1][0],0,255,14,27);
					}
					else
					{
						setuvs(&menutext[0][0],0,255,0,13);
						setuvs(&menutext[1][0],0,255,0,13);
					}
					menutext[0][0].tpage=lang2tpage;
					menutext[0][0].clut=lang2clut;
					menutext[1][0].tpage=lang2tpage;
					menutext[1][0].clut=lang2clut;


					setuvs(&menutext[0][1],0,255,98,111);
					setuvs(&menutext[1][1],0,255,98,111);
//					setuvs(&menutext[0][2],0,255,126,139);
//					setuvs(&menutext[1][2],0,255,126,139);
					menutext[0][1].tpage=lang3tpage;
					menutext[0][1].clut=lang3clut;
					menutext[1][1].tpage=lang3tpage;
					menutext[1][1].clut=lang3clut;
//					menutext[0][2].tpage=langtpage;
//					menutext[0][2].clut=langclut;
//					menutext[1][2].tpage=langtpage;
//					menutext[1][2].clut=langclut;
					for (fecnt1=0;fecnt1<3;fecnt1++)
					{
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					setXY4(&tracknopolys[0],240,151,256,151,240,167,256,167);
					setRGB0(&tracknopolys[0],127,127,127);
					setPolyFT4(&tracknopolys[0]);
					setXY4(&tracknopolys[1],240,151,256,151,240,167,256,167);
					setRGB0(&tracknopolys[1],127,127,127);
					setPolyFT4(&tracknopolys[1]);
					if (currentsave.options[TRACK7_FOUND]==1)
					{
						tracksavailable=7;
					}
					else
					{
						if (currentsave.options[TRACK6_FOUND]==1)
						{
							tracksavailable=6;
						}
						else
						{
							tracksavailable=5;
						}
					}
					if (ConsolePlayers==1)
					{
						thistrack=0;
					}
					else
					{
						thistrack=1;
					}
					backgroundloaded=1;
					fadestatus=1;
				}
				chartemp=thistrack+49;
				uvchar(&chartemp,&tracknopolys[otid]);
				tracknopolys[otid].tpage=tids[8].textpage;
				tracknopolys[otid].clut=tids[8].clutline[0];
				AddPrim(&FeOT[otid][0],&tracknopolys[otid]);
				if (thistrack<5)
				{
					menutext[otid][2].tpage=langtpage;
					menutext[otid][2].clut=langclut;
					setuvs(&menutext[otid][2],0,255,126+(thistrack*14),139+(thistrack*14));
				}
				else
				{
					menutext[otid][2].tpage=lang3tpage;
					menutext[otid][2].clut=lang3clut;
					setuvs(&menutext[otid][2],0,255,224+((thistrack-5)*14),237+((thistrack-5)*14));	/* temp */
				}

				if (fepadread==PAD_B4)
				{
					fegamestate=12;
					backgroundloaded=0;
				}
				if (fepadread==PAD_LEFT)
				{
					if (thistrack==0)
					{
						thistrack=tracksavailable-1;
					}
					else
					{
						thistrack--;
					}
				}
				if (fepadread==PAD_RIGHT)
				{
					if (thistrack==(tracksavailable-1))
					{
						thistrack=0;
					}
					else
					{
						thistrack++;
					}
				}
				if (fepadread==PAD_B2)
				{
					thismount=thistrack;
					switch(thistrack)
					{
						case (0):
						case (1):
						case (3):
						case (4):
						{
							if (twoplayer==2)
							{
								if (thistrack==1)
								{
									fegamestate=15;
									stgamestate=15;
								}
							}
							else
							{
								fegamestate=15;
								stgamestate=15;
							}
#ifdef MUSIC
							SsSepSetDecrescendo(sep1,0,((currentsave.options[MUSIC_VOLUME]*127)/30)-1,600);
#endif
							break;
						}
						default:
						{
							break;
						}
					}
				}
				if (twoplayer==2)
				{
					if (fepadread2==PAD_B4)
					{
						fegamestate=12;
						backgroundloaded=0;
					}
					if (fepadread2==PAD_LEFT)
					{
						if (thistrack==0)
						{
							thistrack=tracksavailable-1;
						}
						else
						{
							thistrack--;
						}
					}
					if (fepadread2==PAD_RIGHT)
					{
						if (thistrack==(tracksavailable-1))
						{
							thistrack=0;
						}
						else
						{
							thistrack++;
						}
					}
					if (fepadread2==PAD_B2)
					{
						switch(thistrack)
						{
							case (0):
							case (1):
							case (3):
							case (4):
							{
								if (twoplayer==2)
								{
									if (thistrack==1)
									{
										fegamestate=15;
										stgamestate=15;
									}
								}
								else
								{
									fegamestate=15;
									stgamestate=15;
								}
#ifdef MUSIC
								SsSepSetDecrescendo(sep1,0,((currentsave.options[MUSIC_VOLUME]*127)/30)-1,600);
#endif
								break;
							}
							default:
							{
								break;
							}
						}
					}
				}
				break;
			}
			case (14):
			{
				/* 2 player track select */
				break;
			}
			case (15):
			{
				RemotePlayers=currentsave.options[GHOST_SET];
				FntLoad(960,0);
				fntid1 = FntOpen(45,15,250,8,0,50);
				SetDumpFnt(fntid1);
				fntid2 = FntOpen(45,24,250,8,0,50);
				SetDumpFnt(fntid2);
				fntid3 = FntOpen(45,33,250,9,0,50);
				SetDumpFnt(fntid3);
				thismount=1;

				/* run engine */
				initobjects();
				InitialiseGame();
				starttrack=Mountain[thistrack].starttrack;
				musiccat=rand()%4;
				if (musiccat==3)
				{
					tuneno=rand()%5;
					tuneno=rand()%5;
				}
				else
				{
					tuneno=rand()%2;
				}
//					menuoption=Mountain[thismount].challenges[thischallenge].starttrack;
//					menuoption=52
				InitialisePlayers();
				RunGameLoop(menuoption);
				otid=0;
				display_id=0;
				SetDispMask(0);
				FntLoad(960,256);
				fntid1 = FntOpen(45,215,250,8,0,50);
				SetDumpFnt(fntid1);
#ifdef MUSIC
				VSyncCallback(0);

				KillSoundFE();
				musiccat=4;
				tuneno=0;
				InitialiseSound(0);
				VSyncCallback(&SoundCallBack);
#endif

				fegamestate=18;
				backgroundloaded=0;
				nomenuopts=0;
				menuoption=0;
				loadcurrentscreens();
				break;
			}
			case (16):
			{
				/* piste selection screen */
				if (backgroundloaded==0)
				{
//					InitialiseGame();
#ifndef CD
					fefin			=	PCopen( "textures/page8.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\PAGE8.TIM;1",cdbuffer+180000);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					tids[7].textpage=LoadTPage(gentimheader.paddr,1,0,576,256,256,256);  /* 96 */
					tids[7].clutline[0]=LoadClut(gentimheader.caddr,768,291);

					Initialise_Skeleton();
					InitBoardModel();
					backgroundloaded=1;
				}
				FntPrint(fntid1,"Track no %d\n",menuoption);
				if (fepadread==PAD_UP)
				{
					if (menuoption==0)
					{
						menuoption=numloadedtracks-1;
					}
					else
					{
						menuoption--;
					}
				}
				if (fepadread==PAD_DOWN)
				{
					if (menuoption==(numloadedtracks-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=6;
					backgroundloaded=0;
					nomenuopts=5;
					menuoption=0;
				}

				if (fepadread==PAD_B2)
				{
					FntLoad(960,0);
					fntid1 = FntOpen(45,15,250,8,0,50);
					SetDumpFnt(fntid1);
					fntid2 = FntOpen(45,24,250,8,0,50);
					SetDumpFnt(fntid2);
					fntid3 = FntOpen(45,33,250,9,0,50);
					SetDumpFnt(fntid3);
					thismount=thistrack=3;

					/* run engine */
					initobjects();
					InitialiseGame();
					musiccat=rand()%4;
					if (musiccat==3)
					{
						tuneno=rand()%5;
					}
					else
					{
						tuneno=rand()%2;
					}
//					menuoption=Mountain[thismount].challenges[thischallenge].starttrack;
//					menuoption=52
					thistrack=9;
					InitialisePlayers();
					RunGameLoop(menuoption);
					otid=0;
					display_id=0;
					SetDispMask(0);
					FntLoad(960,256);
					fntid1 = FntOpen(45,215,250,8,0,50);
					SetDumpFnt(fntid1);

					fegamestate=18;
					backgroundloaded=0;
					nomenuopts=3;
					menuoption=0;
					loadcurrentscreens();
				}
				break;
			}
			case (17):
			{
				/* time trial selection screen, time trial records */
				if (backgroundloaded==0)
				{
#ifndef CD
					fefin			=	PCopen( "textures/pistebak.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+48;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\PISTEBAK.TIM;1",cdbuffer+48);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+48);
					ReadTIM(&fetimheader);
					backgroundloaded=1;
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=15;
				}
				if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
				{
					/* run game */

					fegamestate=18;
					backgroundloaded=0;
					nomenuopts=3;
					menuoption=0;
				}

				break;
			}
			case (18):
			{
				/* race results screen - continue,exit,save */
				if (backgroundloaded==0)
				{
/*
#ifndef CD
					fefin			=	PCopen( "textures/scrscrn.tim", 0, 0 );
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	&cdbuffer;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					load_cd("\\TEXTURES\\SCRSCRN.TIM;1",&cdbuffer);
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(&cdbuffer);
					ReadTIM(&fetimheader);	*/
					backgroundloaded=1;
					lasttime=globaltime[0];
					if (ConsolePlayers==2)
					{
						if (globaltime[1]<lasttime)
						{
							lasttime=globaltime[1];
						}
					}
					if (lasttime!=0)
					{
						if (lasttime<besttime)
						{
							besttime=lasttime;
						}
						if (lastscore>bestscore)
						{
							bestscore=lastscore;
						}
					}
					restimeout=0;
				}
				SetDispMask(1);
				timestring=&timechars[0];
				hours=lasttime/36000000;
				minutes=(lasttime-(hours*36000000))/600000;
				seconds=(lasttime-(hours*36000000)-(minutes*600000))/10000;
				decsecs=(lasttime-(hours*36000000)-(minutes*600000)-(seconds*10000))/100;
				sprintf(timestring,"%02d:%02d:%02d\0",minutes,seconds,decsecs);
				for (Cnt=0;Cnt<10;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=14;
					if (timestring[Cnt]==':')
					{
						timecopyrect.x=712;	/* 704 + 16/2 */
						timecopyrect.y=304;  /* 256 + 48 */
					}
					else
					{
						timecopyrect.x=704;
						timecopyrect.y=256+((timestring[Cnt]-48)*14);
					}
					MoveImage(&timecopyrect,320+(Cnt*8),239);
				}
				setRGB0(&lasttpolys[otid],127,127,127);
				lasttpolys[otid].u0=0;
				lasttpolys[otid].v0=239;
				lasttpolys[otid].u1=128;
				lasttpolys[otid].v1=239;
				lasttpolys[otid].u2=0;
				lasttpolys[otid].v2=253;
				lasttpolys[otid].u3=128;
				lasttpolys[otid].v3=253;
				lasttpolys[otid].tpage=tids[0].textpage;
				lasttpolys[otid].clut=tids[8].clutline[0];
				setXY4(&lasttpolys[otid],182,72,310,72,182,88,310,88);

				SetPolyFT4(&lasttpolys[otid]);
				OTPtr=&(FeOT[otid][1]);
				AddPrim(OTPtr,&lasttpolys[otid]);

/*				sprintf(timestring,"%07d\0",lastscore);
				SetPolyFT4(&lastspolys[otid]);
				for (Cnt=0;Cnt<7;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=16;
					timecopyrect.x=704;
					timecopyrect.y=256+((timestring[Cnt]-48)*16);
					MoveImage(&timecopyrect,320+(Cnt*8),222);
				}
				setRGB0(&lastspolys[otid],127,127,127);
				lastspolys[otid].u0=0;
				lastspolys[otid].v0=222;
				lastspolys[otid].u1=111;
				lastspolys[otid].v1=222;
				lastspolys[otid].u2=0;
				lastspolys[otid].v2=238;
				lastspolys[otid].u3=111;
				lastspolys[otid].v3=238;
				lastspolys[otid].tpage=tids[0].textpage;
				lastspolys[otid].clut=tids[8].clutline[0];
				setXY4(&lastspolys[otid],197,94,310,94,197,110,310,110);
				AddPrim(OTPtr,&lastspolys[otid]);	*/

				timestring=&timechars[0];
				hours=besttime/36000000;
				minutes=(besttime-(hours*36000000))/600000;
				seconds=(besttime-(hours*36000000)-(minutes*600000))/10000;
				decsecs=(besttime-(hours*36000000)-(minutes*600000)-(seconds*10000))/100;
				sprintf(timestring,"%02d:%02d:%02d\0",minutes,seconds,decsecs);
				for (Cnt=0;Cnt<10;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=14;
					if (timestring[Cnt]==':')
					{
						timecopyrect.x=712;	/* 704 + 16/2 */
						timecopyrect.y=304;  /* 256 + 48 */
					}
					else
					{
						timecopyrect.x=704;
						timecopyrect.y=256+((timestring[Cnt]-48)*14);
					}
					MoveImage(&timecopyrect,320+(Cnt*8),150);
				}
				setRGB0(&besttpolys[otid],127,127,127);
				besttpolys[otid].u0=0;
				besttpolys[otid].v0=150;
				besttpolys[otid].u1=128;
				besttpolys[otid].v1=150;
				besttpolys[otid].u2=0;
				besttpolys[otid].v2=163;
				besttpolys[otid].u3=128;
				besttpolys[otid].v3=163;
				besttpolys[otid].tpage=tids[0].textpage;
				besttpolys[otid].clut=tids[8].clutline[0];
				setXY4(&besttpolys[otid],182,142,310,142,182,157,310,157);

				SetPolyFT4(&besttpolys[otid]);
				OTPtr=&(FeOT[otid][1]);
				AddPrim(OTPtr,&besttpolys[otid]);

/*				sprintf(timestring,"%07d\0",bestscore);
				SetPolyFT4(&bestspolys[otid]);
				for (Cnt=0;Cnt<7;Cnt++)
				{
					timecopyrect.w=8;
					timecopyrect.h=16;
					timecopyrect.x=704;
					timecopyrect.y=256+((timestring[Cnt]-48)*16);
					MoveImage(&timecopyrect,320+(Cnt*8),130);
				}
				bestspolys[otid].u0=0;
				bestspolys[otid].v0=130;
				bestspolys[otid].u1=111;
				bestspolys[otid].v1=130;
				bestspolys[otid].u2=0;
				bestspolys[otid].v2=146;
				bestspolys[otid].u3=111;
				bestspolys[otid].v3=146;
				bestspolys[otid].tpage=tids[0].textpage;
				bestspolys[otid].clut=tids[8].clutline[0];
				setRGB0(&bestspolys[otid],127,127,127);
				setXY4(&bestspolys[otid],197,164,310,164,197,180,310,180);
				AddPrim(OTPtr,&bestspolys[otid]);	*/

/*				if (fepadread==PAD_LEFT)
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if (fepadread2==PAD_LEFT)
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if (fepadread==PAD_RIGHT)
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if (fepadread2==PAD_RIGHT)
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}   */
				if ((fepadread==PAD_B2)||(fepadread2==PAD_B2)||(restimeout>3600))
				{
/*					switch(menuoption)
					{
						case (0):
						{	*/
						    fegamestate=13;
							menuoption=0;
							backgroundloaded=0;
/*						    break;
						}
						case (1):
						{
							fegamestate=4;
							nomenuopts=5;
							menuoption=0;

							break;
						}
						case (2):
						{
							fegamestate=19;
							break;
						}
					}   */
				}
				restimeout++;
				break;
			}
			case (20):
			{
				if (backgroundloaded==0)
				{
					textboxeson=1;
					nomenuopts=3;
					menuoption=0;
					menutext[0][0].tpage=langtpage;
					menutext[0][0].clut=langclut;
					menutext[1][0].tpage=langtpage;
					menutext[1][0].clut=langclut;
//					menutext[0][1].tpage=langtpage;
//					menutext[0][1].clut=langclut;
//					menutext[1][1].tpage=langtpage;
//					menutext[1][1].clut=langclut;
//					setuvs(&menutext[0][1],0,255,98,111);
					setuvs(&menutext[0][1],0,255,196,209);
					setuvs(&menutext[0][2],0,255,210,223);
//					setuvs(&menutext[1][1],0,255,98,111);
					setuvs(&menutext[1][1],0,255,196,209);
					setuvs(&menutext[1][2],0,255,210,223);
					for (fecnt1=1;fecnt1<3;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang2tpage;
						menutext[0][fecnt1].clut=lang2clut;
						menutext[1][fecnt1].tpage=lang2tpage;
						menutext[1][fecnt1].clut=lang2clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					for (fecnt1=0;fecnt1<30;fecnt1++)
					{
						barpolys[0][fecnt1].tpage=prelangtpage;
						barpolys[0][fecnt1].clut=prelangclut;
						barpolys[1][fecnt1].tpage=prelangtpage;
						barpolys[1][fecnt1].clut=prelangclut;
					}
					backgroundloaded=1;
					fadestatus=1;
				}
				if (currentsave.options[STEREO_SET]==1)
				{
					setuvs(&menutext[otid][0],0,255,84,97);
				}
				else
				{
					setuvs(&menutext[otid][0],0,255,70,83);
				}
				switch (menuoption)
				{
					case (0):
					{
						blackboxon=0;
						if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT)||(fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
						{
							currentsave.options[STEREO_SET]=(currentsave.options[STEREO_SET]+1)%2;
							if (currentsave.options[STEREO_SET]==1)
							{
								SsSetStereo();
							}
							else
							{
								SsSetMono();
							}
						}
						break;
					}
/*					case (1):
					{
						blackboxon=1;
						if (currentsave.options[DOLBY_SET]==1)
						{
							setuvs(&blackboxtext[otid],128,255,224,237);
						}
						else
						{
							setuvs(&blackboxtext[otid],128,255,238,251);
						}
						setRGB0(&blackboxtext[otid],127,127,127);
						setXY4(&blackboxtext[otid],134,212,266,212,134,225,266,225);
						blackboxtext[otid].tpage=lang2tpage;
						blackboxtext[otid].clut=lang2clut;
						setPolyFT4(&blackboxtext[otid]);
						if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT)||(fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
						{
							currentsave.options[DOLBY_SET]=(currentsave.options[DOLBY_SET]+1)%2;
						}
						break;
					}	*/
					case (1):
					{
						blackboxon=1;
						break;
					}
					case (2):
					{
						blackboxon=1;
						break;
					}
				}
				if ((fepadread==PAD_DOWN)||(fepadread2==PAD_DOWN))
				{
					if (menuoption==(nomenuopts-1))
					{
						menuoption=0;
					}
					else
					{
						menuoption++;
					}
				}
				if ((fepadread==PAD_UP)||(fepadread2==PAD_UP))
				{
					if (menuoption==0)
					{
						menuoption=nomenuopts-1;
					}
					else
					{
						menuoption--;
					}
				}
				if ((Pad_State(0)==PAD_LEFT)||(Pad_State(1)==PAD_LEFT))
				{
					switch(menuoption)
					{
						case (0):
						{
							break;
						}
/*						case (1):
						{
							break;
						}         */
						case (1):
						{
							if (currentsave.options[SFX_VOLUME]!=0)
							{
								currentsave.options[SFX_VOLUME]--;

							}
							break;
						}
						case (2):
						{
							if (currentsave.options[MUSIC_VOLUME]!=0)
							{
								currentsave.options[MUSIC_VOLUME]--;
#ifdef MUSIC
								SsSepSetVol(sep1, 0, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
#endif
							}
							break;
						}
					}
				}
				if ((Pad_State(0)==PAD_RIGHT)||(Pad_State(1)==PAD_RIGHT))
				{
					switch(menuoption)
					{
						case (0):
						{
							break;
						}
/*						case (1):
						{
							break;
						}	*/
						case (1):
						{
							if (currentsave.options[SFX_VOLUME]<30)
							{
								currentsave.options[SFX_VOLUME]++;
							}
							break;
						}
						case (2):
						{
							if (currentsave.options[MUSIC_VOLUME]<30)
							{
								currentsave.options[MUSIC_VOLUME]++;
#ifdef MUSIC
								SsSepSetVol(sep1, 0, (currentsave.options[MUSIC_VOLUME]*127)/30,(currentsave.options[MUSIC_VOLUME]*127)/30);
#endif
							}
							break;
						}
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=11;
					backgroundloaded=0;
				}
				if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
				{

				}
				break;
			}
			case (21):
			{
				if (backgroundloaded==0)
				{
					if (currentsave.options[PAD_TYPE2]==2)
					{
						nomenuopts=2;
					}
					else
					{
						nomenuopts=4;
					}
					menuoption=0;
					textboxeson=1;
					blackboxon=0;
					for (fecnt1=1;fecnt1<nomenuopts;fecnt1++)
					{
						menutext[0][fecnt1].tpage=lang3tpage;
						menutext[0][fecnt1].clut=lang3clut;
						menutext[1][fecnt1].tpage=lang3tpage;
						menutext[1][fecnt1].clut=lang3clut;
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					menutext[0][0].tpage=lang2tpage;
					menutext[0][0].clut=lang2clut;
					menutext[1][0].tpage=lang2tpage;
					menutext[1][0].clut=lang2clut;

					setuvs(&menutext[0][0],0,255,70,83);
					setuvs(&menutext[1][0],0,255,70,83);
					setuvs(&menutext[0][2],0,255,70,83);
					setuvs(&menutext[1][2],0,255,70,83);
					fadestatus=1;
					backgroundloaded=1;
				}
				setuvs(&menutext[otid][1],0,255,0+(currentsave.options[CONTROLLER_OPT1]*14),13+(currentsave.options[CONTROLLER_OPT1]*14));
				setuvs(&menutext[otid][3],0,255,0+(currentsave.options[CONTROLLER_OPT2]*14),13+(currentsave.options[CONTROLLER_OPT2]*14));

				if (currentsave.options[PAD_TYPE1]==0)
				{
					setuvs(&padtext1[otid],0,127,0,13);
					padtext1[otid].tpage=langtpage;
					padtext1[otid].clut=langclut;
				}
				else
				{
					setuvs(&padtext1[otid],0,127,14,27);
					padtext1[otid].tpage=langtpage;
					padtext1[otid].clut=langclut;
				}
				AddPrim(&FeOT[otid][1],&padtext1[otid]);

				if (currentsave.options[PAD_TYPE2]!=2)
				{
					if (currentsave.options[PAD_TYPE2]==0)
					{
						padtext2[otid].tpage=langtpage;
						padtext2[otid].clut=langclut;
						setuvs(&padtext2[otid],0,127,0,13);
					}
					else
					{
						padtext2[otid].tpage=langtpage;
						padtext2[otid].clut=langclut;
						setuvs(&padtext2[otid],0,127,14,27);
					}
					AddPrim(&FeOT[otid][1],&padtext2[otid]);
				}
				if (fepadread==PAD_LEFT)
				{
					if (currentsave.options[CONTROLLER_OPT1]==0)
					{
						currentsave.options[CONTROLLER_OPT1]=3;
					}
					else
					{
						currentsave.options[CONTROLLER_OPT1]--;
					}
				}
				if (fepadread==PAD_RIGHT)
				{
					if (currentsave.options[CONTROLLER_OPT1]==3)
					{
						currentsave.options[CONTROLLER_OPT1]=0;
					}
					else
					{
						currentsave.options[CONTROLLER_OPT1]++;
					}
				}
				if (currentsave.options[PAD_TYPE2]!=2)
				{
					if (fepadread2==PAD_LEFT)
					{
						if (currentsave.options[CONTROLLER_OPT2]==0)
						{
							currentsave.options[CONTROLLER_OPT2]=3;
						}
						else
						{
							currentsave.options[CONTROLLER_OPT2]--;
						}
					}
					if (fepadread2==PAD_RIGHT)
					{
						if (currentsave.options[CONTROLLER_OPT2]==3)
						{
							currentsave.options[CONTROLLER_OPT2]=0;
						}
						else
						{
							currentsave.options[CONTROLLER_OPT2]++;
						}
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=11;
					backgroundloaded=0;
				}
				break;
			}
			case (22):
			{
				if (backgroundloaded==0)
				{
#ifndef CD
					switch (language)
					{
						case (0):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (1):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (2):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (3):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
						case (4):
						{
							fefin			=	PCopen("textures/frontend/carde.tim", 0, 0 );
							break;
						}
					}
					fefilesize	=	PClseek( fefin, 0, 2 );
					PClseek( fefin, 0, 0 );
					fetexture	=	cdbuffer+180000;
					PCread( fefin, (char *)fetexture, fefilesize );
					PCclose( fefin );
#else
					switch(language)
					{
						case (0):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (1):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (2):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (3):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
						case (4):
						{
							load_cd("\\TEXTURES\\FRONTEND\\CARDE.TIM;1",cdbuffer+180000);
							break;
						}
					}
					do
 					{

 					}
 					while (CdReadSync(1,0) > 0 );
#endif
					OpenTIM(cdbuffer+180000);
					ReadTIM(&gentimheader);
					cardtpage=LoadTPage(gentimheader.paddr,1,0,448,256,256,256);  /* 96 */
					cardclut=LoadClut(gentimheader.caddr,448,511);
					menutext[0][0].tpage=cardtpage;
					menutext[0][0].clut=cardclut;
					menutext[1][0].tpage=cardtpage;
					menutext[1][0].clut=cardclut;
					menutext[0][1].tpage=lang2tpage;
					menutext[0][1].clut=lang2clut;
					menutext[1][1].tpage=lang2tpage;
					menutext[1][1].clut=lang2clut;
					for (fecnt1=0;fecnt1<2;fecnt1++)
					{
						menuboxes[0][fecnt1].tpage=prelangtpage;
						menuboxes[0][fecnt1].clut=prelangclut;
						menuboxes[1][fecnt1].tpage=prelangtpage;
						menuboxes[1][fecnt1].clut=prelangclut;
					}
					menuoption=0;
					tempwrite=0;
					backgroundloaded=1;
					fadestatus=1;
					textboxeson=1;
					nocardfiles=0;
					cardyesno=0;
					cardstatus=1; /* assume no card */
				}
				if ((fadestatus==0)&&(cardstatus!=0))
				{
					testcard(0);
					cardscrstatus=7;
					setuvs(&menutext[otid][0],0,200,0,13);
				}
				if (cardstatus==1)
				{
					nomenuopts=1;
					if (fadestatus==0)
					{
						setuvs(&menutext[otid][0],0,200,56,69);
					}
					else
					{
						setuvs(&menutext[otid][fecnt1],0,200,0,13);
					}
				}
				else
				{
					nomenuopts=1;
					switch (cardscrstatus)
					{
						case (7):
						{
							cardscrstatus=0;
							break;
						}

						case (0):
						{
							setuvs(&menutext[otid][0],0,200,98,111);
							nocardfiles=carddirectory(0);
							if (nocardfiles==15)
							{
								cardscrstatus=1;
							}
							else
							{
								cardscrstatus=2;
							}
							break;
						}
						case (1):
						{
							setuvs(&menutext[otid][0],0,200,70,83);
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								fepadread=PAD_B4;
							}
							break;
						}
						case (2):
						{
							setuvs(&menutext[otid][0],0,200,98,111);
							if (cardfileexist(0)==0)
							{
								cardscrstatus=4;
							}
							else
							{
								cardscrstatus=3;
							}
							break;
						}
						case (3):
						{
							nomenuopts=2;
							menuoption=1;
							setuvs(&menutext[otid][0],0,200,84,97);
							if (cardyesno==0)
							{
								setuvs(&menutext[otid][1],128,200,224,237);
							}
							else
							{
								setuvs(&menutext[otid][1],128,200,238,251);
							}
							if ((fepadread==PAD_LEFT)||(fepadread2==PAD_LEFT)||(fepadread==PAD_RIGHT)||(fepadread2==PAD_RIGHT))
							{
								cardyesno=(cardyesno+1)%2;
							}
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								if (cardyesno==0)
								{
									sprintf(&delname,"bu00:BESLES-00711S");
									delname[18]=Player[0].Name[0];
									delname[19]=Player[0].Name[1];
									delname[20]=Player[0].Name[2];
									delname[21]=0;
									if (delete(&delname)==0)
									{
										printf("file %s didn't delete\n",&delname);
										if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
										{
											fepadread=PAD_B4;
										}
									}
									else
									{
										cardscrstatus=4;
									}
								}
								else
								{
									fepadread=PAD_B4;
								}
							}
							break;
						}
						case (4):
						{
							setuvs(&menutext[otid][0],0,200,98,111);
							for (fecnt1=0;fecnt1<3;fecnt1++)
							{
								currentsave.p1name[fecnt1]=Player[0].Name[fecnt1];
								currentsave.p2name[fecnt1]=Player[1].Name[fecnt1];
							}
							for (fecnt1=0;fecnt1<96;fecnt1++)
							{
								savebuf[fecnt1]=0;
							}
							savebuf[0]='S';
							savebuf[1]='C';
							savebuf[2]=0x13;
							savebuf[3]=1;
							sprintf(&memcardtext[0],"Smoke Crack - %s Says its great\0",&Player[0].Name[0]);
							storekanji=&savebuf[4];
							fecnt1=0;
							while (memcardtext[fecnt1]!=0)
							{
								*(storekanji+(fecnt1*2))=(ascii2sjis(memcardtext[fecnt1])>>8);
								*(storekanji+(fecnt1*2)+1)=(ascii2sjis(memcardtext[fecnt1])&0xff);
								fecnt1++;
							}
#ifndef CD
							fefin			=	PCopen( "textures/icon2.tim", 0, 0 );
							fefilesize	=	PClseek( fefin, 0, 2 );
							PClseek( fefin, 0, 0 );
							fetexture	=	cdbuffer+200000;
							PCread( fefin, (char *)fetexture, fefilesize );
							PCclose( fefin );
#else
							load_cd("\\TEXTURES\\ICON2.TIM;1",cdbuffer+200000);
							do
 							{

 							}
 							while (CdReadSync(1,0) > 0 );
#endif
							OpenTIM(cdbuffer+200000);
							ReadTIM(&gentimheader);
							fetexture=gentimheader.caddr;
							for (fecnt1=0;fecnt1<32;fecnt1++)
							{
								savebuf[96+fecnt1]=*(fetexture+fecnt1);
							}
							fetexture=gentimheader.paddr;
							for (fecnt1=0;fecnt1<384;fecnt1++)
							{
								savebuf[128+fecnt1]=*(fetexture+fecnt1);
							}
							fetexture=&currentsave;
							for (fecnt1=0;fecnt1<sizeof(currentsave);fecnt1++)
							{
								savebuf[512+fecnt1]=*(fetexture+fecnt1);
							}
							sprintf(&newname.name,"BESLES-00711S");
							newname.name[13]=Player[0].Name[0];
							newname.name[14]=Player[0].Name[1];
							newname.name[15]=Player[0].Name[2];
							newname.name[16]=0;
							cardwrite(0,&savebuf[0]);
							if (cardstatus==0)
							{
								cardscrstatus=5;
							}
							else
							{
								cardscrstatus=6;
							}
							break;
						}
						case (5):
						{
							setuvs(&menutext[otid][0],0,200,112,125);
							menuoption=0;
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								fepadread=PAD_B4;
							}
							break;
						}
						case (6):
						{
							setuvs(&menutext[otid][0],0,200,126,139);
							menuoption=0;
							if ((fepadread==PAD_B2)||(fepadread2==PAD_B2))
							{
								fepadread=PAD_B4;
							}
							break;
						}
					}
				}
				if ((fepadread==PAD_B4)||(fepadread2==PAD_B4))
				{
					fegamestate=10;
					nomenuopts=0;
					menuoption=0;
					backgroundloaded=0;
					logoson=0;
					textboxeson=0;
				}
/*				if (fepadread==PAD_BOTTOMLEFT)
				{
					sprintf(&delname,"bu00:BESLES-00711S");
					delname[18]=Player[0].Name[0];
					delname[19]=Player[0].Name[1];
					delname[20]=Player[0].Name[2];
					delname[21]=0;
					if (delete(&delname)==0)
					{
						printf("file %s didn't delete\n",&delname);
					}
				}   */

				break;
			}
			case (50):
			{
				break;
			}
		}
/*		if ((fegamestate>3)&&(fegamestate!=6))
		{
			xbutton[otid].tpage=flagtpage;
			xbutton[otid].clut=flagclut;
			SetPolyFT4(&xbutton[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&xbutton[otid]);
			seltext[otid].tpage=langtpage;
			seltext[otid].clut=langclut;
			SetPolyFT4(&seltext[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&seltext[otid]);
		}
		if (fegamestate>2)
		{
			tbutton[otid].tpage=flagtpage;
			tbutton[otid].clut=flagclut;
			SetPolyFT4(&tbutton[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&tbutton[otid]);
			backtext[otid].tpage=langtpage;
			backtext[otid].clut=langclut;
			SetPolyFT4(&backtext[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&backtext[otid]);
		}
		if (udarrowson==1)
		{
			arrowadjust=arrowcycle/4;
			setXY4(&uparrow[otid],21-arrowadjust,127,45-arrowadjust,127,21-arrowadjust,142,45-arrowadjust,142);
			uparrow[otid].tpage=flagtpage;
			uparrow[otid].clut=flagclut;
			SetPolyFT4(&uparrow[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&uparrow[otid]);
			setXY4(&downarrow[otid],182+arrowadjust,127,206+arrowadjust,127,182+arrowadjust,142,206+arrowadjust,142);
			downarrow[otid].tpage=flagtpage;
			downarrow[otid].clut=flagclut;
			SetPolyFT4(&downarrow[otid]);
			feottr=&(FeOT[otid][15]);
			AddPrim(feottr,&downarrow[otid]);
			if (arrowcycle==16)
			{
				arrowcycle=0;
			}
			else
			{
				arrowcycle++;
			}
		}
		if (wheelmove==0)
		{
			selectrot+=0x50;
			if (selectrot>4096)
			{
				selectrot-=4096;
			}
		}
		else
		{
			selectrot=0;
		}   */
#ifndef CD
		pollhost(); 	/* temp */
#endif

		/* draw anything that needs to be drawn. */

//		SetPolyF4(&pisteclear[otid]);
//		feottr=&(FeOT[otid][1]);
//		AddPrim(feottr,&pisteclear[otid]);
		if (blackboxon==1)
		{
			feottr=&(FeOT[otid][1]);
			if ((fegamestate==20)&&(menuoption>0))
			{
				if (menuoption==1)
				{
					thisvol=currentsave.options[SFX_VOLUME];
				}
				else
				{
					thisvol=currentsave.options[MUSIC_VOLUME];
				}
				for (fecnt1=0;fecnt1<thisvol;fecnt1++)
				{
					AddPrim(feottr,&barpolys[otid][fecnt1]);
				}
			}
			else
			{
				if ((fegamestate==7)||(fegamestate==22)||(fegamestate==24))
				{
					/* name polys */
					AddPrim(feottr,&fenamepolys[otid][0]);
					AddPrim(feottr,&fenamepolys[otid][1]);
					AddPrim(feottr,&fenamepolys[otid][2]);
				}
				else
				{
					AddPrim(feottr,&blackboxtext[otid]);
				}
			}
			SetSemiTrans(&blackbox[otid],1);
			AddPrim(feottr,&blackbox[otid]);
		}

		if (textboxeson==1)
		{
			feottr=&(FeOT[otid][1]);
			for (fecnt1=0;fecnt1<nomenuopts;fecnt1++)
			{
				if ((fecnt1==menuoption)||((fecnt1==2)&&(fegamestate==21)))
				{
					setuvs(&menuboxes[otid][fecnt1],3,217,25,39);
				}
				else
				{
					setuvs(&menuboxes[otid][fecnt1],3,217,2,17);
				}
				AddPrim(feottr,&menutext[otid][fecnt1]);
				SetSemiTrans(&menuboxes[otid][fecnt1],1);
				AddPrim(feottr,&menuboxes[otid][fecnt1]);
			}
		}
		if ((fadestatus==1)||(fadestatus==5))
		{
			if (fadestatus==1)
			{
				fadevalue=15;
				fadestatus=5;
			}
			if (fadein()==1)
			{
				fadestatus=0;
			}
		}
		if ((fadestatus==2)||(fadestatus==4))
		{
			if (fadestatus==2)
			{
				fadevalue=0;
				fadestatus=4;
			}
			if (fadeout()==1)
			{
				fadestatus=0;
				fegamestate=stgamestate;
			}
		}

//		imagetrans=(DR_LOAD *)&cdbuffer[0];
//		SetDrawLoad(imagetrans,&imarea[otid]);
//		AddPrim(&FeOT[otid][0],imagetrans);
//		DrawSync(0);
		VSync (0);
        Pad_Update();

		/* temp font shit */


		OTPtr=&FeOT[otid][0];
		DrawOTag(OTPtr);
		FntFlush(fntid1);

		DrawSync(0);

		LoadImage(&imarea[otid],fetimheader.paddr);
		if (logoson==1)
		{
			LoadImage(&imbox[otid],boxtims.paddr);
//			LoadImage(&refbox[otid],reftims.paddr);
		}
//		DrawSync(0);

		PutDrawEnv(&drawenv[0][display_id]);
		PutDispEnv(&dispenv[0][display_id]);
//		OTPtr=&FeOT[otid][0];
//		DrawOTag(OTPtr);


		if (setdisplay==0)
		{
			SetDispMask(1);
			setdisplay=1;
		}
		display_id=(display_id+1)%2;
		otid=(otid+1)%2;
		noframes++;
	}
	/* kill all psx stuff */
}

