/*******************************************************************************
*
* Filename	MAIN.C
*
* Description
*
* Last modified	August 13, 1996	02:27:15
*
* Version	PSX
*
* (C) Silicon Dreams 1996
*
* History	130896	JEB	Created
*
*******************************************************************************/

/* ------------------------------------------------- */
/*    a couple of very important little defines...   */

#define	DEBUGCODE	yes

/* ------------------------------------------------- */

/*	include the standard c stuff */


#define	IN_CHILLMAIN	yes

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "gtemac.h"
#include "inline_c.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "screen.h"
#include "sound.h"
#include "cd.h"
#include "frontend.h"
#include "main.h"
#include "pads.h"
#include "skeleton.h"
#include "who.h"
#include "ghostrep.h"
#include "scores.h"
#include "plume.h"

//#include "prof.h"

extern	padbuffer PadBuf[ MAX_PADS ];
extern	uint8		cdloadstate;

int	res1,res2;
uint8 playercount;
uint8 paddeb=0;
uint8 screenshot=0;
char *ssptr;
char ssfilename[40];
char snum=0;
long ssfin;
long ssfs;
long ssotid;
long tx=0,ty=0,tz=0;
vec3 *point;
uint8 mujumped=0;
uint32 sttime;
uint32 idletime;
uint8	effectplayed;
SpuVoiceAttr voiceattr;
uint8	Oldpermit;
uint8	fucknose;

#ifndef CD
char	screenshotbuffer[200000];
#endif

void KillPSX(void)
{
	PadStop();
	exit();
}

void Fatal(char *shit)
{
	printf("bollocks\n");
	exit(0);
}

// extern unsigned long *loadaddress;    external ptr to shared load address for overlayed code


/* Variable definitions */

uint8		gameexit;
uint8		frontendexit=0;
short		noisevalue;
long TempPad;

void RunGameLoop(uint8 courseno)
{

	if (playdemo!=0)
	{
#ifndef CD
		ssptr=&GhostBuffer[0][0];
		if (playdemo==1)
		{
			ssfin			=	PCopen( "demos/forest4.dem", 0, 0 );
		}
		else
		{
			ssfin			=	PCopen( "demos/forest4.dem", 0, 0 );
		}
		ssfs	=	PClseek( ssfin, 0, 2 );
		PClseek( ssfin, 0, 0 );
		PCread( ssfin, (char *)ssptr, ssfs );
		PCclose( ssfin );
#else
		if (playdemo==1)
		{
			load_cd("\\DEMOS\\FOREST4.DEM;1",&GhostBuffer[0][0]);
		}
		else
		{
			load_cd("\\DEMOS\\FOREST4.DEM;1",&GhostBuffer[0][0]);
		}
		do
 		{

 		}
 		while (CdReadSync(1,0) > 0 );
#endif
	}
	if (thistrack==9)
	{
		starttrack=courseno;
	}
	Ingame=1;
	InitialisePlayers();
	Initialise_Skeleton();
//	InitBoardModel(0);
	if (fucknose==1)
	{
		Player[0].ConsoleRemoteGhosted=REMOTE_PLAYER;
		fucknose=0;
	}

	for (playercount=0;playercount<NumberOfPlayers;playercount++)
	{
		InitialiseTrackEngine( playercount );
	}
//	InitialiseTrackEngine( 0 );        /* default to 1 player */

//	SsInit ();
//	SsSetTickMode (SS_NOTICK);
//	SsStart2 ();
	Init_Ghost();
	InitScoringSystem();
#ifdef MUSIC
// 	initfilesystem();
	ResetCallback();

	VSyncCallback(0);

	KillSoundFE();

	InitialiseSound(1);

/*	SpuSetNoiseClock(32);
	SpuSetNoiseVoice(SPU_ON,SPU_22CH);
	voiceattr.voice=SPU_22CH;
	voiceattr.mask=SPU_VOICE_VOLL|SPU_VOICE_VOLR;
	voiceattr.volume.left=127;
	voiceattr.volume.right=127;
	voiceattr.volmode.left=SPU_VOICE_LINEARIncN;
	voiceattr.volmode.right=SPU_VOICE_LINEARIncN;
	voiceattr.volumex.left=127;
	voiceattr.volumex.right=127;
	SpuSetKeyOnWithAttr(&voiceattr);	*/


#endif
	VSyncCallback(&SoundCallBack);
	gameexit=0;
	effectplayed=0;
	idletime=0;
	framelock=0;
	TempPad=0;
//	profiler_init(0);
	while (gameexit!=4)
	{
		if (gameexit==1)
		{
//			Ingame=0;
			if (fucknose==2)
			{
				ssfs=0x24000;
				sprintf(&ssfilename,"demos/forest2.dem");
				ssfin = PCcreat(&ssfilename,0);
// 				ssfin = PCopen( "textures/scrshot.tim", 1, 0 );
				ssptr=&GhostBuffer[0][0];
				PCwrite(ssfin, ssptr, ssfs);
				PCclose(ssfin);
//				printf("screen shot saved %d\n",snum);
			}
			if (gameexit==1)
			{
				gameexit=2;
			}
			Player[0].ConsoleRemoteGhosted=REMOTE_PLAYER;
//			Player[0].NoTaggedPolys=0;
			if (ConsolePlayers==2)
			{
				Player[1].ConsoleRemoteGhosted=REMOTE_PLAYER;
//				Player[1].NoTaggedPolys=0;
			}
			InitialisePlayers();
			InitialiseTrackEngine(0);
			if (ConsolePlayers==2)
			{
				InitialiseTrackEngine(1);
			}
			Init_Ghost();
			InitScoringSystem();
		}
//		if ((TempPad&PAD_STOP)&&(TempPad&PAD_START))
		if (paused==2)
		{
			paused=0;
			InitialisePlayers();
			InitialiseTrackEngine(0);
			CameraLogic(0);
			if (ConsolePlayers==2)
			{
				InitialiseTrackEngine(1);
				CameraLogic(1);
			}
			Init_Ghost();
			InitScoringSystem();
		}
//		TempPad = Pad_State( 1 );
//		if ((TempPad&PAD_STOP)&&(TempPad&PAD_START))
		switch (paused)
		{
			case (0):
			default:
			{
				break;
			}
			case (1):
			{
				 TempPad=Pad_RealDebounced(pauseplayer);
				 if (TempPad&PAD_UP)
				 {
					if (pauseoption==0)
					{
						pauseoption=nopauseoptions-1;
					}
					else
					{
						pauseoption--;
					}
				 }
				 if (TempPad&PAD_DOWN)
				 {
					if (pauseoption==(nopauseoptions-1))
					{
						pauseoption=0;
					}
					else
					{
						pauseoption++;
					}
				 }
				 if (TempPad&PAD_B2)
				 {
					switch (pauseoption)
					{
						case (0):
						{
							TempPad=PAD_START;
							break;
						}
						case (1):
						{
							paused=2;
							break;
						}
						case (2):
						{
							gameexit=4;
							break;
						}
					}
				 }
			}
		}
		if (paused==0)
		{
			TempPad = Pad_RealDebounced(0);
		}
		if (TempPad&PAD_START)
		{
			if (paused==0)
			{
				paused=1;
				pauseplayer=0;
				Oldpermit=PermitMove;
				PermitMove=0;
				pauseoption=0;
				nopauseoptions=3;
				pauseyesno=0;
			}
			else
			{
				if(pauseplayer==0)
				{
					paused=0;
					PermitMove=Oldpermit;
				}
			}
//			screenshot=1;
		}
		if (ConsolePlayers==2)
		{
			if (paused==0)
			{
				TempPad = Pad_RealDebounced(1);
			}
			if (TempPad&PAD_START)
			{
				if (paused==0)
				{
					paused=1;
					pauseplayer=1;
					Oldpermit=PermitMove;
					PermitMove=0;
					pauseoption=0;
					nopauseoptions=3;
					pauseyesno=0;
				}
				else
				{
					if(pauseplayer==1)
					{
						paused=0;
						PermitMove=Oldpermit;
					}
				}
			}
		}
		/* ghost sensitive stuff before pad update !! */

		Pad_Update();

//		if (ConsolePlayers==1)
//		{
  	 	Refresh_Skeleton();
//		}

#if I_AM == JEB
		TempPad = Pad_RealDebounced(0);
		if ((gameexit==2)&&(TempPad&PAD_START))
		{
			gameexit=4;
			Player[0].ConsoleRemoteGhosted=CONSOLE_PLAYER;
			if (ConsolePlayers==2)
			{
				Player[1].ConsoleRemoteGhosted=CONSOLE_PLAYER;
			}
		}
   		TempPad = Pad_RealDebounced( 1 );
		if ((TempPad&PAD_STOP)&&(TempPad&PAD_START))
		{
			gameexit=4;
//			setdisplay=0;
		}

		if (ConsolePlayers==1)
		{
	//			TempPad>>=16;
	//			TempPad&=0xFFFF;
	//		if ( TempPad == PAD_BOTTOMLEFT )
	//		{
	//			screenshot=1;
	//		}
			if ( TempPad & PAD_BL)
			{
				if (TempPad & PAD_LEFT)
				{
					if (howfoggy[0]>0)
					{
						howfoggy[0]--;
					}
				}
				if (TempPad & PAD_RIGHT)
				{
					if (howfoggy[0]<25)
					{
						howfoggy[0]++;
					}
				}
				if (TempPad & PAD_DOWN)
				{
					if (howsnowy[0]>0)
					{
						howsnowy[0]--;
					}
				}
				if (TempPad & PAD_UP)
				{
					if (howsnowy[0]<25)
					{
						howsnowy[0]++;
					}
				}
				if (TempPad & PAD_TOPLEFT)
				{
					if (snowspeed>0)
					{
						snowspeed--;
					}
				}
				if (TempPad & PAD_TOPRIGHT)
				{
					if (snowspeed<25)
					{
						snowspeed++;
					}
				}
			}
			if (TempPad & PAD_B4)
			{
				framelock=(framelock+1)%2;
			}
			if( TempPad & PAD_B4 )
			{
				switch (Player[0].Cam.Mode)
				{
					case (CAMERA_FOLLOW):
					{
						Player[ 0 ].Cam.Mode = CAMERA_TEST_POSITIONAL;
 						Player[ 0 ].Transport = TESTCAM;
						break;
					}
					case (CAMERA_TEST_POSITIONAL):
					{
						Player[0].Cam.Mode = CAMERA_FOLLOW;
						Player[ 0 ].Transport = SNOWBOARD;	// Set which transport logic to use
						break;
					}
   				}
			}
		}
#endif
		TopScreenDrawn=0;
		if (paused==0)
		{
			for (playercount=0;playercount<NumberOfPlayers;playercount++)
			{
				BoardModel( playercount );
	//			Player[1].Pos.X=Player[0].Pos.X;
	//			Player[1].Pos.Y=Player[0].Pos.Y;
	//			Player[1].Pos.Z=Player[0].Pos.Z;

				RMGetPlayerStrip(playercount);

		    	CameraLogic( playercount );
				setboardcollisionpoint( playercount );
			}

			UpdatePlume();
		}
		for (playercount=0;playercount<NumberOfPlayers;playercount++)
		{
//			BoardModel( playercount );
//			CameraLogic( playercount );
			no_plume_tpages[otid] = 0;
			TempRenderTrackPolys( playercount );
			TopScreenDrawn=1;
		}
		noframes++;
//		StopCallback();
//		EnterCriticalSection();
//		FlushCache();
//		ExitCriticalSection();
//		RestartCallback();
/*		if (musiccnt==4)
		{
			musiccnt=0;
#ifdef	MUSIC
			ChangeSong(0);
#endif
		}   */
#ifdef CD
		if (gameexit!=2)
		{
			if ((Pad_State(0)!=0)||(Pad_State(1))!=0)	 //if idle for more than 30 seconds, full exit
			{
		   		idletime=globaltime[0];
			}
/*			if ((globaltime[0]-idletime)>600600)
			{
				gameexit=4;
	   		}	*/
		}
#endif
		if ((NumberOfPlayers==1)&&(Player[0].ConsoleRemoteGhosted==REMOTE_PLAYER))
		{
			if ((Pad_RealState(0)!=0)||(Pad_RealState(1)!=0))
			{
				gameexit=4;
			}
		}
		if ((Player[0].JumpY==0)&&(Player[0].Vel>0))
		{
			noisevalue=(Player[0].Vel>>12)*5;
			if (noisevalue>0x7f)
			{
				noisevalue=0x7f;
			}
//			SsSepSetVol (sfxsep1, 29, noisevalue, noisevalue);
//			SpuSetNoiseClock(noisevalue);
		}
		else
		{
//			SsSepSetVol (sfxsep1, 29, 0, 0);
//			SsSetNck(0);
//			SpuSetNoiseClock(0);
		}

		TempPad = Pad_State( 0 );
/*		if (TempPad&PAD_LEFT)
		{
			SetNextSeq(2);
		}
		if (TempPad&PAD_RIGHT)
		{
			SetNextSeq(2);
		}   */
/*		if ((TempPad&PAD_B2)&&(mujumped==0))
		{
 			SetNextSeq(2);
		}	*/
		if ((Player[0].JumpY!=0)&&(mujumped==0))
		{
			sttime=globaltime[0];
			mujumped=1;
#ifdef MUSIC
			SsSepSetVol (sfxsep1, 29, 0, 0);
#endif
		}
		if (Player[0].Vel==0)
		{
#ifdef MUSIC
			SsSepSetVol (sfxsep1, 29, 0, 0);
#endif
		}
		if ((mujumped==1)&&((globaltime[0]-sttime)>12000)&&(effectplayed==0))
		{
#ifdef MUSIC
			if (rand()%2==0)
			{
				playsoundeffect(27,1);
			}
			else
			{
				playsoundeffect(28,1);
			}
#endif
			effectplayed=1;
		}
		if ((playwhoah==1)&&((globaltime[0]-deltime)>7000))
		{
#ifdef MUSIC
			playsoundeffect(26,1);
#endif
			playwhoah=0;
		}
		if ((Player[0].JumpY==0)&&(mujumped==1))
		{
			mujumped=0;
			effectplayed=0;
#ifdef MUSIC
			playsoundeffect(9,1);
			SsSepSetVol (sfxsep1, 29, (currentsave.options[SFX_VOLUME]*127)/30,(currentsave.options[SFX_VOLUME]*127)/30);
#endif

		}
/*		if ((Player[0].JumpY==0)&&(Player[0].Vel>0))
		{
#ifdef MUSIC
			SsSepSetVol (sfxsep1, 29, (currentsave.options[SFX_VOLUME]*127)/30,(currentsave.options[SFX_VOLUME]*127)/30);
#endif
		}   */
		if ((abs(Player[0].TurnInert)>=(40<<12))&&(Player[0].JumpY==0))
		{
#ifdef MUSIC
			playsoundeffect(7,1);
#endif
		}
/*		if (TempPad&PAD_DOWN)
		{
			SetNextSeq(3);
		}   */

#if I_AM == JEB
#ifndef CD
		if (screenshot==1)
		{
			cdbuffer=&screenshotbuffer;
			ssptr=cdbuffer;
			ssfin			=	PCopen( "textures/scrshot.tim", 0, 0 );
			ssfs	=	PClseek( ssfin, 0, 2 );
			PClseek( ssfin, 0, 0 );
			PCread( ssfin, (char *)ssptr, ssfs );
			PCclose( ssfin );
			if (ConsolePlayers>1)
			{
				ssotid=((otid/2)+1)%2;
			}
			else
			{
				ssotid=(otid+1)%2;
			}
			ssotid=(ssotid+1)%2;
			ssptr=(cdbuffer);
			ssptr+=20;
			DrawSync(0);
			StoreImage(&imarea[ssotid],ssptr);
			DrawSync(0);
			sprintf(&ssfilename,"textures/shots/sshot%d.tim",snum);
			ssfin = PCcreat(&ssfilename,0);
//			ssfin = PCopen( "textures/scrshot.tim", 1, 0 );
			ssptr=cdbuffer;
			PCwrite(ssfin, ssptr, ssfs);
			PCclose(ssfin);
			printf("screen shot saved %d\n",snum);
			snum++;
			screenshot=0;
		}
#endif
#endif
#ifdef MUSIC
		if (songloading==1)
		{
			loadsong(whichload);
		}
#endif
	}
	SetDispMask(0);
	setdisplay=2;
	otid=0;
	Ingame=0;
	timedstart=0;
	if ((ConsolePlayers==1)&&(Validity[0]==1)&&(currentsave.options[GHOST_SET]==1))
	{
		UpdateGhostData();
	}
	/* question on GhostUpdate - 0 automatic, 1 choice */
//	end_prof(0);
	VSyncCallback(0);
#ifdef CD
	do
 	{

 	}
 	while (CdReadSync(1,0) > 0 );
	CdSyncCallback(0);
	cdloadstate=0;
#endif

#ifdef MUSIC
	KillSoundFE();
#endif
}

main (void)
{
	Frontend();
#ifdef MUSIC
	KillSound();
#endif
	KillPSX;
}


