/* camera.h */

#ifndef _CAMERA_H_
#define	_CAMERA_H_

#define CAMERA_TYPE_TARGET			0
#define CAMERA_TYPE_POSITIONAL	1

#define CAMERA_TEST_TARGET			0
#define CAMERA_TEST_POSITIONAL	1
#define	CAMERA_FOLLOW						2
#define	CAMERA_ACTION						3
#define CAMERA_ETC							4
#define CAMERA_FIRST_PERSON					5

typedef struct camera
{
	/* For both types of mode */
	vec3		Pos;

	/* For ortho modes */
	vec3		Targ;
	vec3		Up;

	/* For positional modes */

	vec3		Rot;

	uint8		Type;
	uint8		Mode;
	MATRIX		ViewMatrix;

}camera;

void InitialiseCameras( void );
void KillCameras( void );

void CameraLogic( uint8 PlayerNumber );

#endif
