/* ourtypes.h */

#ifndef _OURTYPES_H_
#define _OURTYPES_H_


#define PSX


/* Stuff for floating point machines */

#ifdef M2

#include <:kernel:types.h>	/* Hungarian notation */

typedef gfloat chfloat;
#define CHFL(a)	((chfloat)(a))

#endif



/* Stuff for fixed point machines */

#ifdef PSX

/* typedef uint8 etc */

#define PSX_PREC 12	/* or whatever */

typedef long chfloat;
typedef long 	 			int32;
typedef unsigned long		uint32;
typedef short int			int16;
typedef unsigned short int	uint16;
typedef char				int8;
typedef unsigned char		uint8;
#define CHFL(a) ((chfloat)((a)*(1<<PSX_PREC)))

#endif



#endif





