#ifndef AVALANCHE_H
#define AVALANCHE_H


#define WAVE_Y		80


#define AVALANCHE_NUMBER_OF_STRIPS 10

#define AVALANCHE_R		183
#define AVALANCHE_G		192
#define AVALANCHE_B		221


/*#define AVALANCHE_ZOOM_FAR	1200000*/
#define AVALANCHE_ZOOM_FAR	1000000
#define AVALANCHE_ZOOM_FRAMES 30
#define AVALANCHE_ZOOM_STEP	((AVALANCHE_ZOOM_FAR - 307200) / AVALANCHE_ZOOM_FRAMES)

typedef struct {
	short	stripno,fileno;
} VIEW_STRIP;



void	InitAvalanche();
void	DrawAvalanche(POLY_G3 *polys,long current_strip,long PlayerNumber,long players_strip);
						  

extern	long	strip_affected;
extern 	CVECTOR	strip_col;
extern  VIEW_STRIP striptab[2][MAX_VIEW_STRIPS];
extern  long	previous_segment_length[2];


/* from tracks.c */
extern uint8		previouscount[2];
extern incomingtrackbuffer *IBuf[2];


#endif