#ifndef PARACHUTE_H
#define PARACHUTE_H

#define PARACHUTE_OBJECT_TYPE 100



typedef struct {
	long			no_strips;
	long			no_objects;
	long			no_textures;
	long			offsetX,offsetZ;
	TMESH			strips[48];
	long			noobjects[48];
	trackobject		*objects[48];
	texttrackpoly	*textptrs[48];
} PARA_SEGMENT;


void	InitParachute();
void	DrawParachute(long PlayerNumber,long current_strip);



extern long parachute_counter;
extern long parachute_state;
extern long parachute_height;

extern PARA_SEGMENT	landing_zone;

extern long	last_para_y;


#endif