#ifndef ROTMESH_H
#define ROTMESH_H

#define STRIP_OT_SIZE	8
#define MESH_NEAR_Z		32
#define	MESH_SUBDIV		512

#define LONG_MOVE(FROM,TO)	((long *)(TO))[0] = ((long *)(FROM))[0]

typedef struct {
	short	vx,vy;
	short	vz,p;
	} RUSS_SVECTOR;

typedef struct {
	short	vx,vy;
	CVECTOR	col;
	} RUSS_SCVECTOR;


typedef struct {		
	SVECTOR	colour;
	VECTOR	location;
	SVECTOR	rotation;
} RLIGHT;


extern RLIGHT snow_lights[3];

void	RussRotMeshG3(TMESH *mesh,POLY_G3 *polys,unsigned long *ot,long stripno);
void	RussRotMeshG3_cell(TMESH *mesh,POLY_G3 *polys);
void	RussRotMeshG3Multi(player *Plyr,POLY_G3 *polys);
void	RussRotMeshG3Para(player *Plyr,POLY_G3 *polys);
void	DoCamMats(player *Plyr);

extern MATRIX	cam,rev;


#endif

