#ifndef LEAF_H
#define LEAF_H


#define MAX_LEAVES	32
#define LEAF_LIFE	16

#define LEAF_R		0
#define LEAF_G		64
#define LEAF_B		0

#define LEAF_FALLING_R		0
#define LEAF_FALLING_G		96
#define LEAF_FALLING_B		0




#define AVALANCHE_LEAF_R		192
#define AVALANCHE_LEAF_G		192
#define AVALANCHE_LEAF_B		192


#define LEAF_NEAR_Z	16

typedef struct {
	long	timer;
	VECTOR	inert;
	SVECTOR	spin;
	SVECTOR	rot;
	VECTOR	scale;
	VECTOR	global_pos;
	POLY_F4	prim[2];
} LEAF;

void	DrawLeaves(unsigned long player);
void	InitLeaves();
void AddLeaf(long playerno,VECTOR *pos);

#endif
