#ifndef _FRONTEND_H_
#define _FRONTEND_H_

#define SAVEGAME_NAME	"CHILL___000"
#define SAVEGAME_NAME "RECORDS   "

#define MAX_TRACKS	8
#define MAX_RECORDS	5
#define MAX_OPTIONS	16

#define OPT_SFX     	0
#define OPT_MUSIC     1
#define OPT_STEREO    2
#define OPT_CONTROL   3
#define OPT_SPLIT     4
#define OPT_GHOST     5
#define OPT_YETI      6
#define OPT_TRACK_6   7
#define OPT_TRACK_7   8
#define OPT_LANGAUGE	9

typedef char NAME[4];
typedef unsigned long SCORE;

typedef struct
{
	unsigned long	hour:8;
	unsigned long minute:8;
	unsigned long	second:8;
	unsigned long	msec:8;
}	TIME;

typedef struct
{
	NAME name;
	TIME time;
}	TIME_RECORD;

typedef struct
{
	NAME name;
	SCORE score;
}	SCORE_RECORD;

typedef struct
{
	unsigned char options[MAX_OPTIONS];

	TIME_RECORD		time_records[MAX_TRACKS][MAX_RECORDS];
	SCORE_RECORD  score_records[MAX_TRACKS][MAX_RECORDS];

	unsigned long error_checking;
} SAVEGAME;

#endif
