/*******************************************************************************
*
* Filename	MAIN.C
*
* Description
*
* Last modified	August 13, 1996	02:27:15
*
* Version	PSX
*
* (C) Silicon Dreams 1996
*
* History	130896	JEB	Created
*
*******************************************************************************/

/* ------------------------------------------------- */
/*    a couple of very important little defines...   */

#define	DEBUGCODE	yes

/* ------------------------------------------------- */

/*	include the standard c stuff */


#define	IN_CHILLMAIN	yes

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
//#include <libds.h>
#include "LibCD.h"
#include "LibEtc.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "gtemac.h"
#include "inline_c.h"
#include "ourtypes.h"
#include "mathbits.h"
#include "camera.h"
#include "tracks.h"
#include "players.h"
#include "screen.h"
#include "sound.h"
#include "cd.h"
#include "frontend.h"
#include "main.h"
#include "pads.h"
#include "skeleton.h"
#include "who.h"
#include "ghostrep.h"
#include "scores.h"

//#include "prof.h"

extern	padbuffer PadBuf[ MAX_PADS ];

int	res1,res2;
uint8 playercount;
uint8 paddeb=0;
uint8 screenshot=0;
char *ssptr;
char ssfilename[40];
char snum=0;
long ssfin;
long ssfs;
long ssotid;
long tx=0,ty=0,tz=0;
vec3 *point;
uint8 mujumped=0;
uint32 sttime;
uint32 idletime;
uint8	effectplayed;
SpuVoiceAttr voiceattr;
uint8	fucknose;

void KillPSX(void)
{
	PadStop();
	exit();
}

void Fatal(char *shit)
{
	printf("bollocks\n");
	exit(0);
}

// extern unsigned long *loadaddress;    external ptr to shared load address for overlayed code


/* Variable definitions */

uint8		gameexit;
uint8		frontendexit=0;
short		noisevalue;
long TempPad;

void RunGameLoop(uint8 courseno)
{

	if (fucknose==1)
	{
		ssptr=&GhostBuffer[0][0];
		ssfin			=	PCopen( "demos/forest1.dem", 0, 0 );
		ssfs	=	PClseek( ssfin, 0, 2 );
		PClseek( ssfin, 0, 0 );
		PCread( ssfin, (char *)ssptr, ssfs );
		PCclose( ssfin );
	}
	if (thistrack==9)
	{
		starttrack=courseno;
	}
//	Initialise_Skeleton();
//	InitBoardModel(0);
	InitialisePlayers();
	if (fucknose==1)
	{
		Player[0].ConsoleRemoteGhosted=REMOTE_PLAYER;
		fucknose=0;
	}

	for (playercount=0;playercount<NumberOfPlayers;playercount++)
	{
		InitialiseTrackEngine( playercount );
	}
//	InitialiseTrackEngine( 0 );        /* default to 1 player */

//	SsInit ();
//	SsSetTickMode (SS_NOTICK);
//	SsStart2 ();
	Init_Ghost();
	InitScoringSystem();
#ifdef MUSIC
// 	initfilesystem();
	ResetCallback();

	VSyncCallback(0);

	KillSoundFE();

	InitialiseSound(1);

/*	SpuSetNoiseClock(32);
	SpuSetNoiseVoice(SPU_ON,SPU_22CH);
	voiceattr.voice=SPU_22CH;
	voiceattr.mask=SPU_VOICE_VOLL|SPU_VOICE_VOLR;
	voiceattr.volume.left=127;
	voiceattr.volume.right=127;
	voiceattr.volmode.left=SPU_VOICE_LINEARIncN;
	voiceattr.volmode.right=SPU_VOICE_LINEARIncN;
	voiceattr.volumex.left=127;
	voiceattr.volumex.right=127;
	SpuSetKeyOnWithAttr(&voiceattr);	*/


#endif
	VSyncCallback(&SoundCallBack);
	gameexit=0;
	effectplayed=0;
	idletime=0;
	framelock=0;
//	profiler_init(0);
	while (gameexit!=4)
	{
		Pad_Update();
//		if (ConsolePlayers==1)
//		{
  	 	Refresh_Skeleton();
//		}
#if I_AM == JEB
		TempPad = PadBuf[ 0 ].Data.Standard ^ 0xffff;
		if ((gameexit==2)&&(TempPad&PAD_START))
		{
			gameexit=4;
		}
		if (((TempPad&PAD_STOP)&&(TempPad&PAD_START))||(gameexit==1))
		{
			if (fucknose==2)
			{
				ssfs=0x24000;
				sprintf(&ssfilename,"demos/forest1.dem");
				ssfin = PCcreat(&ssfilename,0);
// 				ssfin = PCopen( "textures/scrshot.tim", 1, 0 );
				ssptr=&GhostBuffer[0][0];
				PCwrite(ssfin, ssptr, ssfs);
				PCclose(ssfin);
//				printf("screen shot saved %d\n",snum);
			}
			if (gameexit==1)
			{
				gameexit=2;
			}
			InitialisePlayers();
			Player[0].ConsoleRemoteGhosted=REMOTE_PLAYER;
			InitialiseTrackEngine(0);
			if (ConsolePlayers==2)
			{
				InitialiseTrackEngine(1);
				Player[1].ConsoleRemoteGhosted=REMOTE_PLAYER;
			}
			Init_Ghost();
			InitScoringSystem();
		}
		TempPad = Pad_State( 1 );
		if ((TempPad&PAD_STOP)&&(TempPad&PAD_START))
		{
			gameexit=1;
		}
		if (ConsolePlayers==1)
		{
	//			TempPad>>=16;
	//			TempPad&=0xFFFF;
	//		if ( TempPad == PAD_BOTTOMLEFT )
	//		{
	//			screenshot=1;
	//		}
			if ( TempPad & PAD_BL)
			{
				if (TempPad & PAD_LEFT)
				{
					if (howfoggy[0]>0)
					{
						howfoggy[0]--;
					}
				}
				if (TempPad & PAD_RIGHT)
				{
					if (howfoggy[0]<25)
					{
						howfoggy[0]++;
					}
				}
				if (TempPad & PAD_DOWN)
				{
					if (howsnowy[0]>0)
					{
						howsnowy[0]--;
					}
				}
				if (TempPad & PAD_UP)
				{
					if (howsnowy[0]<25)
					{
						howsnowy[0]++;
					}
				}
				if (TempPad & PAD_TOPLEFT)
				{
					if (snowspeed>0)
					{
						snowspeed--;
					}
				}
				if (TempPad & PAD_TOPRIGHT)
				{
					if (snowspeed<25)
					{
						snowspeed++;
					}
				}
			}
			if (TempPad & PAD_B4)
			{
				framelock=(framelock+1)%2;
			}
			if( TempPad & PAD_B4 )
			{
				switch (Player[0].Cam.Mode)
				{
					case (CAMERA_FOLLOW):
					{
						Player[ 0 ].Cam.Mode = CAMERA_TEST_POSITIONAL;
 						Player[ 0 ].Transport = TESTCAM;
						break;
					}
					case (CAMERA_TEST_POSITIONAL):
					{
						Player[0].Cam.Mode = CAMERA_FOLLOW;
						Player[ 0 ].Transport = SNOWBOARD;	// Set which transport logic to use
						break;
					}
   				}
			}
		}
#endif
		TopScreenDrawn=0;
		for (playercount=0;playercount<NumberOfPlayers;playercount++)
		{
			BoardModel( playercount );
//			Player[1].Pos.X=Player[0].Pos.X;
//			Player[1].Pos.Y=Player[0].Pos.Y;
//			Player[1].Pos.Z=Player[0].Pos.Z;

		    CameraLogic( playercount );
		}
		for (playercount=0;playercount<NumberOfPlayers;playercount++)
		{
//			BoardModel( playercount );
//			CameraLogic( playercount );
			TempRenderTrackPolys( playercount );
			TopScreenDrawn=1;
		}
		noframes++;
//		StopCallback();
//		EnterCriticalSection();
//		FlushCache();
//		ExitCriticalSection();
//		RestartCallback();
/*		if (musiccnt==4)
		{
			musiccnt=0;
#ifdef	MUSIC
			ChangeSong(0);
#endif
		}   */

		if ((Player[0].JumpY==0)&&(Player[0].Vel>0))
		{
			noisevalue=(Player[0].Vel>>12)*5;
			if (noisevalue>0x7f)
			{
				noisevalue=0x7f;
			}
//			SsSepSetVol (sfxsep1, 29, noisevalue, noisevalue);
//			SpuSetNoiseClock(noisevalue);
		}
		else
		{
//			SsSepSetVol (sfxsep1, 29, 0, 0);
//			SsSetNck(0);
//			SpuSetNoiseClock(0);
		}

		TempPad = Pad_State( 0 );
/*		if (TempPad&PAD_LEFT)
		{
			SetNextSeq(2);
		}
		if (TempPad&PAD_RIGHT)
		{
			SetNextSeq(2);
		}   */
/*		if ((TempPad&PAD_B2)&&(mujumped==0))
		{
 			SetNextSeq(2);
		}	*/
		if ((Player[0].JumpY!=0)&&(mujumped==0))
		{
			sttime=globaltime[0];
			mujumped=1;
#ifdef MUSIC
			SsSepSetVol (sfxsep1, 29, 0, 0);
#endif
		}
		if (Player[0].Vel==0)
		{
#ifdef MUSIC
			SsSepSetVol (sfxsep1, 29, 0, 0);
#endif
		}
		if ((mujumped==1)&&((globaltime[0]-sttime)>12000)&&(effectplayed==0))
		{
#ifdef MUSIC
			if (rand()%2==0)
			{
				playsoundeffect(27,1);
			}
			else
			{
				playsoundeffect(28,1);
			}
#endif
			effectplayed=1;
		}
		if ((playwhoah==1)&&((globaltime[0]-deltime)>7000))
		{
#ifdef MUSIC
			playsoundeffect(26,1);
#endif
			playwhoah=0;
		}
		if ((Player[0].JumpY==0)&&(mujumped==1))
		{
			mujumped=0;
			effectplayed=0;
#ifdef MUSIC
			playsoundeffect(9,1);
			SsSepSetVol (sfxsep1, 29, 127, 127);
#endif

		}
		if ((abs(Player[0].TurnInert)>=(40<<12))&&(Player[0].JumpY==0))
		{
#ifdef MUSIC
			playsoundeffect(7,1);
#endif
		}
/*		if (TempPad&PAD_DOWN)
		{
			SetNextSeq(3);
		}   */

#if I_AM == JEB
		if (screenshot==1)
		{
			cdbuffer=&Ib2[1];
			ssptr=cdbuffer;
			ssfin			=	PCopen( "textures/scrshot.tim", 0, 0 );
			ssfs	=	PClseek( ssfin, 0, 2 );
			PClseek( ssfin, 0, 0 );
			PCread( ssfin, (char *)ssptr, ssfs );
			PCclose( ssfin );
			if (ConsolePlayers>1)
			{
				ssotid=((otid/2)+1)%2;
			}
			else
			{
				ssotid=(otid+1)%2;
			}
			ssotid=(ssotid+1)%2;
			ssptr=(cdbuffer);
			ssptr+=20;
			DrawSync(0);
			StoreImage(&imarea[ssotid],ssptr);
			DrawSync(0);
			sprintf(&ssfilename,"textures/shots/sshot%d.tim",snum);
			ssfin = PCcreat(&ssfilename,0);
//			ssfin = PCopen( "textures/scrshot.tim", 1, 0 );
			ssptr=cdbuffer;
			PCwrite(ssfin, ssptr, ssfs);
			PCclose(ssfin);
			printf("screen shot saved %d\n",snum);
			snum++;
			screenshot=0;
		}
#endif
#ifdef MUSIC
		if (songloading==1)
		{
			loadsong(whichload);
		}
#endif
	}
	Ingame=0;
	if ((ConsolePlayers==1)&&(Validity[0]==1)&&(currentsave.options[GHOST_SET]==1))
	{
		UpdateGhostData();
	}
	/* question on GhostUpdate - 0 automatic, 1 choice */
//	end_prof(0);
	VSyncCallback(0);
#ifdef MUSIC
	KillSoundFE();
#endif
}

main (void)
{
	Frontend();
#ifdef MUSIC
	KillSound();
#endif
	KillPSX;
}


