//sound.h

// typedefs

#ifndef CD
typedef struct musicfile
{
	char	vabheader[50];
	char	vabbody[50];
	char	mainsep[50];
	char	endsep[50];
}musicfile;
#else
typedef struct musicfile
{
	CdlFILE  	vabheader;
	CdlFILE		vabbody;
	CdlFILE		mainsep;
	CdlFILE		endsep;
}musicfile;
#endif

typedef struct musiccatagory
{
	uint32		numtunes;
	musicfile	tunes[20];
}musiccatagory;

// external variables

extern char seq_table[SS_SEQ_TABSIZ * 2 * 32];
extern long nextseq;
extern long songloading;
extern long whichload;
extern uint8 musiccat;
extern uint32 tuneno;
extern short sfxsep1;
extern short sep1;  /* SEP data id */
extern short endsep[2];
extern short vab1;  /* VAB data id */
extern short mixvab;
extern short sfxvab;


extern musiccatagory	musiccatalog[5];

// function prototypes

void InitialiseSound(uint8 where);
void KillSoundFE(void);
void KillSound( void );
void playauto( void );
void SetNextSeq( long seq );
void SoundCallBack( void );
void ChangeSong(long tuneno);
void loadsong(uint8 songno);
void playsoundeffect(uint8 no,uint8 repeat);
void playfesoundeffect(uint8 no,uint8 repeat);


