/* pads.c */

#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "ourtypes.h"
#include "main.h"
#include "pads.h"

uint32 Pad, Last, Deb;



void InitialisePads( void )
{
	Pad = Last = Deb = 0;
}

void Pad_Update( void )
{

	Pad = PadRead(0);
	Pad &=0xFFFF;
	Deb = ( Last ^ 0xffffffff ) & Pad;
	Last = Pad;
}

uint32	Pad_State( uint8 PadNumber )
{
	return Pad;
}

uint32	Pad_Debounced( uint8 PadNumber )
{
	return Deb;
}

