#ifndef BOULDER_H
#define BOULDER_H

/* max active boulders at any time */
#define MAX_BOULDERS		32

#define BOULDER_OBJECT_TYPE	125
#define BOULDER_MAX_TIME 150

#define BOULDER_ROT_X		0
#define BOULDER_ROT_Y		0
#define BOULDER_ROT_Z		128

typedef struct {
	long	state;
	long	strip_fraction;
	long	direction;
	VIEW_STRIP	trigger_strip;
	VIEW_STRIP	strip;
	VECTOR	pos;
	SVECTOR	rot;
	SVECTOR	spin;
} BOULDER;


typedef struct {
	long	active;
	VIEW_STRIP	loc;
} BOULDER_FLAG;


void 	InitBoulders();
long	DrawBoulders(long playerno,long current_strip);


/* in tracks.c */
extern objheader	ChillObjects[220];


#endif