
CACHE_START	=	$1f800000
CACHE_SIZE	=	1024
CACHE_END	=	CACHE_START+CACHE_SIZE


C2_VXY0	 equs	"r0"
C2_VZ0	 equs	"r1"
C2_VXY1	 equs	"r2"
C2_VZ1	 equs	"r3"
C2_VXY2	 equs	"r4"
C2_VZ2	 equs	"r5"
C2_RGB	 equs	"r6"
C2_OTZ	 equs	"r7"
C2_IR0	 equs	"r8"
C2_IR1	 equs	"r9"
C2_IR2	 equs	"r10"
C2_IR3	 equs	"r11"
C2_SXY0	 equs	"r12"
C2_SXY1	 equs	"r13"
C2_SXY2	 equs	"r14"
C2_SXY2P equs	"r15"
C2_SZX	 equs	"r16"
C2_SZ0	 equs	"r17"
C2_SZ1	 equs	"r18"
C2_SZ2	 equs	"r19"
C2_RGB0	 equs	"r20"
C2_RGB1	 equs	"r21"
C2_RGB2	 equs	"r22"
C2_RES1	 equs	"r23"
C2_MAC0	 equs	"r24"
C2_MAC1	 equs	"r25"
C2_MAC2	 equs	"r26"
C2_MAC3	 equs	"r27"
C2_IRGB	 equs	"r28"
C2_ORGB	 equs	"r29"
C2_DATA32 equs	"r30" 				; leading zero count
C2_LZC	 equs	"r31"				; 

C2C_R11R12 equs	"r0"
C2C_R13R21 equs	"r1"
C2C_R22R23 equs	"r2"
C2C_R31R32 equs	"r3"
C2C_R33	  equs	"r4"
C2C_TRX	  equs	"r5"
C2C_TRY	  equs	"r6"
C2C_TRZ	  equs	"r7"
C2C_L11L12 equs	"r8"
C2C_L13L21 equs	"r9"
C2C_L22L23 equs	"r10"
C2C_L31L32 equs	"r11"
C2C_L33	  equs	"r12"
C2C_RBK	 equs	"r13"
C2C_GBK	 equs	"r14"
C2C_BBK	 equs	"r15"
C2C_LR1LR2 equs	"r16"
C2C_LR3LG1 equs	"r17"
C2C_LG2LG3 equs	"r18"
C2C_LB1LB2 equs	"r19"
C2C_LB3	  equs	"r20"
C2C_RFC	 equs	"r21"
C2C_GFC	 equs	"r22"
C2C_BFC	 equs	"r23"
C2C_OFX	 equs	"r24"
C2C_OFY	 equs	"r25"
C2C_H	 equs	"r26"
C2C_DQA	 equs	"r27"
C2C_DQB	 equs	"r28"
C2C_1_3	 equs	"r29"
C2C_1_4	 equs	"r30"
C2C_FLAG0 equs	"r31"


;
; function	op code			f-num	speed (multiples of 3 cycles)
;

RotTransPers  =	   $180001	       	; f1	5-6
RotTransPers3 =	   $280030	       	; f2	8-9
RotTrans      =	$480012	   	  	; f3	2-3   results - MAC1-MAC3 for x/y/z .... SideFX - s
LocalLight    =	$4A6412	       	       	; f4	2-3
LightColour   =	$4DA412		   	; f5	3-4
DpqColorLight = $680029			; f6	2-3
DpqColor      = $780010		      	; f7	3-4
DpqColor3     = $F8002A		      	; f8	5-6
Intpl	      = $980011	             	; f9	3-4
Square12      = $A80428	       	       	; f10	1-2
Square0	      = $A00428	       	       	; f11	1-2
NormalColor   = $C8041E	             	; f12	4-5
NormalColor3  = $D80420	      	      	; f13	a-b
NormalColorDpq	= $E80413     	       	; f14	6-7
NormalColorDpq3	= $F80416     	       	; f15	f-10
NormalColorCol	= $108041B    	       	; f16	5-6
NormalColorCol3	= $118043F             	; f17	d-e
ColorDpq	= $1280414    	       	; f18	4-5
ColorCol	= $138041C    	       	; f19	3-4
NormalClip	= $1400006    	       	; f20	2-3
AverageZ3	= $158002D           	; f21	0-1
AverageZ4	= $168002E    	       	; f22	2-3
OuterProduct12	= $178000C    	       	; f23	2-3
OuterProduct0	= $170000C    	       	; f24	2-3 (r11r12) (r21r22) (r23r31) * (ir1) (ir2) (ir3) ---> MAC1 MAC2 MAC3
ScaleVector12	= $198003D       	; f25	2-3
ScaleVector0	= $190003D    	    	; f26	2-3
ScaleAccVec12	= $1A8003E    		; f27	2-3
ScaleAccVec0	= $1A0003E           	; f28	2-3
