SAVEREGS	MACRO
	; store the register save address
	lui	t8,RegSave>>16
	ori	t8,t8,RegSave&$ffff

	; save out the registers	
	sw	a0,(t8)
	sw	a1,4(t8)
	sw	a2,8(t8)
	sw	a3,12(t8)
	sw	s0,16(t8)
	sw	s1,20(t8)
	sw	s2,24(t8)
	sw	s3,28(t8)
	sw	s4,32(t8)
	sw	s5,36(t8)
	sw	s6,40(t8)
	sw	s7,44(t8)
	sw	t0,48(t8)
	sw	t1,52(t8)
	sw	t2,56(t8)
	sw	t3,60(t8)
	sw	t4,64(t8)
	sw	t5,68(t8)
	sw	t6,72(t8)
	sw	t7,76(t8)
	;sw	t8,80(t8)
	sw	t9,84(t8)
	sw	v0,88(t8)
	sw	v1,92(t8)
	nop
	nop
	nop
	nop

	ENDM



RESTOREREGS	MACRO

	; calc register save address
	lui	t8,RegSave>>16
	ori	t8,t8,RegSave&$ffff

	; re load the registers	
	lw	a0,(t8)
	lw	a1,4(t8)
	lw	a2,8(t8)
	lw	a3,12(t8)
	lw	s0,16(t8)
	lw	s1,20(t8)
	lw	s2,24(t8)
	lw	s3,28(t8)
	lw	s4,32(t8)
	lw	s5,36(t8)
	lw	s6,40(t8)
	lw	s7,44(t8)
	lw	t0,48(t8)
	lw	t1,52(t8)
	lw	t2,56(t8)
	lw	t3,60(t8)
	lw	t4,64(t8)
	lw	t5,68(t8)
	lw	t6,72(t8)
	lw	t7,76(t8)
	;lw	t8,80(t8)
	lw	t9,84(t8)
	lw	v0,88(t8)
	lw	v1,92(t8)
	nop
	nop
	nop
	nop


	ENDM


RUSSPUSHREGS	MACRO
	; store the register save address
	addi	sp,sp,-128

	; save out the registers	
	sw	a0,(sp)
	sw	a1,4(sp)
	sw	a2,8(sp)
	sw	a3,12(sp)
	sw	s0,16(sp)
	sw	s1,20(sp)
	sw	s2,24(sp)
	sw	s3,28(sp)
	sw	s4,32(sp)
	sw	s5,36(sp)
	sw	s6,40(sp)
	sw	s7,44(sp)
	sw	t0,48(sp)
	sw	t1,52(sp)
	sw	t2,56(sp)
	sw	t3,60(sp)
	sw	t4,64(sp)
	sw	t5,68(sp)
	sw	t6,72(sp)
	sw	t7,76(sp)
	sw	t8,80(sp)
	sw	t9,84(sp)
	sw	v0,88(sp)
	sw	v1,92(sp)
	nop
	nop
	nop
	nop

	ENDM

RUSSPOPREGS	MACRO
	; save out the registers	
	lw	a0,(sp)
	lw	a1,4(sp)
	lw	a2,8(sp)
	lw	a3,12(sp)
	lw	s0,16(sp)
	lw	s1,20(sp)
	lw	s2,24(sp)
	lw	s3,28(sp)
	lw	s4,32(sp)
	lw	s5,36(sp)
	lw	s6,40(sp)
	lw	s7,44(sp)
	lw	t0,48(sp)
	lw	t1,52(sp)
	lw	t2,56(sp)
	lw	t3,60(sp)
	lw	t4,64(sp)
	lw	t5,68(sp)
	lw	t6,72(sp)
	lw	t7,76(sp)
	lw	t8,80(sp)
	lw	t9,84(sp)
	lw	v0,88(sp)
	lw	v1,92(sp)
	
	; store the register save address
	addi	sp,sp,128
	nop
	nop
	nop
	nop

	ENDM

