#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "norman.h"
#include <inline_o.h>
#include <gtemac.h>


long				fin,count1,count2,count3;
long				filesize;
long				namelength;
long				notexturedmats;
long				tempanswer;
long				z,d;		/* temp */
long				geomx,geomy;
long				geomscreen;
long				noboundboxes;
char				filebuffer[200000];
char				tidfilebuffer[5000];
char				*tidfileptr;
char				outbuffer[200000];
char 				*fileptr;
char 				*polystartptr;
char				*boundstartptr;
char				hrcfilename[21]={'o','b','j','e','c','t','s','/',0,0,0,0,0,0,0,0,0,0,0,0,0 };
char				txtfilename[50]={'t','e','x','t','u','r','e','s','/',0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
char				psxobjname[17]={'p','s','x','/',0,0,0,0,0,0,0,0,0,0,0,0,0 };
char				satobjname[19]={'s','a','t','u','r','n','/',0,0,0,0,0,0,0,0,0,0,0,0 };

unsigned short		charindex,filecharindex;
unsigned int		textpage,clutpage;
unsigned int		x=255;
unsigned int		y=255;
long				flipvs=0;
long				paddebounced=0;

TIM_IMAGE	timheader;
char		cdres[2];

/* playstation stuff */

typedef struct objcollision
{
	long	type;
	VECTOR	info[4];
}objcollision;

typedef struct polygon
{
	long	numverts;
	long	polytype;		/* 1= textured 2=g-shade */
	long	tmatid;
	unsigned long 	vertptr;
	SVECTOR normals[4];
	unsigned long	textus;
	unsigned long	textvs;
	CVECTOR	basecolour;
}polygon;

typedef	struct textureid
{
	unsigned int textpage;
	unsigned int clutpage;
	long	x;
	long	y;
}textureid;

typedef struct tmat
{
	char ident[5];
	long textid;
	long x;
	long y;
	long w;
	long h;
}tmat;

textureid	tids[10];
tmat		tmats[100];
objcollision	BoundArray[10];
long		currenttmats[100];
long		matfound;
long		anymatfound;
long		anyboundfound;
long		notmats;
long		objecttid;
long		notpages;
long		numverts;
long		numpolys;
long		isflag=0;
long		noskisurfaces;
VECTOR		scalevector;
VECTOR		obscalevec;
SVECTOR		rotvector;
SVECTOR		lightvector;
SVECTOR		lightresvec;
MATRIX		transmatrix;
MATRIX		rotmatrix;
SVECTOR		vertices[1000];
SVECTOR		normals[1000];
short		nonorms[1000];
polygon		polys[1000];
POLY_FT4	polyf4s[2][1000];
POLY_FT3	polyf3s[2][1000];
POLY_F4		poly4s[2][1000];
POLY_F3		poly3s[2][1000];
CVECTOR		materials[50];
long		sxy[1000];
long		p[1000];
long		otz[1000];
long		flagdump;
long		savetmats[1000];
long		saveptype[1000];
CVECTOR		outputcolour;
long		polyus[4];
long		polyvs[4];
long reg0;
long reg1;
long reg2;
long reg3;
long reg4;
long p3s=0;
long pf3s=0;
long pf4s=0;
long p4s=0;
long a,b=1;

void findchar( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}

long findcheckflagchar( char a )
{
	long found,flagfound;

	found=0;
	flagfound=0;
	while (found==0)
	{
		if ((*fileptr=='f')&&(*(fileptr+1)=='l')&&(*(fileptr+2)=='a'))
		{
			flagfound=1;
		}
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
	return flagfound;
}


char *ptrfindchar( char a, char *p )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*p==a)
		{
			found=1;
		}
		else
		{
			p++;
		}
	}
	return p;
}


long findbackchar( char a )
{
	long found,c;

	found=0;
	c=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr--;
			c++;
		}
	}
	return c;
}

void findcharupeof( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr=='j')
		{
			if ((*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='c')
		{
			if ((*(fileptr+1)=='u')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='r')
		{
			if ((*(fileptr+1)=='a')&&(*(fileptr+2)=='d'))
			{
				found=1;
				fileptr--;
			}
		}

		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}


void findafterspace( void )
{
	long found;

	found=0;
	while (found==0)
	{
		if ((*fileptr==0x20)&&(*(fileptr+1)!=0x20))
		{
			found=1;
			fileptr++;
		}
		else
		{
			fileptr++;
		}
	}
}

long inttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x20)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans/100;
}

long eoltexttoint( char *fileptr )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x0d)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}

long ptrtexttoint( char *fp )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fp;
	tenscount=1;
	intans=0;
	fp++;
	while (*fp!=0x20)
	{
 		tenscount*=10;
 		fp++;
	}
	while (storeptr!=fp)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}


long verttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x20)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans/10;
}


long floattexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,gencount,intans;
	long negative=0;

	if (*fileptr=='-')
	{
		negative=1;
		fileptr++;
	}
	storeptr=fileptr;
	tenscount=1000;
	gencount=0;
	intans=0;
	fileptr++;
	while (*fileptr!='.')
	{
		tenscount*=10;
		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	fileptr++;
	tenscount=100;
	while (*fileptr!=0x20)
	{
		thischar[0]=*fileptr;
		intans+=atoi(&thischar[0])*tenscount;
		fileptr++;
		tenscount/=10;
	}
	if (negative==1)
	{
		intans=-intans;
	}
	return intans;
}

long	roundit( long a )
{
	a/=100;
	if ((a%10)>4)
	{
		a/=10;
		a++;
	}
	else
	{
		a/=10;
	}
	return a;
}

void drawpolys( void )
{
	long				fntid1;
	long				fntid2;
	long				fntid3;
	long				fntid4;
	long				fntid5;
	long				fntid6;
	long				c1,c2;
	POLY_F4  			clearsquare[2];
	MATRIX				MyLocalLight;
	MATRIX				MyColourMatrix;
	CVECTOR	    		PrimaryColourVector;
	CVECTOR				fc,bc;		/* temp */
	DRAWENV				drawenv[2];
	DISPENV				dispenv[2];
	long				OT[2][4096];
	long				*otptr;
	long				firstscreendrawn=0;
	long				exit=0;
	long				otid=0;
	long				display_id=0;
	long				thisotz;
	long				thisp;
	char				primstr[10]={'f','t','4',20,0,0,0,0,0,0};
	long				checksum;
	long				issaved=0;
	long				tempvz;

	void fliptextvs( void )
	{
		for (count1=0;count1<numpolys;count1++)
		{
			reg4=polys[count1].textvs;
			reg0=reg4&0xff;
			reg1=(reg4>>8)&0xff;
			reg2=(reg4>>16)&0xff;
			reg3=(reg4>>24)&0xff;
		   	reg0=((tmats[polys[count1].tmatid].y+(tmats[polys[count1].tmatid].h-1))-reg0)+tmats[polys[count1].tmatid].y;
		   	reg1=((tmats[polys[count1].tmatid].y+(tmats[polys[count1].tmatid].h-1))-reg1)+tmats[polys[count1].tmatid].y;
		   	reg2=((tmats[polys[count1].tmatid].y+(tmats[polys[count1].tmatid].h-1))-reg2)+tmats[polys[count1].tmatid].y;
		   	reg3=((tmats[polys[count1].tmatid].y+(tmats[polys[count1].tmatid].h-1))-reg3)+tmats[polys[count1].tmatid].y;
			polys[count1].textvs=reg0;
			polys[count1].textvs+=(reg1<<8);
			polys[count1].textvs+=(reg2<<16);
			polys[count1].textvs+=(reg3<<24);
		}
	}

	void savefile ( void )
	{
		long i;

		/* save tmats and save texture id's only*/

		for (i=0;i<numpolys;i++)
		{
			savetmats[i]=polys[i].tmatid;
			saveptype[i]=polys[i].polytype;
			if (notexturedmats==0)
			{
				polys[i].polytype=0;
			}
			else
			{
				if (polys[i].polytype==255)
				{
			    	polys[i].polytype=2;
				}
				else
				{
					if (polys[i].polytype>notexturedmats)
					{
						polys[i].polytype=0;
					}
					else
					{
						polys[i].polytype=1;
					}
				}
			}
			polys[i].tmatid=tmats[polys[i].tmatid].textid;
		}

		/* write file out */

		fin	=	PCopen( &psxobjname, 2, 0 );
		fileptr = &numverts;
		checksum=PCwrite(fin,fileptr,4);			/* write numverts */
		fileptr = &numpolys;
		checksum+=PCwrite(fin,fileptr,4);
		fileptr = &objecttid;
		checksum+=PCwrite(fin,fileptr,4);
		fileptr = &vertices;
		checksum+=PCwrite(fin,fileptr,(8*numverts));    /* verts */
		fileptr = &polys;
		checksum+=PCwrite(fin,fileptr,(60*numpolys));   /* polys */
		fileptr = &noboundboxes;
		checksum+=PCwrite(fin,fileptr,4);
		fileptr = &BoundArray[0];
		checksum+=PCwrite(fin,fileptr,(68*noboundboxes));
		PCclose(fin);
		if (checksum==(16+(8*numverts)+(60*numpolys)+(68*noboundboxes)))
		{
			printf("checksum is correct\n");
		}
		else
		{
			printf("checksum is not correct\n");
		}

		/* restore tmat info */
		for (i=0;i<numpolys;i++)
		{
			polys[i].tmatid=savetmats[i];
			polys[i].polytype=saveptype[i];
		}

	}

	void getpadshit( void )
	{
		long	thisvalue;

		thisvalue=PadRead( 0 );
		thisvalue&=0xffff;
		if (thisvalue==0)
		{
			paddebounced=0;
		}
		if (thisvalue&PADstart)
		{
			exit=1;
		}
		if (thisvalue&PADselect)
		{
			if (issaved==0)
			{
				savefile();
				issaved=1;
			}
		}
		if (thisvalue&PADR2)
		{
			if (paddebounced==0)
			{
				flipvs=(flipvs+1)%2;
				fliptextvs();
				if (issaved==1)
				{
					issaved=0;
				}
				paddebounced=1;
			}
		}
		if (thisvalue&PADL2)
		{
			if (paddebounced==0)
			{
				objecttid++;
				if (objecttid==notpages)
				{
					objecttid=0;
				}
				paddebounced=1;
			}
		}
		if (thisvalue&PADRright)
		{
			if (thisvalue&PADLleft)
			{
				rotvector.vx+=0x10;
				if (rotvector.vx>4096)
				{
					rotvector.vx%=4096;
				}
			}
			if (thisvalue&PADLright)
			{
				rotvector.vx-=0x10;
				if (rotvector.vx<0)
				{
					rotvector.vx+=4096;
				}
			}
			if (thisvalue&PADLup)
			{
				rotvector.vy+=0x10;
				if (rotvector.vy>4096)
				{
					rotvector.vy%=4096;
				}
			}
			if (thisvalue&PADLdown)
			{
				rotvector.vy-=0x10;
				if (rotvector.vy<0)
				{
					rotvector.vy+=4096;
				}
			}
			if (thisvalue&PADL1)
			{
				rotvector.vz+=0x10;
				if (rotvector.vz>4096)
				{
					rotvector.vz%=4096;
				}
			}
			if (thisvalue&PADR1)
			{
				rotvector.vz-=0x10;
				if (rotvector.vz<0)
				{
					rotvector.vz+=4096;
				}
			}
		}
		else
		{
			if (thisvalue&PADRup)
			{
				if (thisvalue&PADLleft)
				{
					scalevector.vx+=0x10;
				}
				if (thisvalue&PADLright)
				{
					scalevector.vx-=0x10;
				}
				if (thisvalue&PADLup)
				{
					scalevector.vy+=0x10;
				}
				if (thisvalue&PADLdown)
				{
					scalevector.vy-=0x10;
				}
				if (thisvalue&PADL1)
				{
					scalevector.vz+=0x10;
				}
				if (thisvalue&PADR1)
				{
					scalevector.vz-=0x10;
				}

			}
			else
			{
				if (thisvalue&PADLleft)
				{
					transmatrix.t[1]-=0x10;
				}
				if (thisvalue&PADLright)
				{
					transmatrix.t[1]+=0x10;
				}
				if (thisvalue&PADLup)
				{
					transmatrix.t[0]-=0x10;
				}
				if (thisvalue&PADLdown)
				{
					transmatrix.t[0]+=0x10;
				}
				if (thisvalue&PADL1)
				{
					transmatrix.t[2]+=0x10;
				}
				if (thisvalue&PADR1)
				{
					transmatrix.t[2]-=0x10;
				}
			}
		}
	}

//	printf("poly=%d",sizeof(polygon));
	SetDefDrawEnv(&drawenv[0],0,0,320,240);
	SetDefDispEnv(&dispenv[0],0,240,320,240);
	SetDefDrawEnv(&drawenv[1],0,240,320,240);
	SetDefDispEnv(&dispenv[1],0,0,320,240);
	PutDrawEnv(&drawenv[0]);
	PutDispEnv(&dispenv[0]);
	FntLoad(896,0);
	fntid1 = FntOpen(15,15,280,9,1,50);
	SetDumpFnt(fntid1);
	fntid2 = FntOpen(15,24,280,9,1,50);
	SetDumpFnt(fntid2);
	fntid3 = FntOpen(15,33,280,9,1,50);
	SetDumpFnt(fntid3);
	fntid4 = FntOpen(15,42,280,9,1,50);
	SetDumpFnt(fntid4);
	fntid6 = FntOpen(15,51,280,9,1,50);
	SetDumpFnt(fntid6);
	fntid5 = FntOpen(15,60,280,9,1,50);
	SetDumpFnt(fntid5);
	geomx=120;
	geomy=160;
	SetGeomOffset(geomx,geomy);      /* 160,120 */
	geomscreen=340;
	SetGeomScreen( geomscreen );        /* 512 */
	fc.r=0;    /* 148,148,196 */
	fc.g=0;
	fc.b=0;
	z=4000;
	d=800;
	bc.r=200;
	bc.g=200;
	bc.b=200;
	SetFarColor(fc.r,fc.g,fc.b);
	SetFogNear(z,d);
	SetBackColor(bc.r,bc.g,bc.b);
	for (c1=0;c1<2;c1++)
	{
		clearsquare[c1].x0=0;
		clearsquare[c1].x1=320;
		clearsquare[c1].y0=0;
		clearsquare[c1].y1=0;
		clearsquare[c1].x2=0;
		clearsquare[c1].x3=320;
		clearsquare[c1].y2=240;
		clearsquare[c1].y3=240;
		clearsquare[c1].r0=100;           /* 148 */
		clearsquare[c1].g0=100;           /* 148 */
		clearsquare[c1].b0=230;           /* 196 */
	}
	for (c1=0;c1<3;c1++)
	{
		for (c2=0;c2<3;c2++)
		{
			if (c2==0)
			{
	  			MyColourMatrix.m[c1][c2]=0x1000;
			}
			else
			{
 				MyColourMatrix.m[c1][c2]=0;
			}
			if (c1==c2)
			{
				rotmatrix.m[c1][c2]=0x1000;
				MyLocalLight.m[c1][c2]=0x1000;
			}
			else
			{
				rotmatrix.m[c1][c2]=0;
				MyLocalLight.m[c1][c2]=0;
			}
		}
		MyLocalLight.t[c1]=1000;
		MyColourMatrix.t[c1]=0;
	}
	lightvector.vx=0;
	lightvector.vy=0;
	lightvector.vz=-1000;
	SetLightMatrix(&MyLocalLight);
	SetColorMatrix(&MyColourMatrix);
	PrimaryColourVector.r=128;
	PrimaryColourVector.g=128;
	PrimaryColourVector.b=128;
/*	for (c1=0;c1<numverts;c1++)
	{
		normals[c1].vx/=nonorms[c1];
		normals[c1].vy/=nonorms[c1];
		normals[c1].vz/=nonorms[c1];
	}
	for (c1=0;c1<numpolys;c1++)
	{
		for (c2=0;c2<polys[c1].numverts;c2++)
		{
			polys[c1].normals[c2].vx=normals[(polys[c1].vertptr>>(8*c2))&0xFF].vx;
			polys[c1].normals[c2].vy=normals[(polys[c1].vertptr>>(8*c2))&0xFF].vy;
			polys[c1].normals[c2].vz=normals[(polys[c1].vertptr>>(8*c2))&0xFF].vz;
		}
	}   */

	while (exit==0)
	{
		getpadshit();
		pollhost();
		otptr=&OT[otid][0];
		ClearOTagR(otptr,4096);
		geomx=120; /* 180 */
		geomy=160;
		gte_SetGeomOffset(geomx,geomy);
		gte_SetGeomScreen(geomscreen);                   /* temp */

		SetFarColor(fc.r,fc.g,fc.b);
		SetFogNear(z,d);
//		SetFogFar(z,d);
		SetBackColor(bc.r,bc.g,bc.b);

//		ClearOTag(otptr,1024);
//		tempvz=rotvector.vz;
//		rotvector.vy+=2048;
		RotMatrix(&rotvector,&rotmatrix);
//		RotMatrixZ(tempvz,&rotmatrix);
		ScaleMatrix(&rotmatrix,&scalevector);
		gte_SetTransMatrix(&transmatrix);
		gte_SetRotMatrix(&rotmatrix);

		ApplyMatrixSV(&rotmatrix,&lightvector,&lightresvec);
		MyLocalLight.m[0][0]=-lightresvec.vx;
		MyLocalLight.m[0][1]=-lightresvec.vy;
		MyLocalLight.m[0][2]=lightresvec.vz;

		gte_SetLightMatrix(&MyLocalLight);
		gte_SetColorMatrix(&MyColourMatrix);


		clearsquare[otid].y0=0;
		clearsquare[otid].y1=0;
 		clearsquare[otid].y2=240;
 		clearsquare[otid].y3=240;
		SetPolyF4(&clearsquare[otid]);
		otptr=&OT[otid][4095];
//		otptr=&OT[otid][0];

		AddPrim(otptr,&clearsquare[otid]);
		p3s=0;
		pf3s=0;
		pf4s=0;
		p4s=0;
		for (a=0;a<b;a++)
		{
			for (c1=0;c1<numverts;c1++)
			{
				gte_RotTransPers(&vertices[c1],&sxy[c1],&p[c1],&flagdump,&otz[c1]);
			}
			for (c1=0;c1<numpolys;c1++)
			{
				thisotz=0;
				thisp=0;
				reg4=polys[c1].vertptr;
				for (c2=0;c2<polys[c1].numverts;c2++)
				{
					thisotz+=otz[(reg4>>(8*c2))&0xFF];
					thisp+=p[(reg4>>(8*c2))&0xFF];
				}
				thisotz/=polys[c1].numverts;
				if (polys[c1].numverts==4)
				{
					if ((polys[c1].polytype<=notexturedmats)||(polys[c1].polytype==255))
					{
						if ((thisotz>=1)&&(thisotz<4096))
						{
							thisp/=4;

							reg0=reg4&0xFF;
							reg1=(reg4>>8)&0xFF;
							reg2=(reg4>>16)&0xFF;
							reg3=(reg4>>24)&0xFF;
							gte_NormalColorDpq(&polys[c1].normals[0],&PrimaryColourVector,thisp,&outputcolour);
							setXY4(&polyf4s[otid][pf4s],((sxy[reg0])&0xffff0000)>>16,
										   			(sxy[reg0])&0xffff,
										  			((sxy[reg1])&0xffff0000)>>16,
										   			(sxy[reg1])&0xffff,
										  			((sxy[reg3])&0xffff0000)>>16,
										   			(sxy[reg3])&0xffff,
										  			((sxy[reg2])&0xffff0000)>>16,
										   			(sxy[reg2])&0xffff);
	//						if (thisp>0)
	//						{
	//							setRGB0(&polyf4s[otid][c1],230-outputcolour.r,230-outputcolour.g,230-outputcolour.b);
	//						}
	//						else
	//						{
								setRGB0(&polyf4s[otid][pf4s],outputcolour.r,outputcolour.g,outputcolour.b);
	//						}
	//						if (flipvs==0)
	//						{
								reg0=polys[c1].textus;
								reg1=polys[c1].textvs;
								polyf4s[otid][pf4s].u0=reg0&0xFF;
								polyf4s[otid][pf4s].v0=reg1&0xFF;
								polyf4s[otid][pf4s].u1=(reg0>>8)&0xFF;
								polyf4s[otid][pf4s].v1=(reg1>>8)&0xFF;
								polyf4s[otid][pf4s].u2=(reg0>>24)&0xFF;
								polyf4s[otid][pf4s].v2=(reg1>>24)&0xFF;
								polyf4s[otid][pf4s].u3=(reg0>>16)&0xFF;
								polyf4s[otid][pf4s].v3=(reg1>>16)&0xFF;
	/*						}
							else
							{
								polyf4s[otid][c1].u0=polys[c1].textus[0];
								polyf4s[otid][c1].v0=y-polys[c1].textvs[0];
								polyf4s[otid][c1].u1=polys[c1].textus[1];
								polyf4s[otid][c1].v1=y-polys[c1].textvs[1];
								polyf4s[otid][c1].u2=polys[c1].textus[3];
								polyf4s[otid][c1].v2=y-polys[c1].textvs[3];
								polyf4s[otid][c1].u3=polys[c1].textus[2];
								polyf4s[otid][c1].v3=y-polys[c1].textvs[2];
							}   */
							polyf4s[otid][pf4s].tpage=tids[tmats[polys[c1].tmatid].textid].textpage;
							polyf4s[otid][pf4s].clut=tids[tmats[polys[c1].tmatid].textid].clutpage;
							SetPolyFT4(&polyf4s[otid][pf4s]);
	//						otptr=&(OT[otid][1024-thisotz]);
							otptr=&(OT[otid][thisotz]);
							AddPrim(otptr,&polyf4s[otid][pf4s]);
							pf4s++;
						}
					}
					else
					{
						if ((thisotz>=1)&&(thisotz<4096))
						{
							thisp/=4;
							reg4=polys[c1].vertptr;
							reg0=reg4&0xFF;
							reg1=(reg4>>8)&0xFF;
							reg2=(reg4>>16)&0xFF;
							reg3=(reg4>>24)&0xFF;

	//						if (polys[c1].polytype>=(notexturedmats+1))
	//						{
								polys[c1].basecolour.r=materials[polys[c1].polytype-(notexturedmats+1)].r;
								polys[c1].basecolour.g=materials[polys[c1].polytype-(notexturedmats+1)].g;
								polys[c1].basecolour.b=materials[polys[c1].polytype-(notexturedmats+1)].b;
								gte_NormalColorDpq(&polys[c1].normals[0],&polys[c1].basecolour,thisp,&outputcolour);
	//						}
	//						else
	//						{
	//							gte_NormalColorDpq(&polys[c1].normals[0],&PrimaryColourVector,thisp,&outputcolour);
	//						}
							setXY4(&poly4s[otid][p4s],((sxy[reg0])&0xffff0000)>>16,
										   			(sxy[reg0])&0xffff,
										  			((sxy[reg1])&0xffff0000)>>16,
										   			(sxy[reg1])&0xffff,
										  			((sxy[reg3])&0xffff0000)>>16,
										   			(sxy[reg3])&0xffff,
										  			((sxy[reg2])&0xffff0000)>>16,
										   			(sxy[reg2])&0xffff);

							setRGB0(&poly4s[otid][p4s],outputcolour.r,outputcolour.g,outputcolour.b);
							SetPolyF4(&poly4s[otid][p4s]);
	//						otptr=&(OT[otid][1024-thisotz]);
							otptr=&(OT[otid][thisotz]);
							AddPrim(otptr,&poly4s[otid][p4s]);
							p4s++;
						}

					}
				}
				else
				{
					if ((polys[c1].polytype<=notexturedmats)||(polys[c1].polytype==255))
					{
						if ((thisotz>=1)&&(thisotz<4096))
						{
							thisp/=3;
							reg4=polys[c1].vertptr;
							reg0=reg4&0xFF;
							reg1=(reg4>>8)&0xFF;
							reg2=(reg4>>16)&0xFF;
							gte_NormalColorDpq(&polys[c1].normals[0],&PrimaryColourVector,thisp,&outputcolour);
							setXY3(&polyf3s[otid][pf3s],((sxy[reg0])&0xffff0000)>>16,
										   			(sxy[reg0])&0xffff,
										  			((sxy[reg1])&0xffff0000)>>16,
										   			(sxy[reg1])&0xffff,
										  			((sxy[reg2])&0xffff0000)>>16,
										   			(sxy[reg2])&0xffff);
							setRGB0(&polyf3s[otid][pf3s],outputcolour.r,outputcolour.g,outputcolour.b);
	//						if (flipvs==0)
	//						{
								reg0=polys[c1].textus;
								reg1=polys[c1].textvs;
								polyf3s[otid][pf3s].u0=reg0&0xFF;
								polyf3s[otid][pf3s].v0=reg1&0xFF;
								polyf3s[otid][pf3s].u1=(reg0>>8)&0xFF;
								polyf3s[otid][pf3s].v1=(reg1>>8)&0xFF;
								polyf3s[otid][pf3s].u2=(reg0>>16)&0xFF;
								polyf3s[otid][pf3s].v2=(reg1>>16)&0xFF;

	/*						}
							else
							{
								polyf3s[otid][c1].u0=polys[c1].textus[0];
								polyf3s[otid][c1].v0=y-polys[c1].textvs[0];
								polyf3s[otid][c1].u1=polys[c1].textus[1];
								polyf3s[otid][c1].v1=y-polys[c1].textvs[1];
								polyf3s[otid][c1].u2=polys[c1].textus[2];
								polyf3s[otid][c1].v2=y-polys[c1].textvs[2];
							}   */
							polyf3s[otid][pf3s].tpage=tids[tmats[polys[c1].tmatid].textid].textpage;
							polyf3s[otid][pf3s].clut=tids[tmats[polys[c1].tmatid].textid].clutpage;
							SetPolyFT3(&polyf3s[otid][pf3s]);
							otptr=&(OT[otid][thisotz]);
							AddPrim(otptr,&polyf3s[otid][pf3s]);
							pf3s++;
						}
					}
					else
					{
						if ((thisotz>=1)&&(thisotz<4096))
						{
							thisp/=3;
							reg4=polys[c1].vertptr;
							reg0=reg4&0xFF;
							reg1=(reg4>>8)&0xFF;
							reg2=(reg4>>16)&0xFF;

	//						if (polys[c1].polytype>=(notexturedmats+1))
	//						{
								polys[c1].basecolour.r=materials[polys[c1].polytype-(notexturedmats+1)].r;
								polys[c1].basecolour.g=materials[polys[c1].polytype-(notexturedmats+1)].g;
								polys[c1].basecolour.b=materials[polys[c1].polytype-(notexturedmats+1)].b;
								gte_NormalColorDpq(&polys[c1].normals[0],&polys[c1].basecolour,thisp,&outputcolour);
	//						}
	//						else
	//						{
	//							gte_NormalColorDpq(&polys[c1].normals[0],&PrimaryColourVector,thisp,&outputcolour);
	//						}
							setXY3(&poly3s[otid][p3s],((sxy[reg0])&0xffff0000)>>16,
										   			(sxy[reg0])&0xffff,
										  			((sxy[reg1])&0xffff0000)>>16,
										   			(sxy[reg1])&0xffff,
										  			((sxy[reg2])&0xffff0000)>>16,
										   			(sxy[reg2])&0xffff);

							setRGB0(&poly3s[otid][p3s],outputcolour.r,outputcolour.g,outputcolour.b);
							SetPolyF3(&poly3s[otid][p3s]);
							otptr=&(OT[otid][thisotz]);
							AddPrim(otptr,&poly3s[otid][p3s]);
							p3s++;
						}
					}
				}
			}
		}

		pollhost();
		DrawSync(0);
		VSync (0);
		FntPrint(fntid1,"NORMAN ver: %s %s",__DATE__,__TIME__);
		FntFlush(fntid1);
		FntPrint(fntid2,"Pos x:%d y:%d z:%d",transmatrix.t[0],transmatrix.t[1],transmatrix.t[2]);
		FntFlush(fntid2);
		FntPrint(fntid3,"Rot x:%d y:%d z:%d",rotvector.vx,rotvector.vy,rotvector.vz+1024);
		FntFlush(fntid3);
		FntPrint(fntid4,"Sca x:%d y:%d x:%d",scalevector.vx,scalevector.vy,scalevector.vz);
		FntFlush(fntid4);
		if (flipvs==1)
		{
			FntPrint(fntid6,"ss:%d bb:%d - v's flipped.",noskisurfaces,noboundboxes);
			FntFlush(fntid6);
		}
		else
		{
			FntPrint(fntid6,"ss:%d bb:%d",noskisurfaces,noboundboxes);
			FntFlush(fntid6);
		}
		if (issaved==1)
		{
			if (flipvs==0)
			{
				FntPrint(fntid5,"saved %s.\n",&psxobjname);
			}
			else
			{
				FntPrint(fntid5,"saved %s (v flip).\n",&psxobjname);
			}
			FntFlush(fntid5);
		}
		PutDrawEnv(&drawenv[display_id]);
		PutDispEnv(&dispenv[display_id]);
		otptr=&OT[otid][4095];
//		otptr=&OT[otid][0];
		DrawOTag(otptr);
		if (firstscreendrawn==0)
		{
			SetDispMask(1);
			firstscreendrawn=1;
		}
		display_id=(display_id+1)%2;
		otid=(otid+1)%2;
	}

	PadStop();
}


void main ( void )
{

	long	parsefound,vertindex;
	char 	*pointerstore;
	long	*timsizeptr;
	long	timsize;
	long	tempus,tempvs;
	char	*tpageptr;
	long	i,j,k;

	PCinit();
	PadInit(0);
	ResetGraph(0);
//	SetGraphDebug(2);
	InitGeom();
	srand(1);


	fin			=	PCopen( "control.txt", 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );

	/* copy filenames from control file */

	anyboundfound=0;
	filecharindex=8;
	for (count1=0;count1<12;count1++)
	{
		if (*fileptr!=0x0d)
		{
			hrcfilename[filecharindex]=*fileptr;
			fileptr++;
			filecharindex++;
		}
		else
		{
			hrcfilename[filecharindex]=0;
			filecharindex++;
		}
	}
//	fileptr+=2;
//	objecttid=eoltexttoint(fileptr);

	/* load texture id file */

	fin			=	PCopen( "textures/tid.txt", 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	tpageptr		=	&tidfilebuffer;
	PCread( fin, (char *)tpageptr, filesize );
	PCclose( fin );

	notpages=eoltexttoint(tpageptr);
	tpageptr+=3;
	for (count2=0;count2<notpages;count2++)
	{
		filecharindex=9;
		for (count1=0;count1<42;count1++)
		{
			if (*tpageptr!=0x0d)
			{
				txtfilename[filecharindex]=*tpageptr;
				tpageptr++;
				filecharindex++;
			}
			else
			{
				txtfilename[filecharindex]=0;
				filecharindex++;
			}
		}
		tpageptr+=2;
		/* read texture into VRAM */

		fin	   		=	PCopen( &txtfilename, 0, 0 );
		filesize	=	PClseek( fin, 0, 2 );
		PClseek( fin, 0, 0 );
		fileptr		=	&filebuffer;
		PCread( fin, (char *)fileptr, filesize );
		PCclose( fin );

		timsizeptr=&filebuffer;
		timsizeptr+=2;
		timsize=*timsizeptr;
		timsize/=4;
		timsizeptr+=timsize;
		timsizeptr+=2;
		timsize=*timsizeptr;
		y=((timsize&0xffff0000)>>16)-1;
		x=((timsize&0xffff)*2)-1;
		tids[count2].x=x;
		tids[count2].y=y;
		OpenTIM((char *)fileptr);
		ReadTIM(&timheader);
		if (count2<5)
		{
			LoadTPage(timheader.paddr,1,0,(320+(count2*128)),0,x+1,y+1);  /* 96 */
			tids[count2].textpage=GetTPage(1,0,(320+(count2*128)),0);
		}
		else
		{
			LoadTPage(timheader.paddr,1,0,(320+((count2-5)*128)),256,x+1,y+1);  /* 96 */
			tids[count2].textpage=GetTPage(1,0,(320+((count2-5)*128)),256);
		}
		LoadClut(timheader.caddr,0,(480+count2));
		tids[count2].clutpage=GetClut(0,(480+count2));
	}

	fin			=	PCopen( "textures/tmats.txt", 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	tpageptr		=	&tidfilebuffer;
	PCread( fin, (char *)tpageptr, filesize );
	PCclose( fin );

	notmats=eoltexttoint(tpageptr);
	for (count1=0;count1<notmats;count1++)
	{
		tpageptr=ptrfindchar(0x0a,tpageptr);
		tpageptr++;
		for (count2=0;count2<5;count2++)
		{
			tmats[count1].ident[count2]=*(tpageptr+count2);
		}
		tpageptr=ptrfindchar(0x20,tpageptr);
		tpageptr++;
		tmats[count1].textid=ptrtexttoint(tpageptr);
		tpageptr=ptrfindchar(0x20,tpageptr);
		tpageptr++;
		tmats[count1].x=ptrtexttoint(tpageptr);
		tpageptr=ptrfindchar(0x20,tpageptr);
		tpageptr++;
		tmats[count1].y=ptrtexttoint(tpageptr);
		tpageptr=ptrfindchar(0x20,tpageptr);
		tpageptr++;
		tmats[count1].w=ptrtexttoint(tpageptr);
		tpageptr=ptrfindchar(0x20,tpageptr);
		tpageptr++;
		tmats[count1].h=eoltexttoint(tpageptr);

	}

	/* initialise normals */

	for (i=0;i<1000;i++)
	{
//		normals[i].vx=normals[i].vy=normals[i].vz=0;
		nonorms[i]=0;
	}

	/* read in hrc file */

	fin			=	PCopen( &hrcfilename, 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );
	*(fileptr+filesize)='j';
	*(fileptr+filesize+1)='e';
	*(fileptr+filesize+2)='b';
	/* parse hrc file */

	/* file model tag */
	parsefound=0;
	while (parsefound==0)
	{
		findchar('m');
		if ((*(fileptr+1)=='o')&&(*(fileptr+2)=='d'))
		{
			parsefound=1;
		}
		else
		{
			fileptr++;
		}
	}
	if (parsefound==1)
	{
		parsefound=0;
		while (parsefound==0)
		{
			findchar('n');
			if ((*(fileptr+1)=='a')&&(*(fileptr+2)=='m'))
			{
				parsefound=1;
			}
			else
			{
				fileptr++;
			}
		}
		if (parsefound==1)
		{
			findchar('"');
			count1=0;
			fileptr++;
#ifdef PSX
			filecharindex=4;
			while (*fileptr!='"')
			{
				psxobjname[filecharindex]=*fileptr;
				count1++;
				filecharindex++;
				fileptr++;
				if (count1>7)
				{
					findchar('"');
				}
			}
			psxobjname[filecharindex]='.';
			psxobjname[filecharindex+1]='o';
			psxobjname[filecharindex+2]='b';
			psxobjname[filecharindex+3]='j';
			filecharindex+=4;
			count1+=4;
			if (count1<11)
			{
				psxobjname[filecharindex]=0;
				filecharindex++;
				count1++;
			}
#endif

#ifdef SATURN
			filecharindex=7;
			while (*fileptr!='"')
			{
				satobjname[filecharindex]=*fileptr;
				count1++;
				filecharindex++;
				fileptr++;
				if (count1>7)
				{
					findchar('"');
				}
			}
			satobjname[filecharindex]='.';
			satobjname[filecharindex+1]='o';
			satobjname[filecharindex+2]='b';
			satobjname[filecharindex+3]='j';
			filecharindex+=4
			count1+=4;
			if (count1<11)
			{
				satobjname[filecharindex]=0;
				filecharindex++;
				count1++;
			}
#endif
			parsefound=0;
			while (parsefound==0)
			{
				findchar('s');
				if ((*(fileptr+1)=='c')&&(*(fileptr+2)=='a'))
				{
					parsefound=1;
				}
				else
				{
					fileptr++;
				}
			}
			if (parsefound==1)
			{
				findafterspace();
				tempanswer=floattexttoint();
				scalevector.vx=(tempanswer*4096)/1000;           /* scale x */
				findafterspace();
				tempanswer=floattexttoint();
				scalevector.vy=(tempanswer*4096)/1000;           /* scale y */
				findafterspace();
				tempanswer=floattexttoint();
				scalevector.vz=(tempanswer*4096)/1000;           /* scale z */
				parsefound=0;
				while (parsefound==0)
				{
					findchar('r');
					if ((*(fileptr+1)=='o')&&(*(fileptr+2)=='t'))
					{
						parsefound=1;
					}
					else
					{
						fileptr++;
					}
				}
				if (parsefound==1)
				{
					findafterspace();
					tempanswer=floattexttoint();
					rotvector.vx=(tempanswer*4096)/1000;           /* rot x */
					findafterspace();
					tempanswer=floattexttoint();
					rotvector.vy=(tempanswer*4096)/1000;           /* rot y */
					findafterspace();
					tempanswer=floattexttoint();
					rotvector.vz=(tempanswer*4096)/1000;           /* rot z */
					rotvector.vz-=1024;
					parsefound=0;
					while (parsefound==0)
					{
						findchar('t');
						if ((*(fileptr+1)=='r')&&(*(fileptr+2)=='a'))
						{
							parsefound=1;
						}
						else
						{
							fileptr++;
						}
					}
					if (parsefound==1)
					{
						findafterspace();
						tempanswer=floattexttoint();
//						transmatrix.t[0]=roundit(tempanswer);           /* trans x */
						findafterspace();
						tempanswer=floattexttoint();
//						transmatrix.t[1]=roundit(tempanswer);           /* trans y */
						findafterspace();
						tempanswer=floattexttoint();
//						transmatrix.t[2]=roundit(tempanswer);           /* trans z */

						/* now parse the vertices and polys */

						parsefound=0;
						while (parsefound==0)
						{
							findchar('t');
							if ((*(fileptr+1)=='i')&&(*(fileptr+2)=='c'))
							{
								parsefound=1;
							}
							else
							{
								fileptr++;
							}
						}
						if (parsefound==1)
						{
							findafterspace();
							numverts=inttexttoint();

							/* vertices */
							for (count1=0;count1<numverts;count1++)
							{
								findchar('[');
								vertindex=verttexttoint();
								findafterspace();
								findafterspace();
								tempanswer=floattexttoint();
								vertices[vertindex].vx=roundit(tempanswer);           /* x */
								findafterspace();
								tempanswer=floattexttoint();
								vertices[vertindex].vy=roundit(tempanswer);           /* y */
								findafterspace();
								tempanswer=floattexttoint();
								vertices[vertindex].vz=roundit(tempanswer);           /* z */
							}
							parsefound=0;
							while (parsefound==0)
							{
								findchar('g');
								if ((*(fileptr+1)=='o')&&(*(fileptr+2)=='n'))
								{
									parsefound=1;
								}
								else
								{
									fileptr++;
								}
							}
							if (parsefound==1)
							{
								findafterspace();
								numpolys=inttexttoint();
								polystartptr=fileptr;
								parsefound=0;
								while (parsefound==0)
								{
									findchar('m');
									if ((*(fileptr+1)=='a')&&(*(fileptr+2)=='t'))
									{
										parsefound=1;
									}
									else
									{
										fileptr++;
									}
								}
								if (parsefound==1)
								{
//									while (*fileptr!=0xff)
									while (1)
									{
										findcharupeof('[');
										if ((*fileptr=='j')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
										{
											anyboundfound=0;
											break;
										}
										if ((*fileptr=='c')&&(*(fileptr+1)=='u')&&(*(fileptr+2)=='b'))
										{
											anyboundfound=1;
											boundstartptr=fileptr;
											break;
										}
										if ((*fileptr=='r')&&(*(fileptr+1)=='a')&&(*(fileptr+2)=='d'))
										{
											anyboundfound=1;
											boundstartptr=fileptr;
											break;
										}
										if (*(fileptr-5)=='e')
										{
											notexturedmats=vertindex;
											findchar('"');
											fileptr++;
											findchar('"');
											namelength=findbackchar('/');
											fileptr++;

											/* match texture name */
											anymatfound=0;
											for (count1=0;count1<notmats;count1++)
											{
												matfound=1;
												for (count2=0;count2<5;count2++)
												{
													if (*(fileptr+count2)!=tmats[count1].ident[count2])
													{
														matfound=0;
													}
												}
												if (matfound==1)
												{
													currenttmats[notexturedmats-1]=count1;
													anymatfound=1;
													break;
												}
											}
											if (anymatfound==0)
											{
												printf("textured material %d not found \n",notexturedmats);
												currenttmats[notexturedmats-1]=0;
											}

										}
										else
										{
											vertindex=verttexttoint()/100;
										}
										if (vertindex==0)
										{

										}
										else
										{
											if (vertindex>notexturedmats)
											{
												findcharupeof('f');
												findafterspace();
												materials[vertindex-(notexturedmats+1)].r=(floattexttoint()*255)/1000;
												findafterspace();
												materials[vertindex-(notexturedmats+1)].g=(floattexttoint()*255)/1000;
												findafterspace();
												materials[vertindex-(notexturedmats+1)].b=(floattexttoint()*255)/1000;
											}
										}
									}
								}

								/* place textured material info in relavent polygons */
								fileptr=polystartptr;
								isflag=0;
								noskisurfaces=0;
								for (count1=0;count1<numpolys;count1++)
								{
									findchar('s');
									findafterspace();
									polys[count1].numverts=inttexttoint();
									polys[count1].vertptr=0;
									for (count2=0;count2<polys[count1].numverts;count2++)
									{
										findchar('x');
										findafterspace();
										polys[count1].vertptr+=inttexttoint()<<(count2*8);
										findchar('l');
										findafterspace();
										polys[count1].normals[count2].vx=(floattexttoint()*4096)/1000;
										findafterspace();
										polys[count1].normals[count2].vy=(floattexttoint()*4096)/1000;
										findafterspace();
										polys[count1].normals[count2].vz=(floattexttoint()*4096)/1000;
										if (nonorms[(polys[count1].vertptr>>(8*count2))&0xFF]==0)
										{
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vx=polys[count1].normals[count2].vx;
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vy=polys[count1].normals[count2].vy;
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vz=polys[count1].normals[count2].vz;
											nonorms[(polys[count1].vertptr>>(8*count2))&0xFF]++;
										}
										else
										{
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vx+=polys[count1].normals[count2].vx;
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vy+=polys[count1].normals[count2].vy;
											normals[(polys[count1].vertptr>>(8*count2))&0xFF].vz+=polys[count1].normals[count2].vz;
											nonorms[(polys[count1].vertptr>>(8*count2))&0xFF]++;
										}
										findchar('T');
										findafterspace();
										tempus=floattexttoint();
										if (tempus<0)
										{
											tempus=0;
										}
										polyus[count2]=tempus;
										findafterspace();
										tempvs=floattexttoint();
										if (tempvs<0)
										{
											tempvs=0;
										}
										polyvs[count2]=tempvs;
									}
									findchar('l');
									findafterspace();
									polys[count1].polytype=inttexttoint();
									if (polys[count1].polytype<=notexturedmats)
									{
										polys[count1].tmatid=currenttmats[polys[count1].polytype-1];
										polys[count1].polytype=1;
										for (count2=0;count2<polys[count1].numverts;count2++)
										{
											polyus[count2]=(polyus[count2]*(tmats[polys[count1].tmatid].w-1))/1000;
											polyus[count2]+=tmats[polys[count1].tmatid].x;
											polyvs[count2]=(polyvs[count2]*(tmats[polys[count1].tmatid].h-1))/1000;
											polyvs[count2]+=tmats[polys[count1].tmatid].y;
											polys[count1].textus+=polyus[count2]<<(count2*8);
											polys[count1].textvs+=polyvs[count2]<<(count2*8);
   										}
									}
									isflag=findcheckflagchar(']');
									if (isflag==1)
									{
										polys[count1].polytype=255;
										noskisurfaces++;
									}
								}

								/* bounding boxes */
								noboundboxes=0;
								if (anyboundfound==1)
								{
									fileptr=boundstartptr;
									while (1)
									{
										if ((*fileptr=='r')&&(*(fileptr+1)=='a')&&(*(fileptr+2)=='d'))
										{
											findchar('s');
											findafterspace();
											BoundArray[noboundboxes].type=0;
											BoundArray[noboundboxes].info[0].vx=(floattexttoint()*4096)/1000;
											findafterspace();
											BoundArray[noboundboxes].info[0].vy=(floattexttoint()*4096)/1000;
											findafterspace();
											BoundArray[noboundboxes].info[0].vz=(floattexttoint()*4096)/1000;
											noboundboxes++;
										}
										if ((*fileptr=='c')&&(*(fileptr+1)=='u')&&(*(fileptr+2)=='b'))
										{
											findchar('s');
											findafterspace();
											BoundArray[noboundboxes].type=1;
											obscalevec.vx=(floattexttoint()*4096)/1000;
											findafterspace();
											obscalevec.vy=(floattexttoint()*4096)/1000;
											findafterspace();
											obscalevec.vz=(floattexttoint()*4096)/1000;
											findchar('l');
											findafterspace();
											BoundArray[noboundboxes].info[0].vx=(floattexttoint()*4096)/1000;
											findafterspace();
											BoundArray[noboundboxes].info[0].vy=(floattexttoint()*4096)/1000;
											findafterspace();
											BoundArray[noboundboxes].info[0].vz=(floattexttoint()*4096)/1000;

											BoundArray[noboundboxes].info[1].vx=BoundArray[noboundboxes].info[0].vx+obscalevec.vx;
											BoundArray[noboundboxes].info[1].vy=BoundArray[noboundboxes].info[0].vy;
											BoundArray[noboundboxes].info[1].vz=BoundArray[noboundboxes].info[0].vz;

		   									BoundArray[noboundboxes].info[2].vx=BoundArray[noboundboxes].info[0].vx;
											BoundArray[noboundboxes].info[2].vy=BoundArray[noboundboxes].info[0].vy;
											BoundArray[noboundboxes].info[2].vz=BoundArray[noboundboxes].info[0].vz+obscalevec.vz;

											BoundArray[noboundboxes].info[3].vx=BoundArray[noboundboxes].info[0].vx;
											BoundArray[noboundboxes].info[3].vy=BoundArray[noboundboxes].info[0].vy+obscalevec.vy;
											BoundArray[noboundboxes].info[3].vz=BoundArray[noboundboxes].info[0].vz;

											BoundArray[noboundboxes].info[0].vx=-BoundArray[noboundboxes].info[0].vx;
											BoundArray[noboundboxes].info[1].vx=-BoundArray[noboundboxes].info[1].vx;
											BoundArray[noboundboxes].info[2].vx=-BoundArray[noboundboxes].info[2].vx;
											BoundArray[noboundboxes].info[3].vx=-BoundArray[noboundboxes].info[3].vx;
											noboundboxes++;
										}
										findcharupeof('"');
										if ((*fileptr=='j')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
										{
											break;
										}
										fileptr++;
									}
								}

								/* the parsing is at last finished */

								drawpolys();
							}
							else
							{
								printf("no poly tag found\n");
							}
						}
						else
						{
							printf("vertices tag not found\n");
						}
					}
					else
					{
						printf("trans tag not found\n");
					}
				}
				else
				{
					printf("rot tag not found\n");
				}
			}
			else
			{
				printf("scaling not found\n");
			}
		}
		else
		{
			printf("name tag not found\n");
		}
	}
	else
	{
		printf("model tag not found\n");
	}
}
