#include <stdio.h>
#include "sys/types.h"
#include "LibGTE.h"
#include "LibGPU.h"
#include "LibCD.h"
#include "LibComb.h"
#include "LibEtc.h"
#include "LibGS.h"
#include "LibMath.h"
#include "LibPress.h"
#include "LibSN.h"
#include "LibSnd.h"
#include "LibSPU.h"
#include "moveit.h"
#include <inline_o.h>
#include <gtemac.h>


long				fin,count1,count2,count3;
long				filesize;
long				namelength;
long				notexturedmats;
long				tempanswer;
long				z,d;		/* temp */
long				geomx,geomy;
long				geomscreen;
long				noboundboxes;
char				filebuffer[200000];
char				tidfilebuffer[5000];
char				*tidfileptr;
char				outbuffer[200000];
char 				*fileptr;
char 				*polystartptr;
char				*boundstartptr;
char				mvfilename[21]={'m','o','v','e','f','i','l','e','/',0,0,0,0,0,0,0,0,0,0,0,0 };
char				psxobjname[16]={'p','s','x','/',0,0,0,0,0,0,0,0,0,0,0,0 };

unsigned short		charindex,filecharindex,outcharindex;
unsigned int		textpage,clutpage;
unsigned int		x=255;
unsigned int		y=255;
long				flipvs=0;
long				paddebounced=0;
long				parseend=0;
int					i,j,k;
long				speed;


TIM_IMAGE	timheader;
char		cdres[2];

typedef	struct moveobj
{
	unsigned char	trackno;
	unsigned char	startstrip;
	unsigned char 	endstrip;
	unsigned char	objectno;
	unsigned short	roty;
	unsigned short	flag;
	long			height;
	long			startx;
	long			starty;
	long			startz;
	long			movex;
	long			movey;
	long			movez;
	long			posx;
	long			posy;
	long			posz;
	long			finx;
	long			finy;
	long			finz;
}moveobj;

moveobj	*moveobjptr;
long	totalmovables;
long	checksum;
unsigned char	thistrack;
unsigned char	nomovables;

long				fntid1;
long				fntid2;
long				fntid3;
long				fntid4;
long				fntid5;
long				fntid6;
long				c1,c2;
POLY_F4  			clearsquare[2];
MATRIX				MyLocalLight;
MATRIX				MyColourMatrix;
CVECTOR	    		PrimaryColourVector;
CVECTOR				fc,bc;		/* temp */
DRAWENV				drawenv[2];
DISPENV				dispenv[2];
long				OT[2][4096];
long				*otptr;
long				firstscreendrawn=0;
long				arseexit=0;
long				otid=0;
long				display_id=0;
long				thisotz;
long				thisp;
char				primstr[10]={'f','t','4',20,0,0,0,0,0,0};
long				checksum;
long				issaved=0;
long				checkvalue;
long				tempvz;

/* playstation stuff */


void findchar( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}

long findcheckflagchar( char a )
{
	long found,flagfound;

	found=0;
	flagfound=0;
	while (found==0)
	{
		if ((*fileptr=='f')&&(*(fileptr+1)=='l')&&(*(fileptr+2)=='a'))
		{
			flagfound=1;
		}
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
	return flagfound;
}


char *ptrfindchar( char a, char *p )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*p==a)
		{
			found=1;
		}
		else
		{
			p++;
		}
	}
	return p;
}


long findbackchar( char a )
{
	long found,c;

	found=0;
	c=0;
	while (found==0)
	{
		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr--;
			c++;
		}
	}
	return c;
}

void findcharupeof( char a )
{
	long found;

	found=0;
	while (found==0)
	{
		if (*fileptr=='j')
		{
			if ((*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='c')
		{
			if ((*(fileptr+1)=='u')&&(*(fileptr+2)=='b'))
			{
				found=1;
				fileptr--;
			}
		}
		if (*fileptr=='r')
		{
			if ((*(fileptr+1)=='a')&&(*(fileptr+2)=='d'))
			{
				found=1;
				fileptr--;
			}
		}

		if (*fileptr==a)
		{
			found=1;
		}
		else
		{
			fileptr++;
		}
	}
}

void findnumericalchar( void )
{
	long found;

	found=0;
	while (found==0)
	{
		if (((*fileptr>='0')&&(*fileptr<='9'))||(*fileptr=='-'))
		{
			found=1;
		}
		else
		{
			if ((*fileptr=='j')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='b'))
			{
				parseend=1;
				return;
			}
			if ((*fileptr=='r')&&(*(fileptr+1)=='e')&&(*(fileptr+2)=='m'))
			{
				while (*fileptr!=0x0a)
				{
					fileptr++;
				}
				fileptr++;
			}
			else
			{
			 	fileptr++;
			}
		}
	}
}

void findafterspace( void )
{
	long found;

	found=0;
	while (found==0)
	{
		if ((*fileptr==0x20)&&(*(fileptr+1)!=0x20))
		{
			found=1;
			fileptr++;
		}
		else
		{
			fileptr++;
		}
	}
}

long inttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;
	long negans;

	tenscount=1;
	intans=0;
	negans=0;
	if (*fileptr=='-')
	{
		fileptr++;
		negans=1;
	}
	storeptr=fileptr;
	while ((*fileptr!=0x20)&&(*fileptr!=0x0d)&&(*fileptr!=0x09))
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	if (negans==1)
	{
		intans=-intans;
	}
	return intans/10;
}

long eoltexttoint( char *fileptr )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x0d)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}

long ptrtexttoint( char *fp )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fp;
	tenscount=1;
	intans=0;
	fp++;
	while (*fp!=0x20)
	{
 		tenscount*=10;
 		fp++;
	}
	while (storeptr!=fp)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans;
}


long verttexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,intans;

	storeptr=fileptr;
	tenscount=1;
	intans=0;
	fileptr++;
	while (*fileptr!=0x20)
	{
 		tenscount*=10;
 		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	return intans/10;
}


long floattexttoint( void )
{
	char *storeptr;
	char thischar[2]={0,0};
	long tenscount,gencount,intans;
	long negative=0;

	if (*fileptr=='-')
	{
		negative=1;
		fileptr++;
	}
	storeptr=fileptr;
	tenscount=1000;
	gencount=0;
	intans=0;
	fileptr++;
	while (*fileptr!='.')
	{
		tenscount*=10;
		fileptr++;
	}
	while (storeptr!=fileptr)
	{
		thischar[0]=*storeptr;
		intans+=atoi(&thischar[0])*tenscount;
		tenscount/=10;
		storeptr++;
	}
	fileptr++;
	tenscount=100;
	while (*fileptr!=0x20)
	{
		thischar[0]=*fileptr;
		intans+=atoi(&thischar[0])*tenscount;
		fileptr++;
		tenscount/=10;
	}
	if (negative==1)
	{
		intans=-intans;
	}
	return intans;
}

long	roundit( long a )
{
	a/=100;
	if ((a%10)>4)
	{
		a/=10;
		a++;
	}
	else
	{
		a/=10;
	}
	return a;
}

void getpadshit( void )
{
	long	thisvalue;

	thisvalue=PadRead( 0 );
	thisvalue&=0xffff;
	if (thisvalue==0)
	{
		paddebounced=0;
	}
	if (thisvalue&PADstart)
	{
		arseexit=1;
	}
	if (thisvalue&PADRdown)
	{
		if (issaved==0)
		{
			issaved=1;
		}
	}
}

long savefile(void)
{
	fin	=	PCcreat( &psxobjname, 0 );
	fileptr = &totalmovables;
	checksum=PCwrite(fin,fileptr,4);			/* write numverts */
	fileptr = &outbuffer[0];
	checksum+=PCwrite(fin,fileptr,(60*totalmovables));
	PCclose(fin);
	if (checksum==(4+(60*totalmovables)))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void main ( void )
{

	long	parsefound,vertindex;
	char 	*pointerstore;
	long	*timsizeptr;
	long	timsize;
	long	tempus,tempvs;
	char	*tpageptr;
	long	i,j,k;

	PCinit();
	PadInit(0);
	ResetGraph(0);
//	SetGraphDebug(2);
	InitGeom();
	srand(1);


	fin			=	PCopen( "control.txt", 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );

	/* copy filenames from control file */

	filecharindex=9;
	for (count1=0;count1<12;count1++)
	{
		if (*fileptr!='.')
		{
			mvfilename[filecharindex]=*fileptr;
			fileptr++;
			filecharindex++;
		}
	}
	mvfilename[filecharindex]='.';
	mvfilename[filecharindex+1]='m';
	mvfilename[filecharindex+2]='v';
	mvfilename[filecharindex+3]=0;
	filecharindex=9;
	outcharindex=4;
	while (mvfilename[filecharindex]!='.')
	{
		psxobjname[outcharindex]=mvfilename[filecharindex];
		filecharindex++;
		outcharindex++;
	}
	psxobjname[outcharindex]='.';
	psxobjname[outcharindex+1]='m';
	psxobjname[outcharindex+2]='v';
	psxobjname[outcharindex+3]='t';
	psxobjname[outcharindex+4]=0;

	fin			=	PCopen( &mvfilename, 0, 0 );
	filesize	=	PClseek( fin, 0, 2 );
	PClseek( fin, 0, 0 );
	fileptr		=	&filebuffer;
	PCread( fin, (char *)fileptr, filesize );
	PCclose( fin );
	*(fileptr+filesize)='j';
	*(fileptr+filesize+1)='e';
	*(fileptr+filesize+2)='b';
	/* parse hrc file */
	parseend=0;
	moveobjptr=&outbuffer;
	totalmovables=0;
	while (parseend==0)
	{
		findnumericalchar();
		if (parseend==1)
		{
			break;
		}
		thistrack=inttexttoint();
		findnumericalchar();
		nomovables=inttexttoint();
		for (i=0;i<nomovables;i++)
		{
			moveobjptr->trackno=thistrack;
			findnumericalchar();
			moveobjptr->startstrip=inttexttoint();
			findnumericalchar();
			moveobjptr->objectno=inttexttoint();
			findnumericalchar();
			moveobjptr->startx=inttexttoint();
			findnumericalchar();
			moveobjptr->starty=inttexttoint();
			findnumericalchar();
			moveobjptr->startz=inttexttoint();
			moveobjptr->posx=moveobjptr->startx<<8;
			moveobjptr->posy=moveobjptr->starty<<8;
			moveobjptr->posz=moveobjptr->startz<<8;
			findnumericalchar();
			moveobjptr->endstrip=inttexttoint();
			findnumericalchar();
			moveobjptr->finx=inttexttoint();
			findnumericalchar();
			moveobjptr->finy=inttexttoint();
			findnumericalchar();
			moveobjptr->finz=inttexttoint();
			findnumericalchar();
			moveobjptr->roty=inttexttoint();
			findnumericalchar();
			moveobjptr->flag=inttexttoint();
			findnumericalchar();
			speed=inttexttoint();
//			speed=10;
		    moveobjptr->movex=((moveobjptr->finx-moveobjptr->startx)*256)/speed;
		    moveobjptr->movey=((moveobjptr->finy-moveobjptr->starty)*256)/speed;
	   	    moveobjptr->movez=((moveobjptr->finz-moveobjptr->startz)*256)/speed;
			findnumericalchar();
			moveobjptr->height=inttexttoint();
			moveobjptr++;
			totalmovables++;
		}
	}

	SetDefDrawEnv(&drawenv[0],0,0,320,240);
	SetDefDispEnv(&dispenv[0],0,240,320,240);
	SetDefDrawEnv(&drawenv[1],0,240,320,240);
	SetDefDispEnv(&dispenv[1],0,0,320,240);
	PutDrawEnv(&drawenv[0]);
	PutDispEnv(&dispenv[0]);
	FntLoad(896,0);
	fntid1 = FntOpen(15,15,280,9,1,50);
	SetDumpFnt(fntid1);
	fntid2 = FntOpen(15,24,280,9,1,50);
	SetDumpFnt(fntid2);
	fntid3 = FntOpen(15,33,280,9,1,50);
	SetDumpFnt(fntid3);
	fntid4 = FntOpen(15,42,280,9,1,50);
	SetDumpFnt(fntid4);
	fntid6 = FntOpen(15,51,280,9,1,50);
	SetDumpFnt(fntid6);
	fntid5 = FntOpen(15,60,280,9,1,50);
	SetDumpFnt(fntid5);
	geomx=120;
	geomy=160;
	SetGeomOffset(geomx,geomy);      /* 160,120 */
	geomscreen=340;
	SetGeomScreen( geomscreen );        /* 512 */
	fc.r=0;    /* 148,148,196 */
	fc.g=0;
	fc.b=0;
	z=4000;
	d=800;
	bc.r=200;
	bc.g=200;
	bc.b=200;
	SetFarColor(fc.r,fc.g,fc.b);
	SetFogNear(z,d);
	SetBackColor(bc.r,bc.g,bc.b);
	for (c1=0;c1<2;c1++)
	{
		clearsquare[c1].x0=0;
		clearsquare[c1].x1=320;
		clearsquare[c1].y0=0;
		clearsquare[c1].y1=0;
		clearsquare[c1].x2=0;
		clearsquare[c1].x3=320;
		clearsquare[c1].y2=240;
		clearsquare[c1].y3=240;
		clearsquare[c1].r0=100;           /* 148 */
		clearsquare[c1].g0=100;           /* 148 */
		clearsquare[c1].b0=230;           /* 196 */
	}
	SetLightMatrix(&MyLocalLight);
	SetColorMatrix(&MyColourMatrix);
	PrimaryColourVector.r=128;
	PrimaryColourVector.g=128;
	PrimaryColourVector.b=128;
	while (arseexit==0)
	{
		getpadshit();
		pollhost();
		otptr=&OT[otid][0];
		ClearOTagR(otptr,4096);
		geomx=120; /* 180 */
		geomy=160;
		gte_SetGeomOffset(geomx,geomy);
		gte_SetGeomScreen(geomscreen);                   /* temp */

		SetFarColor(fc.r,fc.g,fc.b);
		SetFogNear(z,d);
		SetBackColor(bc.r,bc.g,bc.b);

		clearsquare[otid].y0=0;
		clearsquare[otid].y1=0;
 		clearsquare[otid].y2=240;
 		clearsquare[otid].y3=240;
		SetPolyF4(&clearsquare[otid]);
		otptr=&OT[otid][4095];
//		otptr=&OT[otid][0];

		AddPrim(otptr,&clearsquare[otid]);

		pollhost();
		DrawSync(0);
		VSync (0);
		FntPrint(fntid1,"MOVEIT ver: %s %s",__DATE__,__TIME__);
		FntFlush(fntid1);
		FntPrint(fntid2,"Finished Parsing %s\n",&mvfilename);
		FntFlush(fntid2);
		FntPrint(fntid3,"Number of movable objects %d ",totalmovables);
		FntFlush(fntid3);
		FntPrint(fntid4,"Press X to save file ");
		FntFlush(fntid4);
		if (issaved==1)
		{
			checkvalue=savefile();
			issaved=2;
		}
		if (issaved==2)
		{
			FntPrint(fntid5,"file %s saved",&psxobjname);
			FntFlush(fntid5);
			if (checkvalue==1)
			{
				FntPrint(fntid6,"file checksum was correct.");
			}
			else
			{
				FntPrint(fntid6,"file checksum was NOT correct.");
			}
			FntFlush(fntid6);
		}
		PutDrawEnv(&drawenv[display_id]);
		PutDispEnv(&dispenv[display_id]);
		otptr=&OT[otid][4095];
		DrawOTag(otptr);
		if (firstscreendrawn==0)
		{
			SetDispMask(1);
			firstscreendrawn=1;
		}
		display_id=(display_id+1)%2;
		otid=(otid+1)%2;
	}

	PadStop();
}
